{$M 7250,100000,655360} {Stack, minheap, maxheap}
PROGRAM bb;

(*===========================================================================*)
(* The main thing                                                            *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

{$R+}    {Range checking on}
{$B-}    {Boolean complete evaluation off}
{$S+}    {Stack checking on}
{$I+}    {I/O checking on}
{$V+}    {String var checks}
{$F+}    {Must have far calls}
{$N-}    {No numeric coprocessor}

USES
  CRT,
  bbdummy,
  bbmisci,
  bboveri,
  bbtask,
  bbtime,
  bbwin,

  (* These procedures are here for overlay purposes only *)

  bbact,
  bbactcmd,
  bbanswer,
  bbauth,
  bbauxm,
  bbbcst,
  bbbid,
  bbbidaux,
  bbbin,
  bbbpa,
  bbbug,
  bbcaptur,
  bbcmf,
  bbcmsg,
  bbconsl,
  bbconv,
  bbconvm,
  bbcopy,
  bbdb1,
  bbdump,
  bbedit,
  bbexdos,
  bbexport,
  bbfin,
  bbfnr,
  bbfsd,
  bbfsf,
  bbfssf,
  bbfsu,
  bbfsw,
  bbfsz,
  bbfu,
  bbfwdc,
  bbfwdp,
  bbfwdr,
  bbfwds,
  bbfwdt,
  bbhelp,
  bbhlook,
  bbimport,
  bbinit,
  bbkmc,
  bblc,
  bblmc,
  bbmark,
  bbmem,
  bbmess,
  bbmf,
  bbmfi,
  bbminit,
  bbmisc,
  bbmisc2,
  bbmisc4,
  bbmisc5,
  bbmmsgn,
  bbmon,
  bbocmd,
  bboprd,
  bboprm,
  bbopro,
  bbopru,
  bbreg,
  bbrmc,
  bbsearch,
  bbsmc,
  bbsrtbpq,
  bbstarl,
  bbsto,
  bbtcmd,
  bbucmd,
  bbuf,
  bbuser,
  bbwakeup,
  bbwp,
  match;

  (* These are directly accessed *)

{$O BBMISCI}

  (* These procedures are here for overlay purposes only *)

{$O BBACT}
{$O BBACTCMD}
{$O BBANSWER}
{$O BBAUTH}
{$O BBAUXM}
{$O BBBCST}
{$O BBBID}
{$O BBBIDAUX}
{$O BBBIN}
{$O BBBPA}
{$O BBBUG}
{$O BBCAPTUR}
{$O BBCMF}
{$O BBCMSG}
{$O BBCONSL}
{$O BBCONV}
{$O BBCONVM}
{$O BBCOPY}
{$O BBDB1}
{$O BBDUMP}
{$O BBEDIT}
{$O BBEXDOS}
{$O BBEXPORT}
{$O BBFIN}
{$O BBFNR}
{$O BBFSD}
{$O BBFSF}
{$O BBFSSF}
{$O BBFSU}
{$O BBFSW}
{$O BBFSZ}
{$O BBFU}
{$O BBFWDC}
{$O BBFWDP}
{$O BBFWDR}
{$O BBFWDS}
{$O BBFWDT}
{$O BBHELP}
{$O BBHLOOK}
{$O BBIMPORT}
{$O BBINIT}
{$O BBKMC}
{$O BBLC}
{$O BBLMC}
{$O BBMARK}
{$O BBMEM}
{$O BBMESS}
{$O BBMF}
{$O BBMFI}
{$O BBMINIT}
{$O BBMISC}
{$O BBMISC2}
{$O BBMISC4}
{$O BBMISC5}
{$O BBMMSGN}
{$O BBMON}
{$O BBOCMD}
{$O BBOPRD}
{$O BBOPRM}
{$O BBOPRO}
{$O BBOPRU}
{$O BBREG}
{$O BBRMC}
{$O BBSEARCH}
{$O BBSMC}
{$O BBSRTBPQ}
{$O BBSTARL}
{$O BBSTO}
{$O BBTCMD}
{$O BBUCMD}
{$O BBUF}
{$O BBUSER}
{$O BBWAKEUP}
{$O BBWP}
{$O MATCH}

{$I BBMAIN.PAS}

(*===========================================================================*)
(* Main program begins here                                                  *)
(*===========================================================================*)

BEGIN;

  (*-------------------------------------------------------------------------*)
  (* Save the current CSEG for debugging                                     *)
  (*-------------------------------------------------------------------------*)

  main_cs := CSEG;

  (*-------------------------------------------------------------------------*)
  (* Get the overlay processor running                                       *)
  (*-------------------------------------------------------------------------*)

  start_up_overlay;

  (*-------------------------------------------------------------------------*)
  (* Initialize                                                              *)
  (*-------------------------------------------------------------------------*)

  main_init;

  (*-------------------------------------------------------------------------*)
  (* Call mainline                                                           *)
  (*-------------------------------------------------------------------------*)

  main;

  (*-------------------------------------------------------------------------*)
  (* Close down                                                              *)
  (*-------------------------------------------------------------------------*)

  main_close;

  HALT;

END.
