(*===========================================================================*)
(* Action command processor                                                  *)
(*                                                                           *)
(*   Copyright 1990, 1991, 1992 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Action command                                                            *)
(*===========================================================================*)

PROCEDURE action_cmd (cmd_string : STRING);

  VAR
    action_char : CHAR;
    action_word : STRING[10];
    word_cnt    : BYTE;

  BEGIN;

    strip_var(cmd_string, 'B');

    action_word := subword(@cmd_string, 1, 1);

    IF LENGTH(action_word) > 2 THEN
      BEGIN;
        send_message(message_err_2nd);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    IF LENGTH(action_word) > 1 THEN
      action_char := UPCASE(action_word[2])
    ELSE
      action_char := ' ';

    CASE action_char OF

      ' ', 'C', 'F', 'L', 'M', #1 : load_action(action_char);

      ELSE
        BEGIN;
          send_message(message_err_2nd);
          active_tcb^.error_sw := TRUE;
          EXIT;
        END;

    END; (*----- End case statement on action_char --------------------------*)

  END;
