(*===========================================================================*)
(* Add a call to monitored list                                              *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Add a monitored call to a port                                            *)
(*===========================================================================*)

PROCEDURE add_mon_call(to_port     : port_block_ptr;
                       port_letter : CHAR;
                       call_add    : bb_addr_str);

  VAR
    d_port   : port_block_ptr;
    i        : BYTE;
    found    : BOOLEAN;

  BEGIN;

    IF opt_block.n_mon = 0 THEN EXIT;

    IF call_add = '' THEN EXIT;

    IF strip_ssid(call_add) = opt_block.this_bb_sign THEN EXIT;

    d_port := @dummy_port;
    IF to_port = d_port THEN
      port_letter := CHR(ORD(port_letter) - ORD('A'));

    WITH to_port^ DO
      BEGIN;

        i     := 0;
        found := FALSE;

        WHILE (i < opt_block.n_mon) AND (NOT found) DO
          BEGIN;
            INC(i);
            WITH to_port^.call_list^[i] DO
              found := call_add = port_call_sign
          END;

        IF NOT found THEN
          i := opt_block.n_mon;

        WHILE i > 1 DO
          BEGIN;
            DEC(i);
            call_list^[i+1] := call_list^[i];
          END;

        WITH call_list^[1] DO
          BEGIN;
            port_call_date := todays_date_time;
            port_call_port := port_letter;
            port_call_sign := call_add;
          END;

      END;

  END;
