(*===========================================================================*)
(* Control Block -- Actions                                                  *)
(*                                                                           *)
(*   Copyright 1990, 1991 by H. Roy Engehausen.  All rights reserved.        *)
(*                                                                           *)
(*===========================================================================*)

(*---------------------------------------------------------------------------*)
(* Length of overhead bytes in action block                                  *)
(*---------------------------------------------------------------------------*)

CONST
  action_msg_overhead = 10;

(*---------------------------------------------------------------------------*)
(* Action block for hold/reject/rename                                       *)
(*---------------------------------------------------------------------------*)

CONST

  action_msg_hold   = $80;        (* Hold message                            *)
  action_msg_reject = $40;        (* Reject message                          *)
  action_msg_change = $20;        (* Change address                          *)
  action_msg_distr  = $10;        (* Set distribution code                   *)
  action_msg_old    = $08;        (* Hold message because its old            *)
  action_msg_deny   = $04;        (* Deny creating new message               *)
  action_msg_review = $02;        (* Put message in review status            *)
  action_msg_invert = $01;        (* Negate the test                         *)

  action_msg_mask   = $FE;        (* Mask to show active bits                *)

TYPE

  action_msg_type = BYTE;

  action_msg_ptr  = ^action_msg;

  action_msg      = RECORD
                      next_action : action_msg_ptr;
                      action_type : action_msg_type;
                      action_srch : search_block_ptr;
                      action_info : STRING;
                    END;
