(*===========================================================================*)
(* Control Block -- Search action                                            *)
(*                                                                           *)
(*   Copyright 1991 by H. Roy Engehausen.  All rights reserved.              *)
(*                                                                           *)
(*===========================================================================*)

  CONST
    search_string_types = 'MUEQS><@%$'; (* These search types have variable  *)
                                        (* length strings.  Note 1 character *)
                                        (* strings are skipped               *)
    search_overhead_length_string = 21;
    search_overhead_length_other  = 24;

  TYPE

    search_block_ptr  = ^search_block_type;

    search_block_type = RECORD
                       search_next       : search_block_ptr;
                       search_direction  : BOOLEAN;(* Direction is important *)
                       search_ascend     : BOOLEAN;(* Do ascending search    *)
                       search_above      : BOOLEAN;(* Match on >=            *)
                       search_nok        : BOOLEAN;(* Ignore K messages      *)
                       search_invert     : BOOLEAN;(* This test is for not   *)
                       search_one_only   : BOOLEAN;(* Search only this msg   *)
                       search_type       : CHAR;
                       search_last       : msg_index_ptr;
                       search_fi         : BYTE;
                       search_mf         : msg_flag_type;
                       search_msg_no     : WORD;
                       CASE BYTE OF
                         0: (search_dt         : LONGINT);
                         1: (search_str        : STRING);
                         2: (search_user_class : user_class_type);
                     END;
