(*===========================================================================*)
(* System constants                                                          *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

CONST

  max_connect_port = 32;                 (* Maximum connects per port        *)
  max_text_l       = 80;                 (* Maximum text bytes without a CR  *)
  max_str_l        = 512;                (* Maximum string length            *)

  tnc_interrupt    = $14;                (* Interrupt for TNC service        *)

  this_bbs_handshake : STRING[16] = '[4RE-02.12-HMR$]';
                                  (* 123456789012345678901234567890          *)
                                  (* Inter BBS handshake                     *)
  this_bbs_version   : STRING[36] = 'AA4RE Version 2.12, March 31st, 1992';
                                  (* 1234567890123456789012345678901234567890*)

  sys_version            = 2;            (* Message file version             *)
  this_bbs_parms : BYTE  = 212;          (* Parm file version                *)

  default_data_color = 2;                (* Default color for data           *)
  default_spec_color = 112;              (* Default color for special        *)
  invisible_color    = 0;                (* Invisible writing                *)

  printer_match : STRING[4] = 'LPT#';    (* Pattern used to detect printers  *)
                                         (* See MATCH for details            *)

  address_dividers : STRING[3] = '.@!';  (* Address dividers for hierarchial *)

  special_max_pac_wp  = 76;              (* Special task max_pac with and    *)
  special_max_pac_wop = 80;              (* without prefix area showing      *)

  log_interval = 1;                      (* Interval at which log is closed  *)
                                         (* in minutes                       *)

  max_languages = 8;                     (* Maximum number of language files *)

(*===========================================================================*)
(* Stack sizes                                                               *)
(*===========================================================================*)

  user_stack_size        : WORD = 12700;
  terminal_stack_size    : WORD = 12000;
  operator_stack_size    : WORD = 12000;
  forward_stack_size     : WORD = 12000;
  forwardsub_stack_size  : WORD = 12210;
  auxilary_stack_size    : WORD = 12200;
  teleaux_stack_size     : WORD = 12000;

(*===========================================================================*)
(* Various maximum lengths                                                   *)
(*===========================================================================*)

  call_sign_len = 6;                     (* Length of an amateur call sign   *)
  ssid_sign_len = 2;
  bb_addr_len   = 10;
  h_addr_len    = 32;
  bid_len       = 12;
  password_len  = 8;
  file_name_len = 80;
  subj_len      = 128;
