(*===========================================================================*)
(* File subsystem -- miscellaneous routines.  Included by various people     *)
(*                                                                           *)
(*   Copyright 1988, 1989 by H. Roy Engehausen.  All rights reserved.        *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*   Permission is explicity granted to use this code as a model for         *)
(*   other programs as long as they carry this copyright notice and the      *)
(*   imbedded copyright constants                                            *)
(*                                                                           *)
(*===========================================================================*)

  FUNCTION find_fsb (look_for : fsb_name_str) : fsb_ptr;

  VAR
    found    : BOOLEAN;
    work_fsb : fsb_ptr;

  BEGIN;

    work_fsb := fsb_base;
    found    := FALSE;

    WHILE (work_fsb <> NIL) AND NOT found DO
      WITH work_fsb^ DO
        BEGIN;
          IF look_for = fsb_name THEN
            found := TRUE
          ELSE
            found := FIND(@fsb_alias, @look_for) <> 0;
          IF NOT found THEN
            work_fsb := next_fsb;
        END;

    find_fsb := work_fsb;

  END;
