(*===========================================================================*)
(* Process path file                                                         *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE do_this_path_part_0(path_common : path_block_ptr);

  VAR
    i : WORD;

  BEGIN;

    WITH path_common^, active_tcb^.path_fe^ DO
      BEGIN;

        (*-------------------------------------------------------------------*)
        (* Open the path file                                                *)
        (*-------------------------------------------------------------------*)

        {$I-}
        RESET(fe_text);
        {$I+}
        i := IORESULT;

        IF i <> 0 THEN
          BEGIN;
            window_write(path_write_p, 'Path file (' + opt_block.path_fn
                                       + ') cannot be opened!');
            window_write(path_write_p, dos_err_message(i));
            EXIT;
          END;

        (*-------------------------------------------------------------------*)
        (* Loop around reading the path file                                 *)
        (*-------------------------------------------------------------------*)

        WHILE ((fwd_command <> 'XSTOP') OR path_rev) AND NOT EOF(fe_text) DO
          BEGIN;

            (*---------------------------------------------------------------*)
            (* Read a line from the path file and uppercase it               *)
            (*---------------------------------------------------------------*)

            READLN(fe_text, path_info);

            upcase_str_var(path_info);

            (*---------------------------------------------------------------*)
            (* Is this a path statement?  If so, then process                *)
            (*---------------------------------------------------------------*)

            IF subword(@path_info, 1, 1) = 'PATH' THEN
              BEGIN;

                task_switch;

                IF words(path_info) < 3 THEN
                  window_write(path_write_p,
                                          'Improper path card : ' + path_info)
                ELSE
                  do_this_path_part_1(path_common);

              END;

            {$IFDEF POINT_CHK}
              task_switch;
            {$ENDIF}

          END; (*----- End loop thru all paths ------------------------------*)

        CLOSE(fe_text);

      END;

  END;
