(*===========================================================================*)
(* Forward task -- Forward loop... Sends the messages                        *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* This is the actual forwarding loop                                        *)
(*===========================================================================*)

PROCEDURE forward_loop(path_common : path_block_ptr);

  VAR
    msg_index : BYTE;
    this_one  : msg_pi_ptr;

  BEGIN;

    {$IFDEF DEBUG_PORT}
      trace_data('SL 1', 0, active_port, '');
    {$ENDIF}

    (*-----------------------------------------------------------------------*)
    (* Sort the messages into the right order                                *)
    (*-----------------------------------------------------------------------*)

    sort_path_array(path_common);

    {$IFDEF DEBUG_PORT}
      trace_data('SL 2', 0, active_port, '');
    {$ENDIF}

    (*-----------------------------------------------------------------------*)
    (* Signal that not all were processed                                    *)
    (*-----------------------------------------------------------------------*)

    path_common^.path_did_all := FALSE;

    (*-----------------------------------------------------------------------*)
    (* Loop while we have any messages to process                            *)
    (*-----------------------------------------------------------------------*)

    FOR msg_index := 1 TO path_common^.path_msg_count DO
      BEGIN;
        this_one := @path_common^.path_msg_list^[msg_index];

        IF this_one^.msg_p_i <> NIL THEN
          forward_this_one(path_common, this_one);
      END;

    {$IFDEF DEBUG_PORT}
      trace_data('SL 3', 0, active_port, '');
    {$ENDIF}

    (*-----------------------------------------------------------------------*)
    (* Signal that all were processed                                        *)
    (*-----------------------------------------------------------------------*)

    path_common^.path_did_all := TRUE;

  END; (*----- End forward loop procedure -----------------------------------*)
