(*===========================================================================*)
(* Find_call + extract_call                                                  *)
(*                                                                           *)
(*   Copyright 1988, 1989 by H. Roy Engehausen.  All rights reserved.        *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE find_call;
  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Locate position of userid in message                                  *)
    (*-----------------------------------------------------------------------*)

    IF (work2_str = t_to_h_ct) THEN
      i := 3
    ELSE
      i := 4;

    t1_str := subword(@active_tcb^.tnc_data.str_data, i, 1);

    (*-----------------------------------------------------------------------*)
    (* If DRSI card then remove the port identifier                          *)
    (*-----------------------------------------------------------------------*)

    IF active_port^.port_type = port_pcpa THEN
      BEGIN;
        pcpa_port := t1_str[1];
        t1_str := substr(t1_str, 3, 0);
      END
    ELSE
      pcpa_port := CHR(0);

  END;

PROCEDURE extract_call;
  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Extract userid/ssid                                                   *)
    (*-----------------------------------------------------------------------*)

    i := POS('-', t1_str);

    WITH active_tcb^ DO
      BEGIN;

        IF i = 0 THEN
          BEGIN;
            connect_call := t1_str;
            connect_ssid := '';
          END
        ELSE
          BEGIN;
            IF i > 1 THEN
              connect_call := SUBSTR(t1_str, 1, i - 1)
            ELSE
              connect_call := 'NONE';
            connect_ssid := SUBSTR(t1_str, i+1, SIZEOF(connect_ssid)-1);
          END;

        tcb_name := t1_str;

      END;

  END;
