(*===========================================================================*)
(* Log file                                                                  *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1992  by H. Roy Engehausen.  All rights     *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

UNIT BBLOG;

INTERFACE

  USES
    DOS,
    bbdummy,
    bbtime;

  PROCEDURE log_data_s(event : STRING);
  PROCEDURE log_data_is(number : LONGINT; event : STRING);

  VAR

    log_dow  : BYTE;
    log_file : TEXT;
    log_time : LONGINT;
    log_type : CHAR;

  CONST
    log_update = 11 * ticks_per_min;

IMPLEMENTATION

(*===========================================================================*)
(* Log a data string                                                         *)
(*===========================================================================*)

PROCEDURE log_data_s(event : STRING);
  VAR
    c : CHAR;

  BEGIN;

    IF log_type = 'N' THEN EXIT;

    c := byte_to_char[active_tcb^.tcb_number];

    WRITELN(log_file, todays_date_time, c, event);

  END;

(*===========================================================================*)
(* Log a data string with number                                             *)
(*===========================================================================*)

PROCEDURE log_data_is(number : LONGINT; event : STRING);
  VAR
    c : CHAR;
    s : STRING[10];

  BEGIN;

    IF log_type = 'N' THEN EXIT;

    c := byte_to_char[active_tcb^.tcb_number];

    STR(number, s);

    WRITELN(log_file, todays_date_time, c, s, ':', event);

  END;

END.
