(*===========================================================================*)
(* Message Control Blocks and data                                           *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

UNIT BBMDATA;

  INTERFACE

    USES bbdummy;

    {$I BBMEQU.PAS}

    (*-----------------------------------------------------------------------*)
    (* Queue element - These make up the message queue                       *)
    (*-----------------------------------------------------------------------*)

    TYPE

         qe_ptr = ^qe;

         qe = RECORD
                 qe_next     : qe_ptr;      (* Pointer to next QE in chain       *)
                 qe_file_type: BOOLEAN;     (* Is this a file?                   *)
                 qe_data     : STRING;      (* Data string                       *)
               END;

    CONST
         qe_overhead = 6;                   (* Overhead bytes excpt for act data *)

    (*-----------------------------------------------------------------------*)
    (* Message array                                                         *)
    (*-----------------------------------------------------------------------*)

    TYPE
         mess_list_ptr = ^mess_list;
         mess_list     = RECORD
                           mess_next  : mess_list_ptr;
                           mess_this  : qe_ptr;
                           mess_off   : LONGINT;
                           mess_lang  : BYTE;
                           mess_class : user_class_type
                         END;

    VAR
      message_array : ARRAY[1..max_message] OF mess_list_ptr;

  IMPLEMENTATION

END.
