(*===========================================================================*)
(* Message equates                                                           *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

CONST
  max_message              = 182;        (* Highest message number           *)

  message_unknown_cmd      = 1;          (* Unknown command                  *)
  message_signon           = 2;          (* Sign on message                  *)
  message_action_complete  = 3;          (* Action complete                  *)
  message_info             = 4;          (* Info 'I' message                 *)
  message_prompt           = 5;          (* Prompt                           *)
  message_smc_subj         = 6;          (* Send Message Subject             *)
  message_smc_text         = 7;          (* Send Message Text                *)
  message_smc_to           = 8;          (* Send Message To                  *)
  message_err_ivm          = 9;          (* Invalid message number           *)
                                         (*      Also see _err_ivm_wp        *)
  message_rmc_num          = 10;         (* Read what message                *)
  message_err_wrd          = 11;         (* Too many words in command        *)
  message_err_2nd          = 12;         (* Bad qualifier                    *)
  message_msg_head1        = 13;         (* Message Header -- format 1       *)
  message_err_lmcc         = 14;         (* "L" command criteria missing     *)
  message_lmc_nf           = 15;         (* No message matches -- Search     *)
  message_rmc_nf           = 16;         (* No message matches -- Read       *)
                                         (*      Also see _rmf_nf_wp         *)
  message_rmc_mnf          = 17;         (* No message matches -- Read       *)
  message_kmc_nf           = 18;         (* No message matches -- Kill       *)
  message_addr_fmt         = 19;         (* Bad address format               *)
  message_killed_msg       = 20;         (* Yes.. We killed a message        *)
  message_kmc_num          = 21;         (* Kill what message                *)
  message_nodata_can       = 22;         (* No data supplied, cmd cancel     *)
  message_added_msg        = 23;         (* Added message                    *)
  message_fwd_head         = 24;         (* Forward header                   *)
  message_u_not_fnd        = 25;         (* User not found                   *)
  message_unread           = 26;         (* Unread mail waiting              *)
  message_eu               = 27;         (* Edit user prompt                 *)
  message_em               = 28;         (* Edit msg prompt                  *)
  message_user_head        = 29;         (* User listing header              *)
  message_to_noact         = 30;         (* Time out for no activity         *)
  message_bad_task         = 31;         (* Invalid taskid                   *)
  message_task_nf          = 32;         (* Task not found                   *)
  message_user_name        = 33;         (* Enter name                       *)
  message_user_zip         = 34;         (* Enter zip                        *)
  message_user_home        = 35;         (* Enter home zip code              *)
  message_too_long         = 36;         (* Data too long                    *)
  message_reg_ok           = 37;         (* Registration is done             *)
  message_fn_bad           = 38;         (* Invalid fileid                   *)
  message_2nd_bad          = 39;         (* Second operand is bad            *)
  message_bad_date         = 40;         (* Invalid date                     *)
  message_not_en           = 41;         (* Not enough operands              *)
  message_kill_not_a       = 42;         (* Kill not allowed                 *)
  message_help_nf          = 43;         (* Help not found                   *)
  message_mode_switch      = 44;         (* Mode changed                     *)
  message_bcst             = 45;         (* Broadcast message                *)
  message_dupe_bid         = 46;         (* Bid is duplicate                 *)
  message_not_on_port      = 47;         (* Not allowed to use port          *)
  message_direct_head      = 48;         (* Directory heading                *)
  message_direct_alias     = 49;         (* Directory alias                  *)
  message_no_files_all     = 50;         (* No files for this guy            *)
  message_no_files_one     = 51;         (* This guy can't have this file    *)
  message_no_slash         = 52;         (* \ not allowed                    *)
  message_file_saved       = 53;         (* File saved                       *)
  message_file_exists      = 54;         (* File already exists              *)
  message_file_no_exist    = 55;         (* File cannot be found             *)
  message_k_already        = 56;         (* Killed already                   *)
  message_j_list_end       = 57;         (* Last items on JLIST              *)
  message_o_talk_to_u      = 58;         (* Connect to operator              *)
  message_bbs_mode         = 59;         (* BBS mode returns                 *)
  message_waiting_for_op   = 60;         (* Wait for op to answer            *)
  message_wait_cancel      = 61;         (* Wait cancelled                   *)
  message_wait_no_sysop    = 62;         (* No SYSOP answered page           *)
  message_sysop_not_in     = 63;         (* SYSOP not in                     *)
  message_msg_head0        = 64;         (* Message Header -- format 0       *)
  message_user_msg_fmt     = 65;         (* Enter msg format                 *)
  message_bad_number       = 66;         (* Invalid number format            *)
  message_msg_from         = 67;         (* From:                            *)
  message_msg_to           = 68;         (* To:                              *)
  message_msg_date         = 69;         (* Date:                            *)
  message_msg_msgid        = 70;         (* Msgid:                           *)
  message_msg_subj         = 71;         (* Subj:                            *)
  message_msg_path         = 72;         (* Path:                            *)
  message_no_wild          = 73;         (* No wild cards please             *)
  message_send_the_file    = 74;         (* Send the file now                *)
  message_goodbye          = 75;         (* Goodbye message                  *)
  message_op_complete      = 76;         (* Operation complete               *)
  message_smc_type         = 77;         (* Get message type                 *)
  message_smc_type_bad     = 78;         (* Bad type                         *)
  message_overlay_busy     = 79;         (* Overlay busy                     *)
  message_other_active     = 80;         (* Other tasks are active           *)
  message_err_ivm_wp       = 81;         (* Similar to err_ivm but with parm *)
  message_rmc_nf_wp        = 82;         (* Similar to rmc_nf but with parm  *)
  message_op_halted        = 83;         (* Operation halted                 *)
  message_mail_for         = 84;         (* Mail for part of broadcast       *)
  message_start_bin        = 85;         (* Start binary transfer            *)
  message_bin_started      = 86;         (* Binary Xfer started              *)
  message_bin_done         = 87;         (* Same message for done!           *)
  message_bin_abort_out    = 88;         (* Binary abort send                *)
  message_bin_abort_in     = 89;         (* Binary abort received            *)
  message_bin_time_out     = 90;         (* Binary time out                  *)
  message_bin_proto_err    = 91;         (* Binary protocol error            *)
  message_bin_hdr          = 92;         (* Yapp file header                 *)
  message_no_binary        = 93;         (* Binary file xfer not allowed     *)
  message_need_conv        = 94;         (* Need conv task                   *)
  message_enter_uid        = 95;         (* Enter userid                     *)
  message_enter_password   = 96;         (* Enter password                   *)
  message_password_bad     = 97;         (* Password bad                     *)
  message_jn_out_fwd       = 98;         (* Outbound forward                 *)
  message_jn_cip           = 99;         (* Connect in progress              *)
  message_jn_st            = 100;        (* Special task                     *)
  message_jn_in_fwd        = 101;        (* Inbound forward                  *)
  message_jn_r_fwd         = 102;        (* Reverse forward                  *)
  message_jn_t_sysop       = 103;        (* Talking to SYSOP                 *)
  message_jn_no_users      = 104;        (* No users on system               *)
  message_mtype_p          = 105;        (* "Private message"                *)
  message_mtype_b          = 106;        (* "Bulletin"                       *)
  message_mtype_t          = 107;        (* "Traffic"                        *)
  message_mtype_s          = 108;        (* "Service message"                *)
  message_mtype_other      = 109;        (* "Message"                        *)
  message_what_reply       = 110;        (* What message to reply to?        *)
  message_signon_modem     = 111;        (* Modem sign on message            *)
  message_bad_bin          = 112;        (* Bad binary download type         *)
  message_bin_bad_blkno    = 113;        (* Bad binary block number          *)
  message_bin_bad_block    = 114;        (* Bad binary block                 *)
  message_reply_prefix     = 115;        (* Reply prefix                     *)
  message_trail            = 116;        (* Trail message                    *)
  message_rfwd_done        = 117;        (* Reverse forward done             *)
  message_confirm_pls      = 118;        (* Confirm operation                *)
  message_sw_on            = 119;        (* Switch is now on                 *)
  message_sw_off           = 120;        (* Switch is now off                *)
  message_bad_change_file  = 121;        (* Bad name of file to change       *)
  message_reregister       = 122;        (* Reregister message               *)
  message_reason_olddate   = 123;        (* Reason because of old date       *)
  message_reason_dupbid    = 124;        (* Reason because of duplicate bid  *)
  message_reason_loop      = 125;        (* Reason because of loop           *)
  message_reason_opr       = 126;        (* Reason because of operator       *)
  message_reason_reject    = 127;        (* Reason because of reject         *)
  message_alt_header       = 128;        (* Alternate header                 *)
  message_user_scrl        = 129;        (* Get user screen length           *)
  message_e_mode_switch    = 130;        (* Switch call sign in emergency?   *)
  message_more_prompt      = 131;        (* MORE?                            *)
  message_user_scrw        = 132;        (* Get user screen width            *)
  message_user_scr_disp    = 133;        (* Display screen info              *)
  message_not_accept_nts   = 134;        (* Not accepting NTS right now      *)
  message_smc_type_emer    = 135;        (* Emergency mode version of 77     *)
  message_disk_space       = 136;        (* Disk space                       *)
  message_unknown_edit     = 137;        (* Unknown edit command             *)
  message_bad_search       = 138;        (* Bad search arguement             *)
  message_reason_hold      = 139;        (* Reason because of hold action    *)
  message_rejected         = 140;        (* Reject message #0                *)
  message_rejected_1       = 141;        (* Reject message #1                *)
  message_rejected_2       = 142;        (* Reject message #2                *)
  message_rejected_3       = 143;        (* Reject message #3                *)
  message_rejected_4       = 144;        (* Reject message #4                *)
  message_rejected_5       = 145;        (* Reject message #5                *)
  message_rejected_6       = 146;        (* Reject message #6                *)
  message_rejected_7       = 147;        (* Reject message #7                *)
  message_rejected_8       = 148;        (* Reject message #8                *)
  message_rejected_9       = 149;        (* Reject message #9                *)
  message_reason_shouldr   = 150;        (* Reason = should have been reject *)
  message_user_lang        = 151;        (* Prompt for user language         *)
  message_invalid_select   = 152;        (* Invalid selection                *)
  message_more_done        = 153;        (* Ready to proceed from more       *)
  message_nosubj           = 154;        (* Missing subject                  *)
  message_flag_change      = 155;        (* Flagged changed for message      *)
  message_review           = 156;        (* Message held for review          *)
  message_drop_e_mode      = 157;        (* Emergency mode drop              *)
  message_bad_access_send  = 158;        (* Send command disallowed          *)
  message_bad_access       = 159;        (* Access disallowed                *)
  message_review_prompt    = 160;        (* Review prompt                    *)
  message_no_change        = 161;        (* Review prompt                    *)
  message_auth_complete    = 162;        (* Authentication complete          *)
  message_auth_incomplete  = 163;        (* Authentication not complete      *)
  message_dos_ex_file_nf   = 164;        (* DOS file not found               *)
  message_bad_review_actn  = 165;        (* Bad review action                *)
  message_reason_review_h  = 166;        (* Operator selected hold from revie*)
  message_port_conn_off    = 167;        (* Operator says no connects        *)
  message_msg_head2        = 168;        (* Message Header -- format 2       *)
  message_at_bbs_set       = 169;        (* @BBS field set                   *)
  message_send_auth_fail   = 170;        (* Send authenication failed        *)
  message_command_not_perm = 171;        (* This command not permitted       *)
  message_bad_call         = 172;        (* Bad call sign                    *)
  message_cmd_restrict     = 173;        (* Command restricted               *)
  message_must_register    = 174;        (* You must register                *)
  message_no_db            = 175;        (* This database is not enabled     *)
  message_no_db_record     = 176;        (* Record not found for $1          *)
  message_output_fmt_msg   = 177;        (* Optional output format #4        *)
  message_msg_head3        = 178;        (* Message Header -- format 3       *)
  message_msg_head4        = 179;        (* Message Header -- format 4       *)
  message_unkill_read      = 180;        (* Message Header -- format 4       *)
  message_routed_to        = 181;        (* Message routed to                *)
  message_l_pause          = 182;        (* "L" pause query                  *)

