(*===========================================================================*)
(* Handle msg files                                                          *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

{$O+}

{$DEFINE POINT_CHK}
{$UNDEF  DEBUG_DIST}  (* WARNING -- hooks in BBMF2 & BBMF5  *)

UNIT BBMF;

INTERFACE

  USES
    bbdummy;

  VAR
    dis_area          : msg_d_ptr;
    msg_file          : FILE OF msg_block;
    next_msg_no       : WORD;
    next_record_no    : WORD;

  (*----- In MF1 -----*)
  FUNCTION  find_msg         (msg_no : WORD)    : msg_index_ptr;
  FUNCTION  find_dist_list   (i_ptr  : msg_index_ptr) : msg_d_ptr;

  (*----- In MF2 -----*)
  PROCEDURE add_msg          (fileid : STRING; pass_dupe_bid : BOOLEAN);
  PROCEDURE update_msg       (i_ptr  : msg_index_ptr);

  (*----- In MF3 -----*)
  PROCEDURE search_msg       (search : search_block_ptr);

  (*----- In MF4 -----*)
  FUNCTION header_msg_block(i_ptr : msg_index_ptr; type_fmt : INTEGER) : STRING;
  FUNCTION msg_flag_char     (msg_flag : msg_flag_type) : CHAR;

  (*----- In MF5 -----*)
  FUNCTION  check_hidden     (i_ptr  : msg_index_ptr): BOOLEAN;
  PROCEDURE count_msg_list;
  FUNCTION  verify_auth_list(in_str : str_ptr; who : call_sign_str) : BOOLEAN;

  (*----- In MF6 -----*)
  PROCEDURE mark_as_forwarded (i_ptr         : msg_index_ptr;
                               dis_number    : BYTE;
                               response_char : CHAR);


IMPLEMENTATION

  USES
    CRT,
    bbbid,
    bbdump,
    bbmdata,
    bbmem,
    bbmess,
    bbmisc,
    bbmisc2,
    bbmisc3,
    bbrunerr,
    bbsearch,
    bbsema2,
    bbstr,
    bbtask,
    bbtrace,
    bbtime,
    bbwin,
    match;

(*===========================================================================*)
(* This is the global routines                                               *)
(*===========================================================================*)

(*--- in MF5 ---*)

PROCEDURE build_dis(msg_to_do : msg_index_ptr;
                    dis_file_name : file_name_str); FORWARD;

(*===========================================================================*)
(* This is global static variables                                           *)
(*===========================================================================*)

CONST
  dont_fwd_flags       : msg_flag_type = mf_hold
                                         OR mf_read
                                         OR mf_fwd
                                         OR mf_fwd_select
                                         OR mf_kill
                                         OR mf_review;

  not_read_flags       : msg_flag_type = mf_hold
                                         OR mf_read
                                         OR mf_fwd
                                         OR mf_fwd_select
                                         OR mf_kill
                                         OR mf_review;

VAR
  msg_ptr           : msg_block_ptr;
  n_list            : msg_index_ptr;

(*===========================================================================*)
(* Include all the real code                                                 *)
(*===========================================================================*)

{$I BBMF1.PAS}                            (* Find                            *)
{$I BBMF2.PAS}                            (* Add/Update                      *)
{$I BBMF3.PAS}                            (* Search                          *)
{$I BBMF4.PAS}                            (* Display                         *)
{$I BBMF5.PAS}                            (* Miscellaneous                   *)
{$I BBMF6.PAS}                            (* Miscellaneous #2                *)

END.
