(*===========================================================================*)
(* Miscellaneous things - 4                                                  *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

{$UNDEF DEBUG_1} (* Debug command sending *)

{$O+}

UNIT BBMISC4;

INTERFACE

  USES bbdummy;

  PROCEDURE flushdosfile (f : POINTER);
  PROCEDURE oper_force   (cmd_string     : STRING);
  FUNCTION  find_tcb     (tcb_id : str2) : tcb_ptr;
  PROCEDURE force_tcb    (force_this_tcb : tcb_ptr);

IMPLEMENTATION

  USES
    DOS,
    bbmdata,
    bbmess,
    bbsdata,
    bbsess,
    bbstr,
    bbtask,
    bbwin;

(*===========================================================================*)
(* Flush a DOS file                                                          *)
(*===========================================================================*)

PROCEDURE flushdosfile(f : POINTER);

  VAR
    regs         : REGISTERS;

  BEGIN;

    regs.AH := $45;
    regs.BX := FILEREC(f^).handle;
    MSDOS(regs);
    IF (regs.FLAGS AND FCARRY) <> 0 THEN
      BEGIN;
        WRITELN('Err clone handle=', regs.AX);
        EXIT;
      END;

    regs.BX := regs.AX;
    regs.AH := $3E;
    MSDOS(regs);

    IF (regs.FLAGS AND FCARRY) = 0 THEN
      EXIT;

    WRITELN('Err close handle=', regs.AX);
    EXIT;

  END;

(*===========================================================================*)
(* Force a disconnect on a task                                              *)
(*===========================================================================*)

PROCEDURE oper_force(cmd_string : STRING);

  {$UNDEF DEBUG_KILL}

  VAR
    force_this_tcb : tcb_ptr;
    found          : BOOLEAN;
    i              : BYTE;
    kill_sw        : BOOLEAN;
    save_c         : BYTE;
    save_port      : port_block_ptr;

  BEGIN;

    upcase_str_var(cmd_string);

    i := WORDS(cmd_string);

    IF i <> 2 THEN
      BEGIN;
        send_message(message_err_wrd);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    kill_sw := find(@cmd_string, @kill_word) > 0;

    {$IFDEF DEBUG_KILL}
      WRITELN('Kill = ', kill_sw);
    {$ENDIF}

    cmd_string := subword(@cmd_string, 2, 1);
    upcase_str_var(cmd_string);
    IF LENGTH(cmd_string) <> 2 THEN
      BEGIN;
        send_message(message_bad_task);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    force_this_tcb := find_tcb(cmd_string);

    IF force_this_tcb = NIL THEN
      BEGIN;
        send_message(message_task_nf);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    force_tcb(force_this_tcb);

    IF kill_sw THEN
      BEGIN;
        task_wait(5, FALSE);
        {$IFDEF DEBUG_KILL}
          WRITELN('Destroy');
        {$ENDIF}
        task_destroy(force_this_tcb);
      END;

  END;

(*===========================================================================*)
(* Find a TCB                                                                *)
(*===========================================================================*)

FUNCTION find_tcb (tcb_id : str2) : tcb_ptr;

  VAR
    look_tcb  : tcb_ptr;

  BEGIN;

    look_tcb := active_tcb;

    WHILE look_tcb^.next_tcb <> active_tcb DO
      BEGIN;
        look_tcb := look_tcb^.next_tcb;
        WITH look_tcb^ DO
          IF (port_chan_s = tcb_id) AND NOT tcb_ignore_port_chan THEN
            BEGIN;
              find_tcb := look_tcb;
              EXIT;
            END
      END;

    find_tcb := NIL;

  END;

(*===========================================================================*)
(* Force a disconnect on a task using tcb_ptr                                *)
(*===========================================================================*)

PROCEDURE force_tcb (force_this_tcb : tcb_ptr);
  VAR
    i         : BYTE;
    save_c    : BYTE;
    save_port : port_block_ptr;
    t         : STRING;

  BEGIN;

    force_this_tcb^.tcb_dead_in_progress := TRUE;
    force_this_tcb^.tcb_ignore_lc        := FALSE;

    WITH active_tcb^ DO
      BEGIN;

        save_port    := active_port;
        save_c       := channel;
        active_port  := force_this_tcb^.tcb_port;
        channel      := force_this_tcb^.channel;
        tcb_port     := active_port;

        cmd_tnc(@disc_cmd, TRUE);

        active_port  := save_port;
        tcb_port     := active_port;
        channel      := save_c;

      END;

    IF NOT active_tcb^.tnc_null THEN
      BEGIN;

        WITH force_this_tcb^ DO
          BEGIN;

            IF force_this_tcb <> active_tcb THEN
              BEGIN;
                tcb_stop_tnc_io := TRUE;
                IF (tcb_port^.port_type <> port_modem)
                               OR (tcb_port^.port_type <> port_null_modem) THEN
                  save_c := 2
                ELSE
                  save_c := 5;
                task_wait(save_c, FALSE)
              END;

            save_port := tcb_port;
            save_c    := channel;
            save_port^.connected^[save_c] := NIL;
          END;

        task_destroy(force_this_tcb);

        EXIT;

      END;

  END;

END.
