(*===========================================================================*)
(* Miscellaneous things - 5                                                  *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

{$O+}

UNIT BBMISC5;

INTERFACE

  USES bbdummy;

  FUNCTION  display_access_block(in_acc : access_block_type) : str8;
  FUNCTION  dos_err_message (i : INTEGER) : STRING;
  PROCEDURE gc;

IMPLEMENTATION

  USES
    bbsrt,
    bbstr,
    bbwin;

(*===========================================================================*)
(* Display an access control block                                           *)
(*===========================================================================*)

FUNCTION display_access_block(in_acc : access_block_type) : str8;
  VAR
    s : str8;
  BEGIN;
    s := '';
    IF (in_acc.access_flags AND access_f_user     ) <> 0 THEN
      s := s + 'A';
    IF (in_acc.access_flags AND access_f_user_send) <> 0 THEN
      s := s + 'S';
    IF (in_acc.access_flags AND access_f_sysop    ) <> 0 THEN
      s := s + 'R';
    IF (in_acc.access_flags AND access_f_bbs      ) <> 0 THEN
      s := s + 'B';

    display_access_block := s;

  END;

(*===========================================================================*)
(* Routine called to produce a dos error message                             *)
(*===========================================================================*)

FUNCTION dos_err_message(i : INTEGER) : STRING;

  VAR
    f   : TEXT;
    j   : INTEGER;
    k   : INTEGER;
    l   : STRING;

  BEGIN;

    ASSIGN(f, opt_block.dos_mess_fn);
    {$I-}
    RESET(f);
    j := IORESULT;
    {$I+}

    IF j <> 0 THEN
      BEGIN;
        STR(i, l);
        dos_err_message := 'I/O error #' + l;
        EXIT;
      END;

    WHILE NOT EOF(f) DO
      BEGIN;
        READLN(f, l);

        VAL(subword(@l, 1, 1), j, k);

        IF (i = j) AND (k = 0) THEN
          BEGIN;
            dos_err_message := subword(@l, 2, 0);
            CLOSE(f);
            EXIT;
          END;
      END;

    STR(i, l);

    dos_err_message := 'DOS Error #' + l;

    CLOSE(f);

  END;

(*===========================================================================*)
(* Garbage collector                                                         *)
(*===========================================================================*)

PROCEDURE gc;

  VAR
    p : STRING[4];
    s : STRING;

  BEGIN;

    p := active_tcb^.port_chan_s + 'G:';

    s := garbage_collect_tnc;
    WHILE s <> '' DO
      BEGIN;
        window_write(p, s);
        s := garbage_collect_tnc;
      END;

  END;

END.
