(*===========================================================================*)
(* Operator task -- Display things                                           *)
(*                                                                           *)
(*   Copyright 1991 by H. Roy Engehausen.  All rights reserved.              *)
(*                                                                           *)
(*===========================================================================*)

{$O+}

UNIT BBOPRD;

INTERFACE

  PROCEDURE oper_dm    (cmd_in : STRING);
  PROCEDURE disp_route (cmd_in : STRING);

IMPLEMENTATION

  USES
    CRT,
    DOS,
    bbdummy,
    bbfnr,
    bbmdata,
    bbmess,
    bbmf,
    bbmisc,
    bbmisc2,
    bbmisc5,
    bbmmsgn,
    bbsdata,
    bbsearch,
    bbstr,
    match;

  {$I BBOPRDR.PAS}

  (*=========================================================================*)
  (* Display message routing info                                            *)
  (*=========================================================================*)

  PROCEDURE oper_dm (cmd_in : STRING);

    VAR
      cmd_char     : CHAR;
      d_msg_no     : WORD;
      i_ptr        : msg_index_ptr;
      search_block : search_block_type;
      word_cnt     : BYTE;


    PROCEDURE dm_a_msg(p : msg_index_ptr);
      BEGIN;
      END;

    BEGIN;

      word_cnt := WORDS(cmd_in);

      IF LENGTH(cmd_in) = 1 THEN
        cmd_char := ' '
      ELSE
        cmd_char := UPCASE(cmd_in[2]);

      (*---------------------------------------------------------------------*)
      (* Select right code                                                   *)
      (*---------------------------------------------------------------------*)

      CASE cmd_char OF

        (*-------------------------------------------------------------------*)
        (* " "                                                               *)
        (*-------------------------------------------------------------------*)

        ' ': BEGIN;

               (*------------------------------------------------------------*)
               (* Handle DM without a number                                 *)
               (*------------------------------------------------------------*)

               IF word_cnt = 1 THEN
                 BEGIN;

                   (*--------------------------------------------------------*)
                   (* Give error                                             *)
                   (*--------------------------------------------------------*)

                   send_message(message_err_wrd);
                   active_tcb^.error_sw := TRUE;
                   EXIT;

                 END;

               (*------------------------------------------------------------*)
               (* Validate number                                            *)
               (*------------------------------------------------------------*)

               upcase_str_var(cmd_in);

               check_multiple_msg(@cmd_in, 2, word_cnt);
               IF active_tcb^.error_sw THEN
                 EXIT;

               (*------------------------------------------------------------*)
               (* Loop thru all the messages                                 *)
               (*------------------------------------------------------------*)

               d_msg_no := get_next_multiple_msg;

               WHILE d_msg_no <> 0 DO
                 BEGIN;

                   (*--------------------------------------------------------*)
                   (* Find message,  Give error if cannot be found           *)
                   (*--------------------------------------------------------*)

                   i_ptr := find_msg(d_msg_no);

                   IF i_ptr = NIL THEN
                     BEGIN;
                       send_message(message_rmc_nf);
                       IF NOT in_multiple_msg_range THEN
                         EXIT;
                     END;

                   dm_a_msg(i_ptr);

                   (*--------------------------------------------------------*)
                   (* Get next message to display                            *)
                   (*--------------------------------------------------------*)

                   d_msg_no := get_next_multiple_msg;

                 END; (*----- End loop thru all messages --------------------*)

             END;

        (*-------------------------------------------------------------------*)
        (* All other letters                                                 *)
        (*-------------------------------------------------------------------*)

        ELSE
          BEGIN;

            (*---------------------------------------------------------------*)
            (* Build search block                                            *)
            (*---------------------------------------------------------------*)

            cmd_in := COPY(cmd_in, 2, 255);
            set_search(cmd_in, @search_block);

            IF active_tcb^.error_sw THEN
              EXIT;

            (*---------------------------------------------------------------*)
            (* Find first one                                                *)
            (*---------------------------------------------------------------*)

            search_msg(@search_block);

            IF search_block.search_last = NIL THEN
              BEGIN;
                send_message(message_lmc_nf);
                active_tcb^.error_sw := TRUE;
                EXIT;
              END;

            (*---------------------------------------------------------------*)
            (* Loop displaying things                                        *)
            (*---------------------------------------------------------------*)

            REPEAT
              dm_a_msg(search_block.search_last);
              search_msg(@search_block);
            UNTIL search_block.search_last = NIL;

          END;

      END;

    END;

END.
