(*===========================================================================*)
(* Change file name                                                          *)
(*                                                                           *)
(*   Copyright 1989, 1990, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE file_name_change(cmd_string: STRING);

  VAR
    f : file_name_str;
    i : INTEGER;
    p : ^file_name_str;
    s : STRING[12];

  PROCEDURE select_fn;
    BEGIN;

      IF s = 'PATH' THEN
        BEGIN;
          p := @opt_block.path_fn;
          EXIT;
        END;

      IF s = 'ROUTE' THEN
        BEGIN;
          p := @opt_block.route_fn;
          EXIT;
        END;

      IF s = 'MESSAGE' THEN
        BEGIN;
          p := @opt_block.mess_fn;
          EXIT;
        END;

      IF s = 'HELP' THEN
        BEGIN;
          p := @opt_block.help_fn;
          EXIT;
        END;

      IF s = 'WAKEUP' THEN
        BEGIN;
          p := @opt_block.wakeup_fn;
          EXIT;
        END;

      IF s = 'HLOOKUP' THEN
        BEGIN;
          p := @opt_block.hlook_fn;
          EXIT;
        END;

      IF s = 'PASSWORD' THEN
        BEGIN;
          p := @opt_block.passwd_fn;
          EXIT;
        END;

      IF s = 'ACTION' THEN
        BEGIN;
          p := @opt_block.action_fn;
          EXIT;
        END;

      p := NIL;

    END;

  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Parse command and execute right routine                               *)
    (*-----------------------------------------------------------------------*)

    upcase_str_var(cmd_string);

    i := words(cmd_string);

    IF i < 3 THEN
      BEGIN;
        send_message(message_not_en);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    IF i > 3 THEN
      BEGIN;
        send_message(message_err_wrd);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    s := subword(@cmd_string, 2, 1);
    select_fn;

    IF p = NIL THEN
      BEGIN;
        send_message(message_bad_change_file);
        active_tcb^.error_sw := TRUE;
        EXIT;
      END;

    f := subword(@cmd_string, 3, 1);

    i := file_test(f);

    IF i = 0 THEN
      BEGIN;
        p^ := f;
        send_message(message_action_complete);

        IF s = 'ROUTE' THEN
          msg_route_force := TRUE;

        IF s = 'WAKEUP' THEN
          wakeup_force := TRUE;

      END
    ELSE
      BEGIN;
        send_tnc_data_str(dos_err_message(i) + cr);
        active_tcb^.error_sw := TRUE;
      END;

  END;
