(*===========================================================================*)
(* Option block                                                              *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

TYPE
  opt_type = RECORD

        port_count         : BYTE;      (* Number of ports                   *)
        fd_count           : BYTE;      (* Number of file directories        *)

        opt_type_bpt       : BOOLEAN;   (*  Limit types to B, P, and T       *)
        opt_sysop_is_in    : BOOLEAN;   (* Sysop is accepting calls          *)
        opt_sysop_bell     : BOOLEAN;   (* Sysop bell is on                  *)
        opt_bid_for_p      : BOOLEAN;   (* Gen BID for P messages            *)
        opt_bid_for_t      : BOOLEAN;   (* Gen BID for T messages            *)
        opt_bid_for_blank  : BOOLEAN;   (* Gen BID for _ messages            *)
        opt_blank_to_p     : BOOLEAN;   (* Translate "S" to "SP"             *)
        opt_blank_to_b     : BOOLEAN;   (* Translate "S" to "SB"             *)
        opt_hold_dupe_bid  : BOOLEAN;   (* Hold duplicate bids               *)
        opt_kill_bbs_error : BOOLEAN;   (* Disconnect BBS on any error       *)
        opt_direct_display : BOOLEAN;   (* Write direct to display           *)
        opt_direct_snow    : BOOLEAN;   (* Avoid snow on CGA                 *)
        opt_rename_k       : BOOLEAN;   (* Rename killed                     *)
        opt_error          : BOOLEAN;   (* Log minor errors                  *)
        opt_mono_tcb_trace : BOOLEAN;   (* Special monochrome TCB trace      *)
        opt_trace          : BOOLEAN;   (* Run trace                         *)
        opt_mon_time_stamp : BOOLEAN;   (* Time stamp monitor data           *)
        opt_bbs_see_p      : BOOLEAN;   (* Allow BBS to see "P" messages     *)
        opt_already_conn   : BOOLEAN;   (* Duplicate connect check           *)
        opt_time_status    : BOOLEAN;   (* Update status line on time tick   *)
        opt_own_in_bcst    : BOOLEAN;   (* Own call in BCST                  *)
        opt_yapp_state     : BOOLEAN;   (* Show YAPP states                  *)
        opt_show_binary    : BOOLEAN;   (* Show binary data during s/r       *)
        opt_suppress_pfx   : BOOLEAN;   (* Don't show prefix on LO screen    *)
        opt_show_mismatch  : BOOLEAN;   (* Show mismatch during forward scrpt*)
        opt_auto_hlookup   : BOOLEAN;   (* Do HLOOKUP each forward cycle     *)
        opt_extend_timeout : BOOLEAN;   (* Extend timeout on ports           *)
        opt_personal_bbs   : BOOLEAN;   (* Personal BBS                      *)
        opt_no_alt_header  : BOOLEAN;   (* Alternate header                  *)
        opt_send_sid_alwys : BOOLEAN;   (* Always send SID                   *)
        opt_fill_blank_bbs : BOOLEAN;   (* If @ BBS is blank fill from user  *)
        opt_no_lang_prompt : BOOLEAN;   (* Language prompt control in registr*)
        opt_no_full_review : BOOLEAN;   (* If on, bypass full screen review  *)
        opt_blank_to_bbs   : BOOLEAN;   (* If on, set the default to bbs = ''*)
        opt_autoset_to_bbs : BOOLEAN;   (* If on, set the default to bbs to  *)
                                        (* that user's home BBS if any       *)

        operate_mode  : op_mode;        (* Operation mode                    *)
        max_task_no   : BYTE;           (* Maximum number of tasks           *)
        this_bb_sign  : call_sign_str;  (* Call sign of BBS                  *)
        this_bb_bid   : call_sign_str;  (* Call sign of BBS for bid purposes *)
        sysop_sign    : call_sign_str;  (* Call sign of SYSOP                *)
        this_bb_addr  : bb_addr_str;    (* Address of BBS                    *)
        this_bb_h     : h_addr_str;     (* Hieararchical addess of this BBS  *)
        this_bb_name  : STRING[15];     (* SYSOP name                        *)
        this_bb_loc   : STRING[25];     (* Location                          *)
        user_file_name: file_name_str;  (* USER control file                 *)
        msg_file_name : file_name_str;  (* MSG control file                  *)
        msg_file_dir  : file_name_str;  (* Directory for the msg files       *)
        mess_fn       : file_name_str;  (* File name for messages            *)
        dos_mess_fn   : file_name_str;  (* File name for DOS messages        *)
        route_fn      : file_name_str;  (* File name for route table         *)
        path_fn       : file_name_str;  (* File name for path table          *)
        log_fn        : file_name_str;  (* File name for log                 *)
        help_fn       : file_name_str;  (* File name for help                *)
        doserr_fn     : file_name_str;  (* File name for DOS error messages  *)
        mon_fn        : file_name_str;  (* File name for monitor log         *)
        wakeup_fn     : file_name_str;  (* File name for wakeup              *)
        hlook_fn      : file_name_str;  (* File name for hlookup             *)
        passwd_fn     : file_name_str;  (* File name for password file       *)
        action_fn     : file_name_str;  (* File name for action file         *)
        n_mon         : WORD;           (* Number of mon items to keep       *)
        bid_fn        : file_name_str;  (* File name for bid table           *)
        n_bid         : WORD;           (* Number of bid items to keep       *)
        n_j_list      : BYTE;           (* Number of items on j list         *)
        hold_dupe_hdr : BYTE;           (* Number of dup headers to hold     *)
        trace_file_name : file_name_str;  (* Trace output                    *)
        z_time_fwd    : LONGINT;        (* Timezone correction -- FWD        *)
        nofwd_kill    : STRING[26];     (* Dont kill on forward              *)
        bcst_interval : BYTE;           (* Broadcast interval in minutes     *)
        fwd_delay     : BYTE;           (* Forward delay                     *)
        opt_types     : STRING[27];     (* Allowed types                     *)
        emer_types    : STRING[27];     (* Emergency types                   *)
        operator_color: BYTE;           (* Color of operator stuff           *)
        status_color  : BYTE;           (* Color of staus line               *)
        window_percent: BYTE;           (* Window split percentage           *)
        scroll_mon    : WORD;           (* Monitor scroll                    *)
        scroll_opr    : WORD;           (* Operator scroll                   *)
        scroll_conn   : WORD;           (* Connect scroll                    *)
        editor_free   : WORD;           (* Editor free size                  *)
        bell_length1  : BYTE;           (* Tone length                       *)
        bell_length2  : BYTE;           (* Warble length                     *)
        newuser_l_time: BYTE;           (* How many days to show a new user  *)
        wakeup_intervl: BYTE;           (* Wakeup interval                   *)
        bpq_appl_num  : BYTE;           (* BPQ application number            *)
        bpq_buff      : WORD;           (* BPQ buffer size                   *)
        yapp_time_exp : BYTE;           (* YAPP time expansion               *)
        max_l_shown   : BYTE;           (* Max messages given by "L" command *)

        wp_bb_sign    : bb_full_addr;   (* Call sign of WP system to send to *)
        home_expires  : LONGINT;        (* When Home BBS expires             *)
        b_fwd_stop    : LONGINT;        (* Don't forward bulletins after     *)
                                        (* this time period                  *)
        dflt_b_expire : LONGINT;        (* Default bulletin expiration date  *)
        language_list : lang_str;       (* List of allowed languages         *)

        parm_file_ver : BYTE;           (* Version number of parm file       *)
      END;

VAR
  opt_block : opt_type;
