(*===========================================================================*)
(* Overlay processor initialize                                              *)
(*                                                                           *)
(*   Copyright 1991, 1992 by H. Roy Engehausen.  All rights reserved.        *)
(*                                                                           *)
(*===========================================================================*)

UNIT BBOVERI;

INTERFACE

PROCEDURE start_up_overlay;

IMPLEMENTATION

USES
  CRT,
  OVERLAY,
  bbdummy;

(*===========================================================================*)
(* Overlay init                                                              *)
(*     Note:  Variable names are those we could steal since we didn't        *)
(*            want to waste memory                                           *)
(*===========================================================================*)

PROCEDURE start_up_overlay;

  BEGIN;

    {$IFDEF DEBUG_INIT}
      WRITELN('OVERLAY INIT 1');
      DELAY(1000);
    {$ENDIF}

(*  GETMEM(signal_place, 25000);
    FILLCHAR(signal_place^, 25000, 0);
    FREEMEM(signal_place, 25000);  *)

    {$IFDEF DEBUG_INIT}
      WRITELN('OVERLAY INIT 2');
      DELAY(1000);
    {$ENDIF}

    fwd_command := PARAMSTR(0);

    {$IFDEF DEBUG_INIT}
      WRITELN('OVERLAY INIT 3');
      DELAY(1000);
    {$ENDIF}

    signal_dummy := POS('.', fwd_command);
    IF signal_dummy = 0 THEN
      signal_dummy := 255;

    {$IFDEF DEBUG_INIT}
      WRITELN('OVERLAY INIT 4');
      DELAY(1000);
    {$ENDIF}

    fwd_command  := COPY(fwd_command, 1, signal_dummy) + 'OVR';

    {$IFDEF DEBUG_INIT}
      WRITELN('OVERLAY INIT 5');
      DELAY(1000);
    {$ENDIF}

    OVRINIT(fwd_command);
    IF OVRRESULT <> 0 THEN
      BEGIN
        WRITELN('Overlay error: ', OVRRESULT, ' on Overlay file: ', fwd_command);
        RUNERROR
      END;

    OVRSETBUF(45000);
    IF OVRRESULT <> 0 THEN
      WRITELN('Overlay error: ', OVRRESULT, ' on Overlay buf');

  END;

END.
