(*===========================================================================*)
(* Setup main initialization                                                 *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE main_parm_setup;

  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Set scan data -- Main list                                            *)
    (*-----------------------------------------------------------------------*)

    i_value := 1;
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NAME';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_name);
        parm_addr            := @this_bb_name;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'LOCATION';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_loc);
        parm_addr            := @this_bb_loc;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BB_SIGN';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_sign);
        parm_addr            := @this_bb_sign;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BB_ADDR';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_addr);
        parm_addr            := @this_bb_addr;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BB_HIER_ADDR';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_h);
        parm_addr            := @this_bb_h;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SYSOP_SIGN';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(sysop_sign);
        parm_addr            := @sysop_sign;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_SIGN';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(this_bb_bid);
        parm_addr            := @this_bb_bid;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SEND_WP_TO_BBS';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(wp_bb_sign);
        parm_addr            := @wp_bb_sign;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'USER_FILE';
        parm_type            := parm_file_not_exist;
        parm_str_len         := SIZEOF(user_file_name);
        parm_addr            := @user_file_name;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MSG_FILE';
        parm_type            := parm_file_not_exist;
        parm_str_len         := SIZEOF(msg_file_name);
        parm_addr            := @msg_file_name;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MSG_DIR';
        parm_type            := parm_path;
        parm_str_len         := SIZEOF(msg_file_dir);
        parm_addr            := @msg_file_dir;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MESSAGE_LIST';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(mess_fn);
        parm_addr            := @mess_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ROUTE_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(route_fn);
        parm_addr            := @route_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'PATH_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(path_fn);
        parm_addr            := @path_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'HELP_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(help_fn);
        parm_addr            := @help_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_FILE';
        parm_type            := parm_file_not_exist;
        parm_str_len         := SIZEOF(bid_fn);
        parm_addr            := @bid_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'LOG_FILE';
        parm_type            := parm_log;
        parm_str_len         := SIZEOF(log_fn);
        parm_addr            := @log_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MON_FILE';
        parm_type            := parm_file_not_exist;
        parm_str_len         := SIZEOF(mon_fn);
        parm_addr            := @mon_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'TRACE_FILE';
        parm_type            := parm_file_not_exist;
        parm_str_len         := SIZEOF(trace_file_name);
        parm_addr            := @trace_file_name;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'DOS_MESSAGE_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(dos_mess_fn);
        parm_addr            := @dos_mess_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'WAKEUP_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(wakeup_fn);
        parm_addr            := @wakeup_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'H_LOOKUP_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(hlook_fn);
        parm_addr            := @hlook_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'PASSWORD_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(passwd_fn);
        parm_addr            := @passwd_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ACTION_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(action_fn);
        parm_addr            := @action_fn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'TRACE';
        parm_type            := parm_boolean;
        parm_addr            := @opt_trace;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_FOR_P';
        parm_type            := parm_boolean;
        parm_addr            := @opt_bid_for_p;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_FOR_T';
        parm_type            := parm_boolean;
        parm_addr            := @opt_bid_for_t;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_FOR_BLANK';
        parm_type            := parm_boolean;
        parm_addr            := @opt_bid_for_blank;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BLANK_TO_P';
        parm_type            := parm_boolean;
        parm_addr            := @opt_blank_to_p;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BLANK_TO_B';
        parm_type            := parm_boolean;
        parm_addr            := @opt_blank_to_b;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'KILL_USERBBS_ON_ERROR';
        parm_type            := parm_boolean;
        parm_addr            := @opt_kill_bbs_error;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'DIRECT_VIDEO';
        parm_type            := parm_boolean;
        parm_addr            := @opt_direct_display;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'CHECK_SNOW';
        parm_type            := parm_boolean;
        parm_addr            := @opt_direct_snow;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'HOLD_DUPLICATE';
        parm_type            := parm_boolean;
        parm_addr            := @opt_hold_dupe_bid;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'RENAME_KILLED_MSG';
        parm_type            := parm_boolean;
        parm_addr            := @opt_rename_k;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SYSOP_IS_IN';
        parm_type            := parm_boolean;
        parm_addr            := @opt_sysop_is_in;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SYSOP_BELL';
        parm_type            := parm_boolean;
        parm_addr            := @opt_sysop_bell;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'LOUD_SYSOP_BELL';
        parm_type            := parm_boolean;
        parm_addr            := @bell_setting;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MONO_TRACE';
        parm_type            := parm_boolean;
        parm_addr            := @opt_mono_tcb_trace;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MONITOR_TIME_STAMP';
        parm_type            := parm_boolean;
        parm_addr            := @opt_mon_time_stamp;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BBS_SEE_P';
        parm_type            := parm_boolean;
        parm_addr            := @opt_bbs_see_p;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ALREADY_CONNECT_CHECK';
        parm_type            := parm_boolean;
        parm_addr            := @opt_already_conn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'TIME_UPDATES_STATUS';
        parm_type            := parm_boolean;
        parm_addr            := @opt_time_status;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'OWN_CALL_IN_BCST';
        parm_type            := parm_boolean;
        parm_addr            := @opt_own_in_bcst;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SHOW_YAPP_STATES';
        parm_type            := parm_boolean;
        parm_addr            := @opt_yapp_state;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SHOW_BINARY_DATA';
        parm_type            := parm_boolean;
        parm_addr            := @opt_show_binary;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SUPPRESS_PREFIX';
        parm_type            := parm_boolean;
        parm_addr            := @opt_suppress_pfx;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SHOW_FWD_MISMATCH';
        parm_type            := parm_boolean;
        parm_addr            := @opt_show_mismatch;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'AUTO_HLOOKUP';
        parm_type            := parm_boolean;
        parm_addr            := @opt_auto_hlookup;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'EXTENDED_TIMEOUT';
        parm_type            := parm_boolean;
        parm_addr            := @opt_extend_timeout;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'PERSONAL_BBS';
        parm_type            := parm_boolean;
        parm_addr            := @opt_personal_bbs;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NO_ALTERNATE_HEADER';
        parm_type            := parm_boolean;
        parm_addr            := @opt_no_alt_header;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'SEND_SID_ALWAYS';
        parm_type            := parm_boolean;
        parm_addr            := @opt_send_sid_alwys;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'FORWARD_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_fwd_emer;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'FORWARD_NTS_OFF';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_fwd_nonts;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ACCEPT_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_acc_nonts;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ACCEPT_NTS_OFF';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_acc_nonts;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ALLOW_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_e_users;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ALLOW_EMERGENCY_CHANGE';
        parm_type            := parm_boolean;
        parm_addr            := @operate_mode.mode_user_change;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NO_LANGUAGE_PROMPT';
        parm_type            := parm_boolean;
        parm_addr            := @opt_no_lang_prompt;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BLANK_TO_BBS';
        parm_type            := parm_boolean;
        parm_addr            := @opt_blank_to_bbs;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'AUTO_SET_TO_BBS';
        parm_type            := parm_boolean;
        parm_addr            := @opt_autoset_to_bbs;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NO_FULLSCREEN_REVIEW';
        parm_type            := parm_boolean;
        parm_addr            := @opt_no_full_review;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NO_FWD_KILL';
        parm_type            := parm_string_under;
        parm_str_len         := SIZEOF(nofwd_kill);
        parm_addr            := @nofwd_kill;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'ALLOW_TYPES';
        parm_type            := parm_string_under;
        parm_str_len         := SIZEOF(opt_types);
        parm_addr            := @opt_types;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'EMERGENCY_TYPES';
        parm_type            := parm_string_under;
        parm_str_len         := SIZEOF(emer_types);
        parm_addr            := @emer_types;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'LANGUAGE_LIST';
        parm_type            := parm_string_under;
        parm_str_len         := SIZEOF(language_list);
        parm_addr            := @language_list;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MAX_TASK';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 32;
        parm_addr            := @max_task_no;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'HOLD_DUP_HEADER';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @hold_dupe_hdr;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'FORWARD_DELAY';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @fwd_delay;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'NEW_USER_L_TIME';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @newuser_l_time;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'TOP_WINDOW_%';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @window_percent;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'WAKEUP_INTERVAL';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @wakeup_intervl;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'YAPP_TIMEOUT_EXPAND';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 10;
        parm_addr            := @yapp_time_exp;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MAX_L_MESSAGES';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @max_l_shown;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MONITOR_SCROLL_SIZE';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 1000;
        parm_addr            := @scroll_mon;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BPQHOST_APPLICATION';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 5;
        parm_addr            := @bpq_appl_num;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MONITOR_SCROLL_SIZE';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 1000;
        parm_addr            := @scroll_mon;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'OPERATOR_SCROLL_SIZE';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 1000;
        parm_addr            := @scroll_opr;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'CONNECT_SCROLL_SIZE';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 1000;
        parm_addr            := @scroll_conn;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BID_MAX';
        parm_type            := parm_word;
        parm_lo              := 100;
        parm_hi              := 5000;
        parm_addr            := @n_bid;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BPQ_BUFFER_SIZE';
        parm_type            := parm_word;
        parm_lo              := 360;
        parm_hi              := 5000;
        parm_addr            := @bpq_buff;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BBS_TO_FWD_TIME';
        parm_type            := parm_long_int;
        parm_hi              := 24*60-1;
        parm_lo              := -parm_hi;
        parm_addr            := @z_time_fwd;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'HOME_BBS_EXPIRES';
        parm_type            := parm_long_int;
        parm_hi              := 365;
        parm_lo              := 30;
        parm_addr            := @home_expires;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BULLETIN_FWD_STOP';
        parm_type            := parm_long_int;
        parm_hi              := 365;
        parm_lo              := 1;
        parm_addr            := @b_fwd_stop;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'DEFAULT_EXPIRATION';
        parm_type            := parm_long_int;
        parm_hi              := 365;
        parm_lo              := 1;
        parm_addr            := @dflt_b_expire;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'BROADCAST_INTERVAL';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @bcst_interval;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'OPERATOR_COLOR';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @operator_color;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'STATUS_COLOR';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @status_color;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'MON_LIST_LENGTH';
        parm_type            := parm_word;
        parm_lo              := 0;
        parm_hi              := 30;
        parm_addr            := @n_mon;
      END;

    INC(i_value);
    WITH main_parm_array[i_value], opt_block DO
      BEGIN;
        parm_name            := 'EDITOR_FREE_SIZE';
        parm_type            := parm_word;
        parm_lo              := 10000;
        parm_hi              := 65000;
        parm_addr            := @editor_free;
      END;

  END;
