(*===========================================================================*)
(* Setup port initialization                                                 *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE port_parm_setup;

  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Set scan data -- Port list                                            *)
    (*-----------------------------------------------------------------------*)

    i_value := 1;
    WITH port_parm_array[i_value] DO
      BEGIN;
        parm_name            := 'PORT_TYPE';
        parm_type            := parm_port_type;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'INITIALIZE_FILE';
        parm_type            := parm_file;
        parm_str_len         := SIZEOF(first_load);
        parm_addr            := @first_load;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MONITOR';
        parm_type            := parm_boolean;
        parm_addr            := @port_monitor;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'HOST_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @port_host_only;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'REMOTE_SYSOP';
        parm_type            := parm_boolean;
        parm_addr            := @port_r_sysop;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'UPLOAD_DOWNLOAD';
        parm_type            := parm_boolean;
        parm_addr            := @port_up_down;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'BROADCAST';
        parm_type            := parm_boolean;
        parm_addr            := @port_bcst;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NO_OUT_FWD';
        parm_type            := parm_boolean;
        parm_addr            := @port_no_out_fwd;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NO_BUSY_FWD';
        parm_type            := parm_boolean;
        parm_addr            := @port_no_busy_fwd;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NO_BINARY';
        parm_type            := parm_boolean;
        parm_addr            := @port_no_binary;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NEW_USER_TRANSPARENCY';
        parm_type            := parm_boolean;
        parm_addr            := @port_dflt_trans;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'FORWARD_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_fwd_emer;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'FORWARD_NTS_OFF';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_fwd_nonts;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ACCEPT_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_acc_emer;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ACCEPT_NTS_OFF';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_acc_nonts;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ALLOW_EMERGENCY_ONLY';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_e_users;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ALLOW_EMERGENCY_CHANGE';
        parm_type            := parm_boolean;
        parm_addr            := @port_operate_mode.mode_user_change;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'LOCK_MODEM_SPEED';
        parm_type            := parm_boolean;
        parm_addr            := @modem_freez;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'REMOVE_SSID_ADDRESSES';
        parm_type            := parm_boolean;
        parm_addr            := @port_suppress_ssid;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'CALL_SET';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(call_set);
        parm_addr            := @call_set;
      END;
    port_parm_call := i_value;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'COM';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @com_number;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'INTERLOCK_COM';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @port_sema;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MAX_CONNECT';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := max_connect_port - 1;
        parm_addr            := @max_conn;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MAX_CHANNEL';
        parm_type            := parm_byte;
        parm_lo              := 2;
        parm_hi              := max_connect_port;
        parm_addr            := @max_chan;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MONITOR_COLOR';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @port_color;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'DISCONNECT_DELAY';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 255;
        parm_addr            := @disc_delay;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'SPEED';
        parm_type            := parm_speed;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MAX_PAC';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 256;
        parm_addr            := @max_pac;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'DFLT_PAC';
        parm_type            := parm_word;
        parm_lo              := 20;
        parm_hi              := 256;
        parm_addr            := @dflt_pac;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'TIME_OUT';
        parm_type            := parm_word;
        parm_lo              := 60;
        parm_hi              := 3000;
        parm_addr            := @time_out;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'FWD_MIN';
        parm_type            := parm_word;
        parm_lo              := 0;
        parm_hi              := 59;
        parm_addr            := @fwd_min;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MAX_PENDING';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 28;
        parm_addr            := @port_pend;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ANSWER_ON_RING';
        parm_type            := parm_byte;
        parm_lo              := 1;
        parm_hi              := 15;
        parm_addr            := @answer_ring;
      END;
    port_parm_ring := i_value;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NEW_USER_SCREEN_LENGTH';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 255;
        parm_addr            := @dflt_scrl;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'NEW_USER_DISPLAY_FORMAT';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 4;
        parm_addr            := @new_display;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'REJECT_ACTION';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 2;
        parm_addr            := @reject_act;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'REJECT_BULLETIN_ACTION';
        parm_type            := parm_byte;
        parm_lo              := 0;
        parm_hi              := 2;
        parm_addr            := @reject_bul;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'PORT_NAME';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(port_name);
        parm_addr            := @port_name;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'BROADCAST_PATH';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(bcst_path);
        parm_addr            := @bcst_path;
      END;
    port_parm_bcst := i_value;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'DEFAULT_FORWARD_ORDER';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(dflt_order);
        parm_addr            := @dflt_order;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'DEFAULT_LANGUAGE';
        parm_type            := parm_char_upper;
        parm_str_len         := 2; (* Fudge because this is string length *)
        parm_addr            := @dflt_lang;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'MINIMUM_CLASS_ALLOWED';
        parm_type            := parm_user_class;
        parm_addr            := @port_allow;
      END;

    INC(i_value);
    WITH port_parm_array[i_value], work_port DO
      BEGIN;
        parm_name            := 'ACCESS_CONTROL';
        parm_type            := parm_access;
        parm_addr            := @dflt_access
      END;

  END;
