(*===========================================================================*)
(* Setup file initialization                                                 *)
(*                                                                           *)
(*   Copyright 1988, 1989 by H. Roy Engehausen.  All rights reserved.        *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

PROCEDURE file_parm_setup;

  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Set scan data -- File list                                            *)
    (*-----------------------------------------------------------------------*)

    i_value := 1;
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'DIRECTORY_NAME';
        parm_type            := parm_string_upper;
        parm_str_len         := SIZEOF(fsb_name);
        parm_addr            := @fsb_name;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'DIRECTORY_ALIAS';
        parm_type            := parm_string_upper;
        parm_str_len         := SIZEOF(fsb_alias);
        parm_addr            := @fsb_alias;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'DIRECTORY_PATH';
        parm_type            := parm_path;
        parm_str_len         := SIZEOF(fsb_path);
        parm_addr            := @fsb_path;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'DIRECTORY_DESC';
        parm_type            := parm_string;
        parm_str_len         := SIZEOF(fsb_desc);
        parm_addr            := @fsb_desc;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'CLASS_FOR_UPLOAD';
        parm_type            := parm_user_class;
        parm_addr            := @fsb_up;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'CLASS_FOR_DOWNLOAD';
        parm_type            := parm_user_class;
        parm_addr            := @fsb_down;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'SUBDIRECTORY_OK';
        parm_type            := parm_boolean;
        parm_addr            := @fsb_f_subdir_ok;
      END;

    INC(i_value);
    WITH file_parm_array[i_value], work_fsb DO
      BEGIN;
        parm_name            := 'BINARY_OK';
        parm_type            := parm_boolean;
        parm_addr            := @fsb_binary
      END;

  END;
