(*===========================================================================*)
(* Miscellaneous setup routines                                              *)
(*                                                                           *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Print a line in error                                                     *)
(*===========================================================================*)

PROCEDURE err_line(err_mess : STRING);
  BEGIN;

    WRITELN;

    WRITELN('ERROR ==> ', err_mess);

    WRITELN('Line number ', line_cnt);

    WRITELN(in_line);

    WRITELN;

    err_sw := TRUE;

  END;

(*===========================================================================*)
(* Print a line in warning                                                   *)
(*===========================================================================*)

PROCEDURE warn_line(err_mess : STRING);
  BEGIN;

    WRITELN;

    WRITELN('WARNING ==> ', err_mess);

    WRITELN('Line number ', line_cnt);

    WRITELN(in_line);

    WRITELN;

  END;

(*===========================================================================*)
(* Print a error message                                                     *)
(*===========================================================================*)

PROCEDURE err_disp(err_mess : STRING);
  BEGIN;

    WRITELN('ERROR ==> ', err_mess);

    err_sw := TRUE;

  END;

(*===========================================================================*)
(* Y or N only                                                               *)
(*===========================================================================*)

FUNCTION yn : BOOLEAN;
  BEGIN;

    upcase_str_var(p_value);

    yn := TRUE;
    IF p_value = 'Y'   THEN EXIT;
    IF p_value = 'YES' THEN EXIT;
    IF p_value = 'ON' THEN EXIT;

    yn := FALSE;
    IF p_value = 'N'   THEN EXIT;
    IF p_value = 'NO'  THEN EXIT;
    IF p_value = 'OFF' THEN EXIT;

    err_line('Only Yes/No answer for this option');

  END;

(*===========================================================================*)
(* Test for a file                                                           *)
(*===========================================================================*)

FUNCTION test_file(fn : STRING; not_found_ok : BOOLEAN) : BOOLEAN;

  BEGIN;
    FILLCHAR(look, SIZEOF(look), CHR(0));

    FINDFIRST(fn, ANYFILE, look);

    i_value := DOSERROR;

    test_file := TRUE;

    IF (i_value = 18) AND not_found_ok THEN
      EXIT;

    CASE i_value OF
       0   : EXIT;
       2,3 : err_disp('Path not found for ' + fn);
      18   : err_disp('File not found for ' + fn);
      ELSE
        BEGIN;
          STR(i_value, p_value);
          err_disp('Dos error ' + p_value + ' during check of ' + fn);
        END;
    END;

    test_file := FALSE;

  END;

