(*===========================================================================*)
(* Semaphore control for ports                                               *)
(*                                                                           *)
(*   Copyright 1990 by H. Roy Engehausen.  All rights reserved.              *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Get port semaphore                                                        *)
(*===========================================================================*)

PROCEDURE get_port_semaphore;

  BEGIN;

    get_semaphore(active_port^.port_sema, sem_exclusive, FALSE);
    get_semaphore(semaphore_interrupts, sem_shared, FALSE);

  END;

(*===========================================================================*)
(* Free port semaphore                                                       *)
(*===========================================================================*)

PROCEDURE free_port_semaphore;

  BEGIN;

    free_semaphore(active_port^.port_sema);
    free_semaphore(semaphore_interrupts);

  END;
