(*===========================================================================*)
(* Time constants                                                            *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Global constants for all timers                                           *)
(*===========================================================================*)

CONST
  max_time : LONGINT       = $7FFFFFFF;

(*===========================================================================*)
(* Global constant for date/time clock                                       *)
(*===========================================================================*)

  secs_per_tick            = 2;
  secs_per_tick_shift      = 1;     (* Shift factor for seconds per tick *)
  ticks_per_min            = 30;
  ticks_per_hour           = ticks_per_min * 60;
  ticks_per_day            = ticks_per_hour * 24;
  days_per_year            = 365;
  days_per_4year : LONGINT = 1461;

  y_noleap : ARRAY[1..12] OF INTEGER =
                               (0,31,59,90,120,151,181,212,243,273,304,334);
  y_leap   : ARRAY[1..12] OF INTEGER =
                               (0,31,60,91,121,152,182,213,244,274,305,335);

(*===========================================================================*)
(* Global constant for uptime clock                                          *)
(*===========================================================================*)

  up_ticks_per_sec         = 100;
  up_ticks_per_min         = 60 * up_ticks_per_sec;
  up_ticks_per_hour        = 60 * up_ticks_per_min;
  up_ticks_per_day         = 24 * up_ticks_per_hour;

