(*===========================================================================*)
(* Global type definitions                                                   *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991, 1992 by H. Roy Engehausen.  All       *)
(*   rights reserved.                                                        *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Types                                                                     *)
(*===========================================================================*)

TYPE

  str2         = STRING[2];
  str3         = STRING[3];
  str4         = STRING[4];
  str5         = STRING[5];
  str8         = STRING[8];
  str15        = STRING[15];

  str_ptr      = ^STRING;

  str_mixed    = RECORD
                   CASE BYTE OF
                     0: (  long_length : WORD;
                           filler_1    : BYTE;
                           long_data   : ARRAY[1..512] OF CHAR);

                     1: (  filler_2    : WORD;
                           str_data    : STRING;  );

                    END;

  str_mixed_ptr = ^str_mixed;

  str_m_chain   = ^str_m_c_type;

  str_m_c_type  = RECORD
                    str_m_next : str_m_chain;
                    str_m_type : BYTE;
                    str_m_chan : BYTE;
                    str_m_data : str_mixed;
                  END;

TYPE

  bb_addr_str   = STRING[bb_addr_len];
  bb_full_addr  = STRING[call_sign_len + 1 + h_addr_len];
  bid_str       = STRING[bid_len];
  call_sign_str = STRING[call_sign_len];
  file_name_str = STRING[file_name_len];
  h_addr_str    = STRING[h_addr_len];
  mem_id_str    = STRING[3];
  password_str  = STRING[password_len];
  ssid_sign_str = STRING[ssid_sign_len];
  subj_str      = STRING[subj_len];

  lang_str      = STRING[max_languages];

{$IFDEF OBSOLETE}

  chg_dest_tptr = ^chg_dest_type;

  chg_dest_type = RECORD
                    chg_dest_next : chg_dest_tptr;
                    chg_from      : STRING;
                    chg_to        : STRING;
                  END;

{$ENDIF}

  str_chain_ptr = ^str_chain_block;

  str_chain_block = RECORD
                      str_next : str_chain_ptr;
                      str_data : STRING;
                    END;

CONST str_chain_block_oh  = 5;         (* Overhead of string chain block     *)
CONST str_m_block_oh      = 9;         (* Overhead of str mixed chain block  *)
CONST str_m_oh            = 3;         (* Overhead of str mixed              *)

