(*===========================================================================*)
(* Handle userid files                                                       *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

{$O+}

{$DEFINE POINT_CHK}

UNIT BBUF;

INTERFACE

  USES
    bbdummy;

  PROCEDURE add_uid     (uid_to_add : user_record_ptr);
  PROCEDURE uid_init    (uid_data   : user_record_ptr);
  PROCEDURE insert_uid  (uid_to_ins : user_index_ptr);
  PROCEDURE update_uid  (uid_to_upd : user_record_ptr);
  FUNCTION  find_uid    (uid_to_get : call_sign_str)   : user_index_ptr;
  FUNCTION  get_uid     (uid_to_get : user_index_ptr)  : user_record_ptr;

VAR
  uid_chain         : user_index_ptr;
  uid_free          : user_index_ptr;
  uid_file          : FILE OF user_record_type;
  uid_total         : WORD;

CONST
  uid_buffer_mem_str = 'UFB';

IMPLEMENTATION

USES
  CRT,
  bbmem,
  bbmisc3,
  bbmisc4,
  bbsema2,
  bbstr,
  bbtime,
  bbtrace;

{$I BBUF1.PAS}                             (* Miscellaneous                  *)
{$I BBUF2.PAS}                             (* Add/Init/Insert a User         *)
{$I BBUF3.PAS}                             (* Find/Update a User             *)
{$I BBUF4.PAS}                             (* Get/Display a User             *)

END.
