(*===========================================================================*)
(* User task - Nonoverlay                                                    *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

UNIT BBUSERNO;

INTERFACE

  PROCEDURE user_loop;

IMPLEMENTATION

  USES
    bbdummy,
    bbrdata,
    bbsdata,
    bbsess,
    bbtask,
    bbtime;

PROCEDURE user_loop;

  VAR
    delay           : BYTE;
    i               : BYTE;
    link_restart    : BOOLEAN;
    timer_on        : BOOLEAN;
    timer_value     : LONGINT;

  BEGIN;

    delay := 1;
    timer_value := max_time;
    timer_on    := FALSE;

    REPEAT

      (*---------------------------------------------------------------------*)
      (* Delay for a while                                                   *)
      (*---------------------------------------------------------------------*)

      FOR i := 1 TO delay DO
        task_switch;

      delay := 15;

      (*---------------------------------------------------------------------*)
      (* See if operator wants something                                     *)
      (*---------------------------------------------------------------------*)

      IF active_tcb^.tcb_opr_talk THEN
        EXIT;

      (*---------------------------------------------------------------------*)
      (* This is the timeout                                                 *)
      (*   If we have no outstanding frames then we check the timers.        *)
      (*---------------------------------------------------------------------*)

      IF send_unacked(FALSE) = 0 THEN
        IF timer_on THEN
          BEGIN;

            IF (current_day_time > timer_value) THEN

              (*-------------------------------------------------------------*)
              (* Time expired.  Tell user then dump the connection.          *)
              (*-------------------------------------------------------------*)

              timer_end_session;

          END
        ELSE
          BEGIN;
            timer_value := current_day_time + active_port^.time_out;
            timer_on := TRUE;
          END;

    UNTIL read_tnc_data_pending;

  END;

END.
