(*===========================================================================*)
(* Global variables                                                          *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990, 1991 by H. Roy Engehausen.  All rights      *)
(*   reserved.                                                               *)
(*                                                                           *)
(*===========================================================================*)

(*---------------------------------------------------------------------------*)
(* Geneeral temp for people to use                                           *)
(*---------------------------------------------------------------------------*)

VAR
  temp              : WORD;

(*---------------------------------------------------------------------------*)
(* Process communications                                                    *)
(*---------------------------------------------------------------------------*)

VAR
  main_switch       : BOOLEAN;
  shutdown_switch   : BOOLEAN;
  dead_tcb_list     : tcb_ptr;
  kill_printer      : BOOLEAN;

(*---------------------------------------------------------------------------*)
(* Debugging info                                                            *)
(*---------------------------------------------------------------------------*)

  signal_place      : ^WORD;
  signal_dummy      : WORD;
  main_cs           : WORD;

(*---------------------------------------------------------------------------*)
(* Date and time control -- All refer to right now                           *)
(*      Ticks since Jan 1, 1980.  One tick = 2 seconds                       *)
(*---------------------------------------------------------------------------*)

  current_day_time  : LONGINT;         (* Current time in my format          *)
  todays_date_time  : STRING[11];      (* Today in string format YYMMDD/HHMM *)
  todays_dow        : WORD;            (* Today's day of week                *)
  sec100            : WORD;            (* Current 1/100ths of a second       *)
  today_time        : DATETIME;        (* Current time in structure format   *)

  last_midnight     : LONGINT;         (* Previous midnight in my format     *)

(*---------------------------------------------------------------------------*)
(* Up time clock                                                             *)
(*     Ticks since midnight the day the BBS was started.  One tick = .01 sec.*)
(*---------------------------------------------------------------------------*)

  up_time           : LONGINT;         (* Current up time                    *)
  up_days           : BYTE;            (* Days BBS is up                     *)

(*---------------------------------------------------------------------------*)
(* Wakeup control                                                            *)
(*---------------------------------------------------------------------------*)

  wakeup_force      : BOOLEAN;         (* Operator forced wakeup via GK      *)
  wakeup_time       : LONGINT;         (* Next wakeup time                   *)
  wakeup_did_something : BOOLEAN;

(*---------------------------------------------------------------------------*)
(* Status window needs update                                                *)
(*---------------------------------------------------------------------------*)

  status_window_change : BOOLEAN;

(*---------------------------------------------------------------------------*)
(* Edit window is busy                                                       *)
(*---------------------------------------------------------------------------*)

  edit_window_busy     : BOOLEAN;
  edit_exitcode        : BYTE;
  edit_operation       : BYTE;    (* 0 = normal edit, 1 = review *)
  edit_parm            : POINTER;

(*---------------------------------------------------------------------------*)
(* TCB / port control                                                        *)
(*---------------------------------------------------------------------------*)

  ring_tcb           : tcb_ptr;
  ring_port          : port_block_ptr;
  overhead_tcb_count : BYTE;
  alive_tcb_count    : BYTE;

  dummy_port         : port_block_type;

  main_tcb           : tcb_ptr;

(*---------------------------------------------------------------------------*)
(* Active TCB info                                                           *)
(*---------------------------------------------------------------------------*)

  active_port  : port_block_ptr;
  active_tcb   : tcb_ptr;

(*---------------------------------------------------------------------------*)
(* Msg information                                                           *)
(*---------------------------------------------------------------------------*)

  msg_index_end     : msg_index_ptr;
  msg_index_start   : msg_index_ptr;
  msg_counter_ok    : WORD;
  msg_counter_kill  : WORD;

(*---------------------------------------------------------------------------*)
(* Actions                                                                   *)
(*---------------------------------------------------------------------------*)

  first_msg_action : action_msg_ptr;

(*---------------------------------------------------------------------------*)
(* Forward control                                                           *)
(*---------------------------------------------------------------------------*)

  fwd_command     : STRING;
  fwd_out_busy    : BOOLEAN;
  msg_route_list  : msg_r_ptr;
  msg_route_num   : WORD;              (* Number of highest msg in routes    *)
  msg_route_force : BOOLEAN;           (* TRUE signifies a OPERATOR forced   *)
                                       (* reorg of routes via GF command     *)

(*---------------------------------------------------------------------------*)
(* Procedure to execute                                                      *)
(*---------------------------------------------------------------------------*)

  proc_addr       : POINTER;

(*---------------------------------------------------------------------------*)
(* Inter-procedure communications                                            *)
(*---------------------------------------------------------------------------*)

  io_file_size    : LONGINT;

(*---------------------------------------------------------------------------*)
(* Data for SYSOP                                                            *)
(*---------------------------------------------------------------------------*)

  op_busy         : BOOLEAN;

(*---------------------------------------------------------------------------*)
(* Capture data                                                              *)
(*---------------------------------------------------------------------------*)

  capture_this_window  : BYTE;
  capture_file         : text;

(*---------------------------------------------------------------------------*)
(* Hierarchical search info (HLOOKUP)                                        *)
(*---------------------------------------------------------------------------*)

  last_h_msg  : WORD;

(*---------------------------------------------------------------------------*)
(* Trace info                                                                *)
(*---------------------------------------------------------------------------*)

  trace_file  : ^TEXT;
  trace_count : BYTE;
