(*===========================================================================*)
(* Wakeup date checker                                                       *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1990 by H. Roy Engehausen.  All rights reserved.  *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Wakeup line processor                                                     *)
(*===========================================================================*)

PROCEDURE date_check;

  CONST
    dow_list = ('SUNDAY MONDAY TUESDAY WEDNESDY THURSDAY FRIDAY SATURDAY');

  VAR
    code : INTEGER;
    i    : INTEGER;
    s    : STRING[2];
    t    : STRING;

  BEGIN;

    IF action_date_str = '==/==/==' THEN
      BEGIN;
        date_ok := TRUE;
        EXIT;
      END;

    IF (action_date_str = 'WEEKEND') THEN
      BEGIN;
        IF (todays_dow = 0) OR (todays_dow = 6) THEN
          date_ok := TRUE;
        EXIT;
      END;

    IF (action_date_str = 'WEEKDAY') THEN
      BEGIN;
        IF (todays_dow > 0) OR (todays_dow < 6) THEN
          date_ok := TRUE;
        EXIT;
      END;

    t := dow_list;
    i := FIND(@t, @action_date_str);

    IF i > 0 THEN
      BEGIN;
        date_ok := todays_dow = i - 1;
        EXIT;
      END;

    IF (LENGTH(action_date_str) <> 8)
                                      OR (action_date_str[3] <> '/')
                                      OR (action_date_str[6] <> '/') THEN
      BEGIN;
        window_write('WKE:', 'Bad action date on WAKEUP line #' + line_no_str);
        EXIT;
      END;

    s := SUBSTR(action_date_str, 1, 2);

    IF s <> '==' THEN
      BEGIN;
        VAL(s, i, code);

        IF (code <> 0) OR (i < 1) OR (i > 12) THEN
          BEGIN;
            window_write('WKE:',
                            'Bad action month on WAKEUP line #' + line_no_str);
            EXIT;
          END;

        IF s <> substr(todays_date_time, 3, 2) THEN
          EXIT;
      END;

    s := SUBSTR(action_date_str, 4, 2);

    IF s <> '==' THEN
      BEGIN;

        VAL(s, i, code);

        IF (code <> 0) OR (i < 1) OR (i > 31) THEN
          BEGIN;
            window_write('WKE:',
                              'Bad action day on WAKEUP line #' + line_no_str);
            EXIT;
          END;

        IF s <> substr(todays_date_time, 5, 2) THEN
          EXIT;

      END;

    s := SUBSTR(action_date_str, 7, 2);

    IF s <> '==' THEN
      BEGIN;

        VAL(s, i, code);

        IF (code <> 0) OR (i < 88) THEN
          BEGIN;
            window_write('WKE:',
                             'Bad action year on WAKEUP line #' + line_no_str);
            EXIT;
          END;

        IF s <> substr(todays_date_time, 1, 2) THEN
          EXIT;

      END;

    date_ok := TRUE;

  END;
