(*===========================================================================*)
(* Get x,y, who_is_in, refresh screen                                        *)
(*                                                                           *)
(*   Copyright 1988, 1989, 1991 by H. Roy Engehausen.  All rights reserved.  *)
(*                                                                           *)
(*===========================================================================*)

FUNCTION  get_window_x(window_number : BYTE) : WORD;
  BEGIN;

    {$IFDEF DEPTH}
    stack_depth;
    {$ENDIF}

    get_window_x := 1 * 256 + 80;

  END;

FUNCTION  get_window_y(window_number : BYTE) : WORD;
  BEGIN;

    {$IFDEF DEPTH}
    stack_depth;
    {$ENDIF}

    WITH window_location[window_array[window_number].window_loc] DO
      BEGIN;
        get_window_y :=  window_u_y * 256 + window_l_y;
      END;

  END;

FUNCTION who_is_in_window (this_location : BYTE) : BYTE;
  BEGIN;

    {$IFDEF DEPTH}
    stack_depth;
    {$ENDIF}

    IF window_array[window_connect].window_loc = this_location THEN
      who_is_in_window := window_connect
    ELSE
      who_is_in_window := window_monitor;

  END;

PROCEDURE window_refresh(w_no : BYTE);
  VAR
    b : BOOLEAN;
    s : BYTE;
    t : window_data_ptr;
    w : window_data_ptr;

  {$IFDEF LOOP_POINT_CHK}
    i : WORD;
  {$ENDIF}

  BEGIN;

    {$IFDEF DEPTH}
    stack_depth;
    {$ENDIF}

    {$IFDEF LOOP_POINT_CHK}
      i := 0;
    {$ENDIF}

    WITH window_array[w_no] DO
      BEGIN;

        (*-------------------------------------------------------------------*)
        (* If this window doesn't scroll, forget it                          *)
        (*-------------------------------------------------------------------*)

        IF NOT window_scrollable THEN
          EXIT;

        (*-------------------------------------------------------------------*)
        (* Go to correct window                                              *)
        (*-------------------------------------------------------------------*)

        s := current_window;

        IF w_no <> s THEN
          window_select(w_no);

        (*-------------------------------------------------------------------*)
        (* Get ready for loop                                                *)
        (*-------------------------------------------------------------------*)

        w := window_line;
        t := find_window_top_line;

        (*-------------------------------------------------------------------*)
        (* Loop writing the screen                                           *)
        (*-------------------------------------------------------------------*)

        REPEAT

          {$IFDEF LOOP_POINT_CHK}
            INC(i);
            IF (t = t^.next_line) OR (i > 500) THEN
              BEGIN;
                WRITELN('Window loop refresh ', i, '-', w_no);
                dump_string('Wind loop at refresh ' + p2x(t));
                dump_window(w_no);
                HALT;
              END;
          {$ENDIF}

          b := w <> t;

          put_bot_line(t, b);

          IF b THEN WRITELN;

          t := t^.next_line;

        UNTIL NOT b;

        (*-------------------------------------------------------------------*)
        (* Go back to old window                                             *)
        (*-------------------------------------------------------------------*)

        IF w_no <> s THEN
          window_select(s);

      END;

  END;
