(*===========================================================================*)
(* YAPP Protocol processor -- Main line                                      *)
(*                                                                           *)
(*   Copyright 1989, 1992 by H. Roy Engehausen.  All rights reserved.        *)
(*                                                                           *)
(*   This implements the YAPP(tm) binary transfer protocol (or at least      *)
(*   a subset OF the full protocol - this version does not include the       *)
(*   server commands FOR automated transfer.)                                *)
(*                                                                           *)
(*   This is a modified version OF the actual code used in YAPP FOR the      *)
(*   IBM PC AND compatibles.  Some lines have been deleted that handled      *)
(*   functions such as displaying the status OF the transfer, AND checking   *)
(*   FOR an abort from the keyboard.                                         *)
(*                                                                           *)
(*===========================================================================*)

(*===========================================================================*)
(* Yapp mainline                                                             *)
(*===========================================================================*)

PROCEDURE yapp_xfer;

  (*-------------------------------------------------------------------------*)
  (* These are AA4RE's vars                                                  *)
  (*-------------------------------------------------------------------------*)

  VAR

    yapp_timer      : LONGINT;

  (*-------------------------------------------------------------------------*)
  (* These TYPEs are from WA7MBL YAPP code                                   *)
  (*-------------------------------------------------------------------------*)

  TYPE

    states  = (S, S1, SH, SD, SE, ST, R, RH, RD, Abort, CW, C, Start);
    paktype =
         (UK, RR, RF, SI, HD, DT, EF, ET, NR, CN, CA, RI, TX, UU, TM, AF, AT);
    line    = STRING;
    fofb    = FILE OF BYTE;

  (*-------------------------------------------------------------------------*)
  (* These VARs are from WA7MBL YAPP code                                    *)
  (*-------------------------------------------------------------------------*)

  VAR

    sendinit_count  : WORD;
    xferhdr         : line;
    xfercnt         : LONGINT;
    xferok          : BOOLEAN;

    state           : states;
    ptype           : paktype;

    pkbuff          : ARRAY [1..256] OF CHAR;
    pklen           : WORD;
    pkfile          : ^fofb;
    txtbuff         : line;

  CONST

    nul       = #0;
    soh       = #1;
    stx       = #2;
    etx       = #3;
    eot       = #4;
    enq       = #5;
    ack       = #6;
    dle       = #16;
    nak       = #21;
    can       = #24;

  {$I BBYAPP1.PAS}        (* AA4RE code to make Jeff's YAPP work *)
  {$I BBYAPP2.PAS}        (* Mostly WA7MBL Code             *)

  BEGIN;

    (*-----------------------------------------------------------------------*)
    (* Locate the file area                                                  *)
    (*-----------------------------------------------------------------------*)

    pkfile := @active_tcb^.io_fe^.fe_bin;

    (*-----------------------------------------------------------------------*)
    (* Do the file                                                           *)
    (*-----------------------------------------------------------------------*)

    xferok := FALSE;

    IF up_it THEN
      yapp_upload
    ELSE
      yapp_download;

    (*-----------------------------------------------------------------------*)
    (* Close file                                                            *)
    (*-----------------------------------------------------------------------*)

    get_semaphore(semaphore_interrupts, sem_exclusive, FALSE);
    {$I-}
    close(pkfile^);
    {$I+}
    xfercnt := IORESULT; (*throw away data somehwere*)
    free_semaphore(semaphore_interrupts);

    (*-----------------------------------------------------------------------*)
    (* Set the switch showing results                                        *)
    (*-----------------------------------------------------------------------*)

    active_tcb^.error_sw := NOT xferok;

  END;
