/*
   biff.c: Copyright 1993, Paul Healy.

   Todo: trigger a scan from a location following the arrival of mail.

   930413 : Created
*/
#include <stdio.h>
#include <time.h>
#include "config.h"
#include "buf.h"
#include "mailfile.h"
#include "biff.h"
#include "pc.h"
#include "rc.h"

static const int TimeOut = 20; /* seconds */
static const char newmail[]= "\nYou have new mail\n";

static void
doprompt(Mailfile *m)
{
   static char owrite[] = "\r                             \r";

   printf("%s%s:%d> ", owrite, mail_newsgroup(m), mail_curmsg(m));
   fflush(stdout);
}

char *
biff(Mailfile *curm, char *line, int max)
{
   static Mailfile m;
   static int setup = 0;
   long size;
   time_t t = time(NULL);

#ifdef DEBUG
   fflush(stdout);
   fprintf(stderr, "biff: starting\n");
#endif

   if (!setup) {
      if (mail_init(&m, getrc(username)) == -1) {
         fprintf(stderr, "bmh: unable to check mail folder\n");
         exit(1);
         }
      setup = 1;
      }

   size = mail_size(&m);

   doprompt(curm);

   while (kbhit() == 0)
      if (time(NULL) > t + TimeOut) {
         long newsize = mail_size(&m);

         t = time(NULL);
         if (newsize == -1L)
            return getline(line, max);

         if (newsize < size)
            size = newsize;
         else if (newsize > size) {
            printf(newmail);
            doprompt(curm);
            return getline(line, max);
            }
         }
      else
         deschedule();

   if (mail_size(&m) > size) {
      printf(newmail);
      doprompt(curm);
      }

   return getline(line, max);
}
