/* bm.h -- definitons for bm.c that aren't included elsewhere */

/* types of config file lines that we know how to handle */
#define NONE	0
#define MAXLET	1
#define SMTP	2
#define HOST	3
#define USER	4
#define EDIT	6
#define NAME	7
#define REPLY	8
#define MBOX	9
#define RECORD	10
#define SCREEN	11

#ifdef UNIX
#define	RUNCOM	".bmrc"		/* config file */
#else
#define	RUNCOM	"/bm.rc"		/* config file */
#endif

#ifdef MSDOS
#define	MAXROWS		25	/* number of lines on display */
#define	MAXCOL		80	/* number of lines on display */
#else
#define	MAXROWS		24	/* number of lines on display */
#define	MAXCOL		80	/* number of lines on display */
#endif

/* message status */
#define	DELETE	1
#define	READ	2

#define NLET	300			/* default size of letter array */
#define MAXARGS	16

#define SLINELEN	64
#define LINELEN		256

/* a mailbox list entry */
struct let {
	long	start;
	long	size;
	int	status;
};

/* address structure */
struct addr {
	struct addr *next;
	char *user;
	char *host;
	int sent;
};

/* token used for a string and its token */
struct token {
	char *str;
	char type;
};

/* global definitions */
extern char
 	*hostname,		/* name of this host from rc file */
	*username,		/* name of this user from rc file */
	*fullname,		/* name of this user from rc file */
	*replyto,		/* return address fro reply-to */
	*maildir,		/* default mail directory */
	*editor,		/* user's favorite editor program */
	*savebox,		/* user's mbox for the s command */
	*record,		/* place to store a copy of snet mail for you */
	*mfilename;		/* for the -f option */

extern unsigned maxlet;		/* max messages */
extern int current;		/* the current message number */
extern int nmsgs;		/* number of messages in this mail box */
extern int newmsgs;		/* number of new messages in mail box */
extern int change;		/* mail file changed */
extern FILE *mfile;		/* mail data file pointer */
extern int	tty;		/* is standard in a tty ? */
extern int mlock(), rmlock();
extern struct addr *make_tolist();
extern long get_msgid();
extern char mailqdir[];
extern char mailspool[];
extern char mailqueue[];
extern char notename[];
extern char notefile[];
extern char nomail[];
extern char badmsg[];
extern struct let *mbox;
extern char *fgets(),*gets(),*savestr();
extern char *malloc(),*calloc();
extern void exit(),perror();
extern int parse(),htype();
extern int getrch(), screen_clear(), setrawmode(), setcookedmode();
extern char *getline();

/* Define null object pointer in case stdio.h isn't included */
#ifndef	NULL
/* General purpose NULL pointer */
#define	NULL (void *)0
#endif
#define	NULLCHAR (char *)0	/* Null character pointer */
#define	NULLFP	 (int (*)())0	/* Null pointer to function returning int */
#define	NULLVFP	 (void (*)())0	/* Null pointer to function returning void */
#define	NULLFILE (FILE *)0	/* Null file pointer */
#define	NULLADDR (struct addr *)0	/* Null address */

