/* bm.h -- definitons for bm.c that aren't included elsewhere */

#define FIDOROOT	"/fido"		/* location of fido root directory */

#if ( SYS5 || ATARI )
#define rindex	strrchr
#define index	strchr
#define BMRC	"\\bm.rc"		/* was: "./bm.rc" */
#define timezone	timezon
#else
#define BMRC	"/bm.rc"
#endif /* SYS5 */

/* types of config file lines that we know how to handle */
#define NONE	0
#define FIDO	1
#define SMTP	2
#define HOST	3
#define USER	4
#define EDIT	6
#define ZONE	7
#define NAME	8
#define REPLY	9
#define MAXLET	10

/* message status */
#define	DELETE	1
#define	READ	2

#define NLET	300

#define SLINELEN	64
#define LINELEN		128

/* a mailbox list entry */
struct let {
	long	start;
	long	size;
	int	status;
};


/* global definitions */
extern char
 	hostname[SLINELEN],	/* name of this host from rc file */
	username[SLINELEN],	/* name of this user from rc file */
	fullname[SLINELEN],	/* name of this user from rc file */
	replyto[SLINELEN],	/* return address fro reply-to */
#ifdef ATARI
/*	inreplyto[SLINELEN],	*/
#endif
#if ( SYS5 || ATARI )
	timezon[4],		/* users time zone */
#else
	timezone[4],		/* users time zone */
#endif /* SYS5 */
	maildir[LINELEN],	/* default mail directory */
	editor[SLINELEN];	/* user's favorite editor program */

extern unsigned maxlet;		/* max messages */
extern int current;		/* the current message number */
extern int nmsgs;		/* number of messages in this mail box */
extern int change;		/* mail file changed */
extern FILE *mfile;		/* mail data file pointer */
extern int mlock(),rmlock();
extern long get_msgid();
extern char mailqdir[];
extern char mailqueue[];
extern char notename[];
extern char notefile[];
extern char lockdir[];
extern struct let *mbox;
extern char *fgets(),*gets();
extern int	tty;

/* Define null object pointer in case stdio.h isn't included */
#ifndef	NULL
/* General purpose NULL pointer */
#define	NULL (void *)0
#endif
#define	NULLCHAR (char *)0	/* Null character pointer */
#define	NULLFP	 (int (*)())0	/* Null pointer to function returning int */
#define	NULLVFP	 (void (*)())0	/* Null pointer to function returning void */
#define	NULLFILE (FILE *)0	/* Null file pointer */

