/* bmutil.c */
#include <stdio.h>
#include <ctype.h>
#ifdef SYS5
#include <sys/types.h>
#include <sys/stat.h>
#else
#ifndef ATARI
#include <stat.h>
#endif ATARI
#endif /* SYS5 */
#include <fcntl.h>
#include "bm.h"
#include "header.h"

extern int bmmode;		/* NEW: mode (smtp, unix) */
char *getname();

initnotes()
{
	char 	tstring[LINELEN];
	register char	*p, *s;
	FILE	*tmpfile();
	long	ftell();
	FILE	*ifile;
	char	*index();
	int	sequence;
	int	len;
	long	cpos;
	register struct	let *cmsg;
	int	cut;

#ifndef ATARI
	if (mlock(maildir,notename)) {
		mfile = NULLFILE;
		printf("Mail file is busy\n");
		return;
	}
#endif
	if ((ifile = fopen(notefile,"r")) == NULLFILE) {
		printf("No mail for %s\n",notename);
		mfile = NULLFILE;
#ifndef ATARI
		rmlock(maildir,notename);
#endif
		return;
	}
	if ((mfile = tmpfile()) == NULLFILE) {
		printf("Unable to create tmp file\n");
		fclose(ifile);
#ifndef ATARI
		rmlock(maildir,notename);
#endif
		return;
	}
	nmsgs = 0;
	current = 1;
	change = 0;
	cmsg = NULL;
	while(!feof(ifile)) {
		cpos = ftell(ifile);
		fgets(tstring,LINELEN,ifile);
		fputs(tstring,mfile);
		/* scan for Received: i.e. begin of a message */
		if (bmmode == 0) {
			cut = RECEIVED;
		} else {
			cut = FROMUUCP;
		}
		if(htype(tstring) == cut) {
			if (nmsgs == maxlet) {
				printf("Mail box full: > %d messages\n",maxlet);
				fclose(mfile);
				fclose(ifile);
#ifndef ATARI
				rmlock(maildir,notename);
#endif
				exit(1);
			}
			nmsgs++;
			cmsg = &mbox[nmsgs];
			cmsg->start = cpos;
			cmsg->status = 0;
			cmsg->size = strlen(tstring);
			while (!feof(ifile)) {
				fgets(tstring,LINELEN,ifile); 
				fputs(tstring,mfile);
				cmsg->size += strlen(tstring);
				if (*tstring == '\n') /* dont header part */
					break;
			}
		} else if (cmsg) {
			cmsg->size += strlen(tstring);
		}
	}
	fclose(ifile);
#ifndef ATARI
	rmlock(maildir,notename);
#endif
}

/* list headers of a notesfile a message */
listnotes()
{
	register struct	let *cmsg;
	register char	*p, *s;
	char	smtp_date[LINELEN],
		smtp_from[LINELEN],
		smtp_subject[LINELEN], 
		tstring[256];
	char	*index();
	int	i;
	long	size;

	if (mfile == NULLFILE) {
		return;
	}

	printf(" Mailbox %s - %d messages\n\n",notename,nmsgs);
	for (cmsg = &mbox[1],i = 1; i <= nmsgs; i++, cmsg++) {
		*smtp_date = '\0';
		*smtp_from = '\0';
		*smtp_subject = '\0'; 
		fseek(mfile,cmsg->start,0);
		size = cmsg->size;
		while (!feof(mfile) && size > 0) {
			fgets(tstring,sizeof(tstring),mfile);
			if (*tstring == '\n')	/* end of header */
				break;
			size -= strlen(tstring);
			rip(tstring);
			/* handle continuation later */
			if (*tstring == ' '|| *tstring == '\t') 
				continue;
			switch(htype(tstring)) {
			case FROM:
				if((p = getname(tstring)) == NULLCHAR) {
					p = &tstring[6];
					while(*p && *p != ' ' && *p != '(')
						p++;
					*p = '\0';
					p = &tstring[6];
				}
				sprintf(smtp_from,"%.30s",p);
				break;
			case SUBJECT:
				sprintf(smtp_subject,"%.34s",&tstring[9]);
				break;
			case DATE:
				if ((p = index(tstring,',')) == NULLCHAR)
					p = &tstring[6];
				else
					p++;
				/* skip spaces */
				while (*p == ' ' || *p == '0') p++;
				if(strlen(p) < 17)
					break; 	/* not a valid length */
				s = smtp_date;
				/* copy day */
				if (atoi(p) < 10) {
					*s++ = ' ';
				} else
				*s++ = *p++;
				*s++ = *p++;

				*s++ = ' ';
				while (*p == ' ')
					p++;
				/* copy month */
				*s++ = *p++;
				*s++ = *p++;
				*s++ = *p++;
				while (*p == ' ')
					p++;
				/* skip year */
				while (isdigit(*p))
					p++;
				/* copy time */
				*s++ = *p++;	/* space */
				*s++ = *p++;	/* hour */
				*s++ = *p++;
				*s++ = *p++;	/* : */
				*s++ = *p++;	/* min */
				*s++ = *p++;
				*s = '\0';
				break;
			case STATUS:
				if (tstring[8] == 'R')
					cmsg->status |= READ;
				break;
			case NOHEADER:
				break;
			}
		}
		printf("%c%c%c%3d %-27.27s %-12.12s %5ld %.25s\n",
			(i == current ? '>' : ' '),
			(cmsg->status & DELETE ? 'D' : ' '),
			(cmsg->status & READ ? 'Y' : 'N'),
			i, smtp_from, smtp_date,
			cmsg->size, smtp_subject);
		if((i % 24) == 0) {
			printf(" - more -");
			if (getchar() == 'q')
				break;
		}	
	}
}

/*  save msg on stream - if noheader set don't output the header */
/*  assumes that mfile is already open for reading */
savemsg(msg,tfile,noheader)
int msg;
FILE *tfile;   /* already open for write */
int noheader;
{
	char	tstring[LINELEN];
	long 	size, totalsize, percent;
	int	lincnt = 1;			/* new: counts no. of lines */
	if (mfile == NULLFILE) {
		printf("No mail\n");
		return;
	}
	fseek(mfile,mbox[msg].start,0);
	size = mbox[msg].size;
	mbox[msg].status |= READ;
	
#ifdef ATARI
	if (tfile == stdout) {
		printf("\033EMessage %d:\n",msg);
	}
#endif
	if (noheader) {
		/* skip header */
		while (!feof(mfile) && size > 0) {
			fgets(tstring,LINELEN,mfile);
			size -= strlen(tstring);
			if (*tstring == '\n')
				break;
		}
	}
	/* this loop lists a message to stream tfile */
	totalsize = size;			/* DG2KK */
	while (!feof(mfile) && size > 0) {
		fgets(tstring,LINELEN,mfile);
		lincnt++;			/* DG2KK: linecounter! */
		if (strlen(tstring) > 79)
			lincnt++;
		size -= strlen(tstring);
		fputs(tstring,tfile);
		if (ferror(tfile)) {
			printf("Error writing mail file\n");
			fclose(tfile);
			fclose(mfile);
			exit(1);
		}
		/* DG2KK: added */
		if (tfile == stdout) {
			if ((lincnt % 23) == 0) {
				percent = 100 - (size * 100L) / totalsize;
				printf("\033p more (%ld%) \033q",percent);	/* reverse */
				if ((gemdos(7) & 0x7f) == 'q') {
					printf("\n");
					break;
				}
				printf("\033l");	/* delete a line */
			}
		}
	}
}

/*  delmsg - delete message in current notesfile */
delmsg(msg)
int msg;
{
	if (mfile == NULLFILE) {
		printf("No mail\n");
		return;
	}
	mbox[msg].status |= DELETE;
	change = 1;
	if (msg == current) 
		if (msg == nmsgs)
			current--;
		else
			current++;

}

/*  reply - to a message  */
reply(msg)
int msg;
{
	char 	to[LINELEN],
		mesid[30],			/* added */
		mes_id[30],
		subject[LINELEN],
		tstring[LINELEN];
	char 	*p,*s;
	long	size;
	FILE	*tfile;				/* added */

	if (mfile == NULLFILE) {
		printf("No mail\n");
		return;
	}
	*to = '\0';
	*subject = '\0';
	*mesid = '\0';
	fseek(mfile,mbox[msg].start,0);
	size = mbox[msg].size;
	while (!feof(mfile) && size > 0) {
		fgets(tstring,LINELEN,mfile);
		size -= strlen(tstring);
		if (*tstring == '\n') 	/* end of header */
			break;
		rip(tstring);
		if ((*to == '\0' && htype(tstring) == FROM)
			|| htype(tstring) == REPLYTO) { 
			s = getname(tstring);
			if (s == NULLCHAR) {
				p = index(tstring,':');
				p += 2;
				s = p;
				while(*p && *p != ' ' && *p != '(')
					p++;
				*p = '\0';
			}
			strcpy(to,s);
		} else if (htype(tstring) == SUBJECT)
			sprintf(subject,"Re: %s",&tstring[9]);	/* was: %s\n */
/**/
		/* extract message-id */
		if (*mesid == '\0' && htype(tstring) == MSGID) {
			sprintf(mes_id,"%s",&tstring[12]);
		}
/**/
	}
	if (*to == '\0')
		printf("No reply address in message\n");
	else {
		printf("To: %s\n",to);
		printf("Subject: %s\n",subject);
		printf("In-Reply-To: %s\n",mes_id);

		if ((tfile = fopen("\\xbm1.tmp","w+")) == NULLFILE)
			printf("\nCannot open temp file.\n");
		else {
			savemsg(msg,tfile,1);	/* no header */
			fseek(tfile,0L,0);
			dosmtpsend(tfile,to,subject,mes_id); /* was: NULLFILE */ 
			fclose(tfile);
		}
	}
}

/* close the temp file while coping mail back to the mailbox */
closenotes()
{
	register struct	let *cmsg;
	char tstring[LINELEN];
	long size;
	int i,c;
	int	fgetc(),fputc();
	long	end;
	FILE *nfile;
#ifdef ATARI
	int st_size;
#else
	struct stat mstat;
#endif

	if (mfile == NULLFILE)
		return;
	if (!change) {
		fclose(mfile);
		return;
	}
#ifndef ATARI
	while(mlock(maildir,notename)) {
		printf("Mail file is busy, Abort or Retry ? ");
		gets(tstring);
		if (*tstring == 'A' || *tstring == 'a') {
			printf("Changes lost\n");
			fclose(mfile);
			mfile = NULLFILE;
			return;
		}
	}
#endif

#ifdef ATARI
	st_size = stat(notefile);
	if (st_size < 0)
		printf("weird mstat.st_size: %d\n",st_size);
	else {
#else
	if (stat(notefile,&mstat))
		printf("unable to stat %s\n",notefile);
	else {
#endif
		fseek(mfile,0L,2);
		end = ftell(mfile);
#ifndef ATARI
		if (mstat.st_size > end) {
#else
		if (st_size > end) {
#endif
			printf("new mail has arrived\n");
			if ((nfile = fopen(notefile,"r")) == NULLFILE)
				printf("Unable to open %s\n",notefile);
			else {
			/* copy the new mail to the end of the tmp file */
				if (nmsgs == maxlet) {
					printf("Not enough room for new messages\n");
					printf("bm quiting. Mail file restored\n");
					fclose(mfile);
#ifndef ATARI
					rmlock(maildir,notename);
#endif
					exit(1);
				}
				nmsgs++;
				mbox[nmsgs].start = end;
				fseek(nfile,end,0);
				nmsgs++;
				size = 0L;
				while ((c = fgetc(nfile)) != EOF) {
					fputc(c, mfile);
					size++;
				}
				mbox[nmsgs].size = size;
				fclose(nfile);
				if (ferror(nfile))
					printf("Error writing temp file\n");
			}

		}
	}

	if ((nfile = fopen(notefile,"w")) == NULLFILE) {
		printf("Unable to open %s\n",notefile);
#ifndef ATARI
		rmlock(maildir,notename);
#endif
		return;
	}
	/* copy tmp file back to notes file */
	for (cmsg = &mbox[1],i = 1; i <= nmsgs; i++, cmsg++) {
		fseek(mfile,cmsg->start,0);
		size = cmsg->size;
		if ((cmsg->status & DELETE)) 
			continue;
		while (!feof(mfile) && size > 0) {
			fgets(tstring,LINELEN,mfile);
			fputs(tstring,nfile);
			size -= strlen(tstring);
			if (ferror(nfile)) {
				printf("Error writing mail file\n");
				fclose(nfile);
				fclose(mfile);
				exit(1);
			}
		}
	}
	nmsgs = 0;
	fclose(nfile);
	fclose(mfile);
	mfile = NULLFILE;
#ifndef ATARI
	rmlock(maildir,notename);
#endif
}

long 
get_msgid()
{

	char sfilename[LINELEN];
	char s[20];
	long sequence = 0L;
	FILE *sfile;
	long atol();

	strcpy(sfilename,mailqdir);
	strcat(sfilename,"sequence.seq");
	strcpy(sfilename,"c:\\uucp\\artid");	/* DG2KK: uucp sequence file */
	sfile = fopen(sfilename,"r");

	/* if sequence file exists, get the value, otherwise set it */
	if (sfile != NULLFILE) {
		fgets(s,sizeof(s),sfile);
		sequence = atol(s);
	/* Keep it in range of and 8 digit number to use for dos name prefix. */
		if (sequence < 0L || sequence > 99999999L )
			sequence = 0L;
		fclose(sfile);
	}

	/* increment sequence number, and write to sequence file */
	sfile = fopen(sfilename,"w");
	fprintf(sfile,"%ld\n",++sequence);	/* DG2KK: added \n */
	fclose(sfile);
	return sequence;
}

/* Given a string of the form <user@host>, extract the part inside the
 * brackets and return a pointer to it.
 */
char *
getname(cp)
register char *cp;
{
	char *cp1;

	if((cp = index(cp,'<')) == NULLCHAR){
		return NULLCHAR;
	}
	cp++;	/* cp -> first char of name */
	if((cp1 = index(cp,'>')) == NULLCHAR){
		return NULLCHAR;
	}
	*cp1 = '\0';
	return cp;
}

/* create mail lockfile */
int
mlock(dir,id)
char *dir;
char *id;
{
	char lockname[LINELEN];
	int fd;
	/* Try to create the lock file in an atomic operation */
	sprintf(lockname,"%s%.8s.lck",dir,id);
	if((fd = open(lockname, O_WRONLY|O_EXCL|O_CREAT)) == -1)
		return -1;
	close(fd);
	return 0;
}

/* remove mail lockfile */
int
rmlock(dir,id)
char *dir;
char *id;
{
	char lockname[LINELEN];
	sprintf(lockname,"%s%.8s.lck",dir,id);
	unlink(lockname);
}
