/*
   buf.h: Copyright 1993, Paul Healy.

   930503 : Created
*/
#ifndef _buf_h_
#define _buf_h_

typedef struct {
  uchar  *buffer;
  size_t size;
  uchar  *curp;
  uchar  *endp;

  int    eof;              /* finished this mail file flag */
  long   curpos;
  long   nextpos;
  long   filesize;
} buf;

void buf_init(buf *bp);
int buf_fill(int fd, buf *bp);
void buf_free(buf *bp, int cacheit);

#define buf_set(bp, offset) ((bp)->nextpos = offset)
void buf_reset(buf *bp);

char *buf_findF(buf *bp);
long buf_offset(buf *bp, uchar *p);

#define buf_curp(bp) ((bp)->curp)
#define buf_endp(bp) ((bp)->endp)
#define buf_bufp(bp) ((bp)->buffer)
#define buf_eob(bp)  (buf_curp(bp) == buf_endp(bp))
#define buf_eof(bp) (buf_eob((bp)) && ((bp)->eof))
#define buf_seteof(bp) ((bp)->curp = (bp)->endp, (bp)->eof = 1)

#define buf_setptr(bp, p) ((bp)->curp=(p))
#define buf_setend(bp, p) ((bp)->endp=(p))

#define buf_inc(bp) ((bp)->curp++)

#endif /* _buf_h_ */

