#ifndef	_CONFIG_H
#define	_CONFIG_H

/* Software options */
#define	MAILBOX		1	/* Include SM0RGV mailbox server */
#undef	NNTP		1	/* Netnews client */
#define	SERVERS		1	/* Include TCP servers */
#define	TRACE		1	/* Include packet tracing code */
#define	RIP		1	/* Include RIP routing */
#undef	HOPCHECK	1	/* IP path tracing command */
#undef	DIALER		1	/* SLIP redial code */
#define	NRS		1	/* NET/ROM async interface */
#define	NETROM		1	/* NET/ROM network support */
#undef	LZW		1	/* LZW-compressed sockets */
#undef	RLOGINCLI	1	/* Rlogin client code */
#define	SLIP		1	/* Serial line IP on built-in ports */
#undef	PPP		1	/* Point-to-Point Protocol code */
#undef	VJCOMPRESS	1	/* Van Jacobson TCP compression for SLIP */
#define	POP		1	/* Include POP2 Post Office Protocol */
#define	ESCAPE		1	/* Allow Unix style escape on PC */
#define	RSPF		1	/* Include Radio Shortest Path First Protocol */
#undef	AXIP		1	/* digipeater via ip port 93 interface */
#define	IPACCESS	1	/* Include IP access control code */
#define	RARP		1	/* Enable Reverse ARP protocol */
#define	LOCK		1	/* Password lockup for keyboard */
#define	DOSCMD		1	/* Enable the internal DOS commands */ 
#define	ALLCMD		1	/* Enable all commands */
#define	ALLSERV		1	/* Enable all server commands */
#define	MBFWD		1	/* Enable mailbox forwarding code */

/* Software tuning parameters */
#define	MTHRESH		16384	/* Default memory threshold */
#define	NROWS		25	/* Number of rows on screen */
#define	NIBUFS		5	/* Number of interrupt buffers */
#define	IBUFSIZE	2048	/* Size of interrupt buffers */
#define	NSESSIONS	10	/* Number of interactive clients */
#define	DEFNSOCK	40	/* Default number of sockets */

/* Hardware driver options */
#undef	ARCNET		1	/* ARCnet via PACKET driver */
#undef	PC_EC		1	/* 3-Com 3C501 Ethernet controller */
#define	KISS		1	/* KISS TNC code */
#undef	HS		1	/* High speed (56kbps) modem driver */
#undef	HAPN		1	/* Hamilton Area Packet Network driver code */
#undef	EAGLE		1	/* Eagle card driver */
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#undef	PC100		1	/* PAC-COM PC-100 driver code */
#undef	APPLETALK	1	/* Appletalk interface (Macintosh) */
#undef	DRSI		1	/* DRSI PCPA slow-speed driver */
#undef	SCC		1	/* PE1CHL generic scc driver */
#undef	PI		1	/* VE3IFB pi dma card scc driver */
#define	ASY		1	/* Asynch driver code */
#undef	SLFP		1	/* SLFP packet driver class supported */

#if defined(NRS)
#undef	NETROM
#define	NETROM		1	/* NRS implies NETROM */
#endif

#if (defined(HS)||defined(NETROM)||defined(KISS)||defined(HAPN)||defined(EAGLE)||defined(PC100)||defined(PI))
#define	AX25		1	/* AX.25 subnet code */
#endif

#if (defined(ARCNET) || defined(SLFP))
#undef	PACKET
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#endif

#if (defined(PC_EC) || defined(PACKET))
#define	ETHER	1		/* Generic Ethernet code */
#endif

#endif	/* _CONFIG_H */
