#ifndef	_CONFIG_H
#define	_CONFIG_H

/* Configuration file for direct internet PC access */

/* Software options */
#define	MAILBOX		1	/* Include SM0RGV mailbox server */
#define	NNTPCLIENT	1	/* Netnews client */
#define	POP2CLIENT	1	/* POP2 client -- IAB not recommended */
#define	POP2SERVER	1	/* POP2 server -- IAB not recommended */
#define	POP3CLIENT	1	/* POP3 client -- IAB draft standard */
#define POP3SERVER	1	/* POP3 server -- IAB draft standard */
#define	SMTPCLIENT	1	/* SMTP client */
#define	SMTPSERVER	1	/* SMTP server */
#define	SERVERS 	1	/* Include TCP servers */
#define	TRACE		1	/* Include packet tracing code */
#define REMOTE		1	/* Include remote access commands */
#define	RIP		1	/* Include RIP routing */
#define	HOPCHECK	1	/* IP path tracing command */
#define	DIALER		1	/* async dial code */
#undef	NRS		1	/* NET/ROM async interface */
#undef	NETROM		1	/* NET/ROM network support */
#undef	LZW		1	/* LZW-compressed sockets */
#define	SLIP		1	/* Serial line IP on built-in ports */
#define PPP		1	/* Point-to-Point Protocol code */
#define	BOOTP		1	/* Bootstrap protocol */
#define	TERMINAL	DUMB	/* Terminal emulator code */

/* Software tuning parameters */
#define	MTHRESH		8192	/* Default memory threshold */
#define	NROWS		25	/* Number of rows on screen */
#define	NIBUFS		5	/* Number of interrupt buffers */
#define	IBUFSIZE	2048	/* Size of interrupt buffers */
#define	NSESSIONS	10	/* Number of interactive clients */
#define DEFNSOCK	40	/* Default number of sockets */

/* Hardware driver options */
#undef	ARCNET		1	/* ARCnet via PACKET driver */
#undef	PC_EC		1	/* 3-Com 3C501 Ethernet controller */
#undef	KISS		1	/* KISS TNC code */
#undef	HS		1	/* High speed (56kbps) modem driver */
#undef	HAPN		1	/* Hamilton Area Packet Network driver code */
#undef	EAGLE		1	/* Eagle card driver */
#undef	PI		1	/*  PI card driver */
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#undef	PC100		1	/* PAC-COM PC-100 driver code */
#undef	APPLETALK	1	/* Appletalk interface (Macintosh) */
#undef	DRSI		1	/* DRSI PCPA slow-speed driver */
#undef	SCC		1	/* PE1CHL generic scc driver */
#define	ASY		1	/* Asynch driver code */
#define	SLFP		1	/* SLFP packet driver class supported */

#if defined(NRS)
#undef	NETROM
#define	NETROM		1	/* NRS implies NETROM */
#endif

#if (defined(HS)||defined(NETROM)||defined(KISS)||defined(HAPN)||defined(EAGLE)||defined(PC100)||defined(PI))
#define	AX25		1	/* AX.25 subnet code */
#endif

#if (defined(ARCNET) || defined(SLFP))
#undef	PACKET
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#endif

#if (defined(PC_EC) || defined(PACKET))
#define	ETHER	1		/* Generic Ethernet code */
#endif

#if (defined(POP2CLIENT) || defined(POP3CLIENT))
#define MAILCLIENT	1	/* Mail clients */
#endif

#if (defined(POP2SERVER)||defined(POP3SERVER)||defined(SMTPSERVER)||defined(REMOTE)||defined(RIP))
#undef	SERVERS
#define SERVERS		1	/* get TCP servers, too */
#endif

#if (defined(MAILBOX)||defined(MAILCLIENT)||defined(SMTPSERVER)||defined(REMOTE))
#undef	SMTPCLIENT
#define SMTPCLIENT	1	/* get SMTP client, too */
#endif
#endif	/* _CONFIG_H */
