#ifndef	_CONFIG_H
#define	_CONFIG_H
/* This is the configuration as distributed by WG7J */

/* Software options */
#define BOOTP 1
#define	MAILBOX		1	/* Include SM0RGV mailbox server */
#define CONVERS     1   /* Conference bridge (babble-box :-) */
/* Use only ONE of the 2 news options below !!! */
#define NNTP        1   /* Netnews client */
#undef NNTPS	      /* Netnews client and server */
#define SERVERS    1   /* Include TCP servers */
#define TRACE       1   /* Include packet tracing code */
#define RIP         1   /* Include RIP routing */
#define HOPCHECK    1   /* IP path tracing command */
#define DIALER      1   /* SLIP redial code */
#define NRS         1   /* NET/ROM async interface */
#define NETROM      1   /* NET/ROM network support */
#define LZW         1   /* LZW-compressed sockets */
#define RLOGINCLI   1   /* Rlogin client code */
#define SLIP        1   /* Serial line IP on built-in ports */
#define PPP         1   /* Point-to-Point Protocol code */
#define VJCOMPRESS  1   /* Van Jacobson TCP compression for SLIP */
#undef POP            /* Include POP2 Post Office Protocol */
#define POP2CLIENT  1   /* POP2 client -- IAB not recommended */
#define POP2SERVER  1   /* POP2 server -- IAB not recommended */
#define	POP3CLIENT	1	/* POP3 client -- IAB draft standard */
#define POP3SERVER	1	/* POP3 server -- IAB draft standard */
#undef ESCAPE         /* Allow Unix style escape on PC */
#define RSPF        1   /* Include Radio Shortest Path First Protocol */
#define AXIP        1   /* digipeater via ip port 93 interface */
#undef RARP           /* Include Reverse Address Resolution Protocol */
#define CALLBOOK    1   /* Simple callbook server over Internet */
#undef CALLSERVER      /* Include BuckMaster CDROM server support */
#undef CALLCLI         /* Include BuckMaster CDROM client code only  */
#define ATCMD       1   /* Include timed 'at' execution */
#define EXPIRY      1   /* Include message and bid expiry */
#define MBXTDISC    1   /* Include mailbox timeout-disconnect */
#define NR4TDISC    1   /* Include Netrom L4 timeout-disconnect */
#define FTPTDISC    1   /* Include ftp-server timeout disconnect */
#define TIPMAIL     1   /* Include TIP mailbox server */
#define IPACCESS    1   /* Include IP access control code */
#define ENCAP       1   /* Include IP encapsulation code */
#define AUTOROUTE   1   /* Include AX.25 IP auto-route code(causes problems when VC mode is used for ip) */
#define LOCK        1   /* Include keyboard locking */
#define MAILFOR     1   /* Include Mailbox 'Mail for' beacon */
#define RLINE       1   /* Include BBS R:-line interpretation code */
#define MBFWD       1   /* Include Mailbox AX.25 forwarding */
#define USERLOG 	1	/* Include last-message-read tracking for users */
#define MULTITASK   1   /* Include Dos shell multi-tasker */
#undef SHELL           /* Include shell command */
#define ALLSESSIONS 1   /* Include all session types */
/*if undefined, deletes outgoing telnet,ftp,ax25,netrom sessions */
#define ALLCMD     1    /* if undefined, exclude a bunch of commands */
/*excluded are:
 *   delete,rename,more,tail,dump,status,motd,cd,dir,finger,fkey,info,mail,mkdir
 *   pwd,record,rmdir,watch,test,upload
 */
#define ALLSERV      1   /* if undefined, exclude a bunch of servers */
/*excluded are:
 *echo,discard,tip and ttylink servers
 *and the ttylink command (with no split screen code anymore)
 */
#undef	NNTPSERVER		/* Netnews client + server */
#undef	POP			/* Include POP2 Post Office Protocol */
#define	NRS		1	/* NET/ROM async interface */
#define	RLOGINCLI	1	/* Rlogin client code */
#define	PPP		1	/* Point-to-Point Protocol code */
#define	RSPF		1	/* Include Radio Shortest Path First Protocol */
#undef	RARP			/* Enable Reverse ARP protocol */
#define	DOSCMD		1	/* Enable the internal DOS commands */
#define	CONVERS	1	/* Conference bridge (babbelbox) */
#undef	LPD			/* Dave Johnson's LPD server */
#undef	LPCLIENTS		/* Dave Johnson's LP clients (LPR,LPRM,LPQ) */

/* Software tuning parameters */
#define MTHRESH 	16384	 /* Default memory threshold */
#define NROWS       25      /* Number of rows on screen */
#define NIBUFS      0       /* Number of interrupt buffers */
#define IBUFSIZE    0    /* Size of interrupt buffers */
#define NSESSIONS   40      /* Number of interactive clients */
#define DEFNSOCK    100      /* Default number of sockets */
#define	NIBUFS		0	/* Number of interrupt buffers */
#define	IBUFSIZE	0	/* Size of interrupt buffers */

/* Hardware driver options */
#undef ARCNET         /* ARCnet via PACKET driver */
#undef PC_EC          /* 3-Com 3C501 Ethernet controller */
#define KISS        1   /* KISS TNC code */
#undef HS             /* High speed (56kbps) modem driver */
#undef HAPN           /* Hamilton Area Packet Network driver code */
#undef EAGLE          /* Eagle card driver */
#undef PACKET         /* FTP Software's Packet Driver interface */
#undef PC100          /* PAC-COM PC-100 driver code */
#undef APPLETALK      /* Appletalk interface (Macintosh) */
#undef DRSI           /* DRSI PCPA slow-speed driver */
#undef SCC            /* PE1CHL generic scc driver */
#undef PI             /* VE3IFB pi dma card scc driver */
#define ASY        1   /* Asynch driver code */
#undef SLFP           /* SLFP packet driver class supported */
#undef	ARCNET			/* ARCnet via PACKET driver */
#undef	PC_EC			/* 3-Com 3C501 Ethernet controller */
#undef	HS			/* High speed (56kbps) modem driver */
#undef	HAPN			/* Hamilton Area Packet Network driver code */
#undef	EAGLE			/* Eagle card driver */
#undef	PACKET			/* FTP Software's Packet Driver interface */
#undef	PC100			/* PAC-COM PC-100 driver code */
#undef	APPLETALK		/* Appletalk interface (Macintosh) */
#undef	DRSI			/* DRSI PCPA slow-speed driver */
#undef	SCC			/* PE1CHL generic scc driver */
#undef	PI			/* VE3IFB pi dma card scc driver */
#define	ASY		1	/* Asynch driver code */
#undef	SLFP			/* SLFP packet driver class supported */

#if defined(NRS)
#undef	NETROM
#define	NETROM		1	/* NRS implies NETROM */
#endif

#if (defined(AXIP)||defined(HS)||defined(NETROM)||defined(KISS)||defined(HAPN)||defined(EAGLE)||defined(PC100)||defined(PI))
#define	AX25		1	/* AX.25 subnet code */
#endif

#if (defined(ARCNET) || defined(SLFP))
#undef	PACKET
#define	PACKET		1	/* FTP Software's Packet Driver interface */
#endif

#if (defined(PC_EC) || defined(PACKET))
#define	ETHER	1		/* Generic Ethernet code */
#endif

#if defined(CALLSERVER)
#define CALLCLI     1
#endif

#if (defined(POP2CLIENT) || defined(POP2SERVER))
#undef POP 
#endif

#if (defined(POP2CLIENT) || defined(POP3CLIENT))
#define	MAILCLIENT	1
#undef POP 
#endif

#endif	/* _CONFIG_H */
