#include <stdio.h>
#include <modes.h>
#include <dir.h>


/* dirutil.c
 *        OSK directory reading stuff.
 *        Matthias Bohlen
 *        Copyright 1987 Matthias Bohlen, All Rights Reserved.
 *        Permission granted for non-commercial copying and use, provided
 *        this notice is retained.
 */

static DIR *d;
static struct direct *r;


/* wildcard filename lookup */
filedir (dirname, filemask, times, ret_str)
char *dirname, *filemask;
int times;
char *ret_str;
{
	register int masklen;
	
    masklen = strlen(filemask);
    
	if (times==0) {   /* first time */
		if ( (d=opendir(dirname)) == NULL ) {
			*ret_str = '\0';
			return;
		}
	}
	
	while (1) {
		if ( (r=readdir(d)) == NULL ) {
			*ret_str = '\0';
			closedir(d);
			return;
		}
		if (_cmpnam(r->d_name, filemask, masklen) == 0)
			if (r->d_name[0] != '.') {
				strcpy(ret_str, r->d_name);
				return;
			}
	}
}


rename(oldname,newname)
char *oldname, *newname;
{
	char cmdbuf[512];
	sprintf(cmdbuf, "rename %s %s", oldname, newname);
	system(cmdbuf);
}
