#define	BASE 0x380
#define	CTL 	(BASE+0)
#define	DATA	(BASE+1)

#define	KEYUP	105	/* Keyup delay: 105 bytes = 15 ms */
#define	TAIL	3	/* TX release delay */

char isat;

#include <stdio.h>
#include "8530.h"
#ifndef	foo
char buf[7000] = "Testing de KA9Q, Warren, NJ, using 56kbps MSK modem by WA4DSY";
#else
char buf[7000];
#endif

main()
{
	register int i;

	/* Reset and Initialize 8530 channel B */
	write_sio(CTL,R9,FHWRES);
	write_sio(CTL,R4,X1CLK|SDLC|SYNC_ENAB);
	write_sio(CTL,R1,0); /* Disable interrupts */
	write_sio(CTL,R3,Rx8|RxCRC_ENAB|RxENABLE);
	write_sio(CTL,R5,DTR|Tx8|TxENAB|TxCRC_ENAB);
	write_sio(CTL,R7,FLAG);
	write_sio(CTL,R9,0);	/* Interrupt bits off */
	write_sio(CTL,R10,CRCPS|NRZ);	/* NRZ mode */
	write_sio(CTL,R11,RCTRxCP|TCRTxCP); /* RxCLK = TRxCLK, TxCLK = RTxCLK */
	write_sio(CTL,R0,RES_EOM_L);	/* Clear end-of-message flag */

	txon();
	for(i=0;i<7;i++)
		send_buf(buf,sizeof(buf));
	txoff();
}
/* Transmit a buffer. The transmitter must already be on. */
send_buf(buf,n)
register char *buf;
register unsigned int n;
{
	write_sio(CTL,R0,RES_Tx_CRC);	/* Restart TX CRC calculation */

	/* Send data bytes */
	outportb(DATA,*buf++);
	n--;
	write_sio(CTL,R0,RES_EOM_L);	/* Clear end-of-message flag */
	while(n-- != 0){
		while(!(read_sio(CTL,R0) & Tx_BUF_EMP))
			;
		outportb(DATA,*buf++);
	}
	/* Wait for tx buffer empty to drop to indicate CRC going out */
	while(read_sio(CTL,R0) & Tx_BUF_EMP)
		;
	/* Now wait for the transmitter to become ready again,
	 * once CRC finishes
	 */
	while(!(read_sio(CTL,R0) & Tx_BUF_EMP))
		;
}
/* Turn on transmitter and wait for keyup delay. This is done by
 * starting a garbage frame, sending enough characters to allow
 * for the delay, and then aborting it.
 */
txon()
{
	register int i;

	/* Turn on transmitter */
	write_sio(CTL,R5,DTR|Tx8|TxENAB|TxCRC_ENAB|RTS);

	/* Send dummy frame */
	for(i=KEYUP;i != 0; i--){
		while(!(read_sio(CTL,R0) & Tx_BUF_EMP))
			;
		outportb(DATA,'\0');
	}
	/* Now abort it */
	write_sio(CTL,R0,SEND_ABORT);
}
/* Turn off transmitter. First start a new dummy frame to allow the last
 * data frame to get out, then abort it.
 */
txoff()
{
	register int i;

	/* Wait in case a CRC is just going out */
	while(!(read_sio(CTL,R0) & Tx_BUF_EMP))
			;
	write_sio(CTL,R0,RES_Tx_CRC);	/* Restart TX CRC calculation */
	write_sio(CTL,R0,RES_EOM_L);	/* Clear end-of-message flag */
	/* Send dummy frame */
	for(i=TAIL;i != 0; i--){
		while(!(read_sio(CTL,R0) & Tx_BUF_EMP))
			;
		outportb(DATA,'\0');
	}
	write_sio(CTL,R0,SEND_ABORT);			/* Abort frame */
	write_sio(CTL,R5,DTR|Tx8|TxENAB|TxCRC_ENAB);	/* Drop carrier */
}

