MODEL        equ        0
        include lmacros.h
        assume        ds:dataseg
        public        intds,sssave,spsave,intds,intstk,doret

; ec0vec - Ethernet interrupt handler
        public        ecint_,ec0vec_

ec0vec_ proc        far
        push        ds                ; save on user stack
        mov        ds,cs:intds        ; establish interrupt data segment

        mov        ds:sssave,ss        ; stash user stack context
        mov        ds:spsave,sp

        mov        ss,cs:intds        ; set up interrupt stack
        lea        sp,intstk+512

        push        ax                ; save user regs on interrupt stack
        push        bx
        push        cx
        push        dx
        push        bp
        push        si
        push        di
        push        es
        mov        es,cs:intds        ; set up es reg, so di can be used!!

        mov        ax,0                ; arg for service routine
        push        ax
        call        ecint_
        pop        ax
        jmp        doret
ec0vec_        endp

; fast buffer I/O routines -- used by 3-COM Ethernet controller

; outbuf - put a buffer to an output port
        procdef outbuf,<<oport,word>,<obuf,word>,<ocnt,word>>
        pushf
        push        si
        mov        dx,oport
        mov        cx,ocnt
        mov        si,obuf
        cld

xb:        lodsb                ; do { al = *si++;
        out        dx,al        ; out(dx,al);
        loop        xb        ; } while(--cx != 0);

        pop        si
        popf
        pret
        pend        outbuf

; inbuf - get a buffer from an input port
        procdef inbuf,<<iport,word>,<ibuf,word>,<icnt,word>>
        pushf
        push        di
        mov        dx,iport
        mov        cx,icnt
        mov        di,ibuf
        cld

rb:        in        al,dx        ; do { al = in(dx);
        stosb                ; *di++ = al;
        loop        rb        ; } while(--cx != 0);

        pop        di
        popf
        pret
        pend        inbuf

        end

