/*
   expirbid.c : Copyright Paul Healy, EI9GL, 1992.

   [ doesn't make much sense to try and expire non-time stamped bids? ]

   920913 : Created.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <io.h>
#include <ctype.h>
#include "config.h"
#include "rc.h"
#include "misc.h"
#include "help.h"
#include "lock.h"
#include "mailer.h"
#include "expirlib.h"

#ifdef BMH
#define main expirbid_main
#endif

static int Verbose = 0;

static int
expirebids(FILE *oldfp, FILE *newfp, int days)
{
   char line[MAXNAMLEN];
   time_t datum = time(NULL) - (days <= 0 ? DefaultAge : days) * 24 * 60 * 60;
   char bid[64];
   time_t bidt;
   int res;

   while (fgets(line, sizeof(line), oldfp) != NULL) 
      if ( (res = sscanf(line, "%s %ld", bid, &bidt)) == 2) {
         if (Verbose)
            fprintf(stderr, "expirbid: looking at %s %ld (%s)\n", bid, bidt);
         if (bidt >= datum) {
            if (fprintf(newfp, "%s %ld\n", bid, bidt) == EOF) {
               fprintf(stderr, "expirbid: error writing new history file\n");
               return -1;
               }
            else
               return dupfile(oldfp, newfp);
            }
         }
      else if (res == 1)
         if (fprintf(newfp, "%s %ld\n", bid, time(NULL)) == EOF) {
            fprintf(stderr, "expirbid: error writing new history file\n");
            return -1;
            }
         else {
            fprintf(stderr, "expirbid: bad return from scanf %d\n", res);
            return -1;
            }

   return 0;
}

int
main(int argc, char *argv[])
{
   if (dohelp(argc, argv, "expirbid [<days>] [-verbose] (expire ax25 pbbs bids)"))
      return 0;

   Verbose = isflag("-verbose", argc, argv);

   return updatef("expirbid", getrc(spooldir), "history", "",
      expirebids, argc, argv);
}
