/*
   forw.c : Copyright Paul Healy, EI9GL, 1992.

   920802 : Created.
*/
#include <stdio.h>
#include "config.h"
#include "buf.h"
#include "mailfile.h"
#include "bmh.h"
#include "rc.h"
#include "misc.h"
#include "help.h"
#include "send.h"
#include "header.h"
#include "mailer.h"
#include "message.h"
#include "extract.h"

#ifdef BMH
#define main forw_main
#endif

int
forw(Mailfile *m, int argc, char *argv[])
{
   char filename[MAXNAMLEN];

   if (mail_getfile(m, argc, argv, "forw") == -1)
      return -1;
   else if (mktemplate("forw", filename, "", "", "----- Forwarded message -----\n", 0) == -1)
      return -1;
      
   if ( (append("forw", m, filename, mail_thismsg(m, argc, argv)) == -1) ||
        (addstr("forw", filename, "----- End of forwarded message -----\n") == -1) ||
        (call_ed("forw", filename) == -1)
      ) {
      unlink(filename);
      return -1;
      }

   return dowhatnow("forw", filename, dosend);
}

int
main(int argc, char *argv[])
{
   Mailfile m;

   if (dohelp(argc, argv, "forw [msg] (forward a message)"))
      return 0;

   mail_zero(&m);

   forw(&m, argc, argv);

   return mail_savestate(&m);
}
