/*
	This is a test program for the AFT system.

	Send and receive frames.  Machine dependant for the PC with
	async driver installed.  Requires Microsoft C 4.0.
*/

#include "stdio.h"
#include "conio.h"
#include "dos.h"
#include "fcntl.h"
#include <sys\types.h>
#include <sys\stat.h>
#include "io.h"
#include "stdlib.h"

int async_handle;

main()
{
	printf("Copy data from ASYNC2: to CON:\n");

	async_handle = open("ASYNC2", O_RDWR | O_BINARY);

	if (async_handle == -1) {
		printf("Open of async driver failed. errno=%d\n", errno);
		printf("Make sure ASYNC.BIN is included in CONFIG.SYS.\n");
		exit(1);
	}

	while (1) {

		if (async_char_waiting()) printf("%c",async_get_char());

		if (kbhit()) {

			if (getch() == 0x1b) exit(0);
		}

	}
}

async_char_waiting()
{
	union REGS inregs, outregs;

	inregs.h.ah = 0x44;	/* I/O control function */
	inregs.h.al = 0x06;	/* Input status */
	inregs.x.bx = async_handle;

	intdos(&inregs, &outregs);

	return outregs.x.ax != 0;
}

async_get_char()
{
	char c;

	if (read(async_handle, &c, 1) != 1) {
		printf("No data waiting for read!!!\n");
		return 0x7e;
	}

	return c;
}


