/*
   g e t m s g i d . c 

   smtp queue management routines

   Taken from bm.

   Copyright 1986 Bdale Garbee, All Rights Reserved.
   Permission granted for non-commercial copying and use, provided
   this notice is retained.
   Copyright 1987 1988 Dave Trulli NN2Z, All Rights Reserved.
   Permission granted for non-commercial copying and use, provided
   this notice is retained.

*/

#include <stdio.h>
#include "lock.h"
#include "rc.h"


/*
 * get a message id from the sequence file
 */
long get_msgid(char *mqueue)
{
   FILE *sfile = fopenlocked(mqueue, "sequence", ".seq", "r+");
   long sequence = 0L;

   /*
    *  if sequence file exists, get the value, otherwise set it
    */
   if (sfile != NULL) {
      if ( fscanf(sfile, "%ld", &sequence) == EOF)
         sequence = -1L;
      else {
         /*
          *  Keep it in range, use 8 digit number for DOS name prefix.
          */
         if ( (sequence < 0L) || (sequence > 99999999L) )
            sequence = 0L;
         if (fseek(sfile, 0L, SEEK_SET) != 0)
            sequence = -1L;
         }
      }
   else {
      fprintf(stderr, "get_msgid: creating sequence file\n");
      if ( (sfile = fopenlocked(mqueue, "sequence", ".seq", "w")) == NULL)
         return -1L;
      }

   if (sequence != -1L)
      fprintf(sfile, "%ld", ++sequence);

   fcloselocked(sfile, mqueue, "sequence");

   return(sequence);
}

