/*
   header.h : Copyright Paul Healy, EI9GL, 1992.
*/
#ifndef _header_h_
#define _header_h_

extern char *Hdr[];

typedef enum {
   CC,
   DATE,
   FROM,
   MESSAGEID,
   NEWSGROUPS,
   RECEIVED,
   REPLYTO,
   SENDER,
   STATUS,
   SUBJECT,
   TO,
#ifdef AX25BBS
   XBBSMSGTYPE,
#endif
   UNKNOWN, NOHEADER } Header;

#define MAXHDR UNKNOWN

typedef struct {
   char *header[MAXHDR];
   char  buf[HDRBUFLEN];
   char *hwm;               /* points to first free space */
   Header lasth;
   } Header_t;

#define HEADER(ht, h) ht.header[h]
#define HEADERP(hp, h) hp->header[h]

int gethdrf(FILE *fp, Header_t *h);
#ifdef _mailfile_h_
int gethdrb(Mailfile *m, Header_t *h);
#endif
FILE *gethdrfn(char *filename, Header_t *h);

int putuhdr(FILE *fp, Header_t *h);

void hdr_init(Header_t *h);
int hdr_add(Header_t *h, Header hdr, char *s);

#ifdef _send_h_
long putrfc822(FILE *fp, Header_t *h, struct addr *tolist, struct addr *cclist);
#endif

int dosend(FILE *fp, Header_t *h);

#endif
