/* split an RLI/MBL import file into multiple bulletins */
/* copyright 1991 by PE1CHL */

#include <stdio.h>
#include <time.h>
#include <ctype.h>
#ifdef __TURBOC__
#include <stdlib.h>
#include <string.h>
#endif

/* States for send line parser state machine */

#define	    SKIP_CMD	    1
#define	    LOOK_FOR_USER   2
#define	    IN_USER	    3
#define	    AFTER_USER	    4
#define	    LOOK_FOR_HOST   5
#define	    IN_HOST	    6
#define	    AFTER_HOST	    7
#define	    LOOK_FOR_FROM   8
#define	    IN_FROM	    9
#define	    AFTER_FROM	    10
#define	    LOOK_FOR_MSGID  11
#define	    IN_MSGID	    12
#define	    FINAL_STATE	    13
#define	    ERROR_STATE	    14

char s_to[40],s_host[40],s_from[40],s_msgid[40];

main (argc,argv)
    int argc;
    char *argv[];

{
    FILE *wrk,*txt;
    unsigned int num;
    char tmp[80];
    char linebuf[512];

    if (argc != 4)
    {
	fprintf(stderr,"Usage: import <source> <receiver> <bbs>\n");
	fprintf(stderr,"e.g.:  import uosat3 pe1chl pi8utr\n");
	return 1;
    }

    num = (unsigned int)time(NULL);

    while (fgets(linebuf,sizeof(linebuf) - 1,stdin) != NULL)
    {
	if (strncmp(linebuf,"SB ",3))
	    continue;

	s_to[0] = s_host[0] = s_from[0] = s_msgid[0] = '\0';
	parse_send(linebuf);

	sprintf(tmp,"B%u.wrk",num);
	printf("Job: %s To: %s@%s From: %s Bid: %s\n",tmp,s_to,s_host,s_from,s_msgid);

	if ((wrk = fopen(tmp,"w")) == NULL)
	{
	    perror(tmp);
	    return 1;
	}

	fprintf(wrk,"%s.bbs\n",argv[3]);
	fprintf(wrk,"%s\n",argv[2]);
	fprintf(wrk,"%s%%%s@%s.bbs\n",s_to,s_host,argv[3]);

	fclose(wrk);

	sprintf(tmp,"B%u.txt",num++);
	if ((txt = fopen(tmp,"w")) == NULL)
	{
	    perror(tmp);
	    return 1;
	}

	fprintf(txt,"Received: from %s by %s with BROADCAST\n",argv[1],argv[2]);

	if (s_msgid[0])
	    fprintf(txt,"Message-Id: <%s>\n",s_msgid);

	if (s_from[0])
	    fprintf(txt,"From: %s\n",s_from);

	if (fgets(linebuf,sizeof(linebuf) - 1,stdin) != NULL)
	    fprintf(txt,"Subject: %s",linebuf);

	fprintf(txt,"X-BBS-Msg-Type: B\n");

	while (fgets(linebuf,sizeof(linebuf) - 1,stdin) != NULL &&
	       strncmp(linebuf,"/EX",3))
	    fprintf(txt,"%s",linebuf);

	fclose(txt);
    }

    return 0;
}

/* this part is from W9NK's AX.25 BBS.  it is not completely okay, but  */
/* let's live with it for now....                                       */

parse_send (cp)
    char *cp;

{
    int state;
    char *user,*host,*from,*msgid;
    int userlen = 0,hostlen = 0,fromlen = 0,msgidlen = 0;

    for (state = SKIP_CMD; state < FINAL_STATE; cp++) {
#ifdef MBDEBUG
	printf("MBX: State is %d, char is %c\n", state, *cp);
#endif
	switch (state) {
	    case SKIP_CMD:
		if (*cp == '\0')
		    state = ERROR_STATE;	/* no user */
		else if (isspace(*cp))
		    state = LOOK_FOR_USER;
		break;
	    case LOOK_FOR_USER:
		if (*cp == '\0' || *cp == '@' || *cp == '<' || *cp == '$')
		    state = ERROR_STATE;	/* no user */
		else if (!isspace(*cp)) {	/* found start of user */
		    user = cp;			/* point at start */
		    userlen++;			/* start counting */
		    state = IN_USER;
		}
		break;
	    case IN_USER:
		switch (*cp) {
		    case '\0':			/* found username only */
			state = FINAL_STATE;
			break;
		    case '@':
			state = LOOK_FOR_HOST;	/* hostname should follow */
			break;
		    case '<':
			state = LOOK_FOR_FROM;	/* from name should follow */
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* message id should follow */
			break;
		    default:
			if (isspace(*cp))
			    state = AFTER_USER; /* white space */
			else
			    userlen++;		/* part of username */
		}
		break;
	    case AFTER_USER:
		switch (*cp) {
		    case '\0':
			state = FINAL_STATE;	/* found username only */
			break;
		    case '@':
			state = LOOK_FOR_HOST;	/* hostname follows */
			break;
		    case '<':
			state = LOOK_FOR_FROM;	/* fromname follows */
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* message id follows */
			break;
		    default:
			if (!isspace(*cp))
			    state = ERROR_STATE;
		}
		break;
	    case LOOK_FOR_HOST:
		switch (*cp) {
		    case '\0':			/* user@? */
		    case '@':			/* user@@ */
		    case '<':			/* user@< */
		    case '$':			/* user@$ */
			state = ERROR_STATE;
			break;
		    default:
			if (!isspace(*cp)) {
			    host = cp;
			    hostlen++;
			    state = IN_HOST;
			}
		}
		break;
	    case IN_HOST:
		switch (*cp) {
		    case '\0':
			state = FINAL_STATE;	/* found user@host */
			break;
		    case '@':
			state = ERROR_STATE;	/* user@host@? */
			break;
		    case '<':
			state = LOOK_FOR_FROM;	/* fromname follows */
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* message id follows */
			break;
		    default:
			if (isspace(*cp))
			    state = AFTER_HOST;
			else
			    hostlen++;
		}
		break;
	    case AFTER_HOST:
		switch (*cp) {
		    case '\0':
			state = FINAL_STATE;	/* user@host */
			break;
		    case '@':
			state = ERROR_STATE;	/* user@host @ */
			break;
		    case '<':
			state = LOOK_FOR_FROM;	/* user@host < */
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* user@host $ */
			break;
		    default:
			if (!isspace(*cp))
			    state = ERROR_STATE;/* user@host foo */
		}
		break;
	    case LOOK_FOR_FROM:
		switch (*cp) {
		    case '\0':			/* user@host <? */
		    case '@':			/* user@host <@ */
		    case '<':			/* user@host << */
		    case '$':			/* user@host <$ */
			state = ERROR_STATE;
			break;
		    default:
			if (!isspace(*cp)) {
			    from = cp;
			    fromlen++;
			    state = IN_FROM;
			}
		}
		break;
	    case IN_FROM:
		switch (*cp) {
		    case '\0':
			state = FINAL_STATE;	/* user@host <foo */
			break;
		    case '<':
			state = ERROR_STATE;	/* user@host <foo< */
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* message id follows */
			break;
		    default:
			if (isspace(*cp))
			    state = AFTER_FROM;
			else
			    fromlen++;
		}
		break;
	    case AFTER_FROM:
		switch (*cp) {
		    case '\0':
			state = FINAL_STATE;	/* user@host <foo */
			break;
		    case '@':			/* user@host <foo @ */
		    case '<':			/* user@host <foo < */
			state = ERROR_STATE;
			break;
		    case '$':
			state = LOOK_FOR_MSGID; /* user@host <foo $ */
			break;
		    default:
			if (!isspace(*cp))
			    state = ERROR_STATE;/* user@host foo */
		}
		break;
	    case LOOK_FOR_MSGID:
		if (*cp == '\0')
		    state = ERROR_STATE;	/* msgid = $? */
		else if (isspace(*cp))
		    state = ERROR_STATE;	/* user@host <foo $ bar */
		else {
		    msgid = cp;
		    msgidlen++;
		    state = IN_MSGID;
		}
		break;
	    case IN_MSGID:
		if (*cp == '\0')
		    state = FINAL_STATE;
		else if (isspace(*cp))
		    state = FINAL_STATE;
		else
		    msgidlen++;
		break;
	    default:
		/* what are we doing in this state? */
		state = ERROR_STATE;
	}
    }

    if (state == ERROR_STATE)
	return -1;     /* syntax error */

    strncpy(s_to,user,userlen);
    s_to[userlen] = '\0';

    for (cp = s_to; *cp != '\0'; cp++)
	*cp = tolower(*cp);

    strncpy(s_host,host,hostlen);
    s_host[hostlen] = '\0';

    for (cp = s_host; *cp != '\0'; cp++)
	*cp = tolower(*cp);

    strncpy(s_from,from,fromlen);
    s_from[fromlen] = '\0';

    for (cp = s_from; *cp != '\0'; cp++)
	*cp = tolower(*cp);

    strncpy(s_msgid,msgid,msgidlen);
    s_msgid[msgidlen] = '\0';

    return 0;
}

