/*
   letter.c: Copyright 1993, Paul Healy.

   930616 : Created
*/
#include <string.h>
#include "letter.h"

folder
let_setup(int maxmsg)
{
   folder f = (folder) malloc(sizeof(letter)*maxmsg);

   if (f == NULL) {
      fprintf(stderr, "bmh: no room for folder information\n");
      return NULL;
      }
   else {
      memset(f, 0, sizeof(letter)*(maxmsg+3));
      f[LET_CURMSG] = (letter) 0L;
      f[LET_MAXMSG] = (letter) maxmsg;

      return f;
      }

   return 0;
}

int
let_setrange(folder f, int lo, int hi, long flag)
{
   int i;

   if (hi>let_maxmsg(f))
      hi =let_maxmsg(f);
   if (lo<1)
      lo=1;
   if (hi>f[LET_CURMSG])
      f[LET_CURMSG] = hi;

   hi+=LET_MSG0;

   for (i=lo+LET_MSG0; i<=hi; i++)
      f[i]|=flag;

   return 0;
}

int
let_unsetrange(folder f, int lo, int hi, long flag)
{
   int i;

   for (i=lo; i<=hi; i++)
      let_unset(f, i, flag);
   if (msg>f[LET_CURMSG])
      f[LET_CURMSG] = msg;
   if (msg<f[LET_MAXMSG]) {
      f[msg]&=flag;
      return 0;
      }
   else
      return -1;
}

#ifdef notdef

long
let_setstart(folder f, int msg, long start)
{
   if (msg>f[LET_CURMSG])
      f[LET_CURMSG] = msg;
   if (msg<f[LET_MAXMSG]) {
      f[msg] = (f[msg] & Let_flags) | start;
      return start;
      }
   else
      return -1L;
}

long
let_getstart(folder f, int msg)
{
   if (msg>f[LET_CURMSG])
      return -1L;
   else
      return f[msg] & Let_length;
}

int
let_save(folder f, char *name, int curmsg)
{

}

int
let_load(folder f, char *name)
{

}

static char bitmask[] = { 1, 2, 4, 8, 0x10, 0x20, 0x40, 0x80 };

int
mail_markasread(Mailfile *m, int msg)
{
   int index = msg >> 3;

   if (index >= MAIL_MAXIDX)
      return -1;
   else {
      m->isreadidx[index] |= bitmask[ msg & 0x7 ];

      return msg;
      }
}

int
mail_markread(Mailfile *m, int argc, char *argv[])
{
   int i, j;

   for (i=1; i<argc; i++)
      if (isdigit(argv[i][0])) {
         char *p = strchr(argv[i], '-');
         int first = atoi(argv[i]);

         if ( p != NULL) {
            int last=atoi(p+1);

            for (j=first; j<=last; j++)
               mail_markasread(m, j);
            }
         else
            mail_markasread(m, first);
         }
   return 0;
}

int
mail_isread(Mailfile *m, int msg)
{
   int index = msg >> 3;

   return index >= MAIL_MAXIDX ? 0 : m->isreadidx[index] & bitmask[msg & 0x7];
}

/*
 * should possibly do some bit shifting after a delete message operation
 * but this is simpler for the moment. Shifting seems nasty.
 */
int
mail_resetread(Mailfile *m, int msg)
{
   int index = (msg >> 3) + 1;
   int bit = msg & 0x7;
   int i;

   for (i=msg; i<=msg+bit; i++)
      mail_markasread(m, i);

   for (i=index; i<MAIL_MAXIDX; i++)
      m->isreadidx[i] = 0;

   return 0;
}

/* ----------------------------------------------------------------------- */
#define MAIL_MAXIDX 256       /* 256 is enough for 2048 messages */
   char isreadidx[MAIL_MAXIDX];
int mail_markasread(Mailfile *m, int msg);
int mail_markread(Mailfile *m, int argc, char *argv[]);
int mail_isread(Mailfile *m, int msg);
int mail_resetread(Mailfile *m, int lowmsg);

#endif
