/* Internet LPD Client definitions
 *   written by David Johnson (dave@cs.olemiss.edu)
 *
 * This code is in the public domain.
 *
 * Revision History:
 *
 * Revision 1.0  91/09/04  dave
 * Initial Release
 *
 */
#ifndef	_LP_H
#define	_LP_H

/* Definitions common to both LP servers and clients */
#define	BLOCKSIZE	1024	/* Chunk size for file I/O */
#define YIELD		pwait(NULL)

/*
 * Defaults
 */
#define D_LP		"lp"


/* Queue status flag values */
#define PRINT_ENABLED 0x01
#define QUEUE_ENABLED 0x02
#define FORCE_REQUE   0x04	/* force unspooler to reread queue */
#define PAUSED        0x08	/* waiting for next sheet */

/* LPD commands */
#define	START_CMD	1
#define	RECEIVE_CMD	2
#define	SQUEUE_CMD	3
#define	QUEUE_CMD	4
#define	REMOVE_CMD	5

/* LPD subcommands */
#define ABORT_SCMD	1
#define RECEIVE_CF_SCMD	2
#define RECEIVE_DF_SCMD	3

/* LPD return status */
#define STATUS_OK	0
#define STATUS_ERR	1

/* Status responses. Correspond to above return values */
#define RESPOND_OK(s)	send(s,"\0",1,0)
#define RESPOND_ERR(s)	send(s,"\1",1,0)
#define GET_RESPONSE(s)	rrecvchar(s)

#endif	/* _LP_H */
