;==========================================================================;
; Individual COM Blocks                                                    ;
;                                                                          ;
;   Copyright 1986, 1987, 1990 by H. Roy Engehausen.  All rights reserved. ;
;   This software may be freely distributed and used, but it may not       ;
;   under any circumstances be sold by anyone other than the author.       ;
;   It may be distributed by a commercial company as long as it is         ;
;   for no cost.                                                           ;
;                                                                          ;
;   This is where you customized the hardware configuration for your setup.;
;   You should have one com_block for each COM port you want supported.    ;
;==========================================================================;

com1:

           DW      OFFSET com2      ; Next com block
           DW      ?                ; Segment of current receive buffer
           DW      ?                ; Segment of current transmit buffer
           DB      0                ; Comm number - 1
           DB      chip_8250        ; Chip type
           DW      0                ; Offset to common chip info
           DB      0                ; Flag byte
           DB      opt_trbuf        ; Option byte
           DB      ?                ; Data rate for this line
           DB      ?                ; Last receive status
           DB      0CH              ; Hardware interrupt vector number
           DW      3F8H             ; Base port address
           DB      0EFH             ; Interrupt mask
           DW      ?                ; Buffer in pointer - Receive
           DW      ?                ; Buffer out pointer - Receive
           DW      ?                ; Buffer in pointer - Transmit
           DW      ?                ; Buffer out pointer - Transmit
           DW      ?                ; Buffer seg pointer - Receive
           DW      ?                ; Buffer seg pointer - Transmit

                                    ; Variable section for 8530

           DW      ?                ; Time since DCD
           DW      ?                ; Time since last transmit event

           DB      ?                ; Number of transmit event in progress

           DB      63               ; P-Persistance
           DB      2                ; Slot time
           DW      3                ; TXD
           DW      2                ; CRC wait
           DW      4770             ; Clock speed
           DB      1                ; Card type
           DB      0                ; Kiss type
           DB      0                ; Kiss flag

com2:

           DW      OFFSET 0         ; Next com block
           DW      ?                ; Segment of current receive buffer
           DW      ?                ; Segment of current transmit buffer
           DB      1                ; Comm number - 1
           DB      chip_8250        ; Chip type
           DW      0                ; Offset to common chip info
           DB      0                ; Flag byte
           DB      opt_trbuf        ; Option byte
           DB      ?                ; Data rate for this line
           DB      ?                ; Last receive status
           DB      0BH              ; Hardware interrupt vector number
           DW      2F8H             ; Base port address
           DB      0F7H             ; Interrupt mask
           DW      ?                ; Buffer in pointer - Receive
           DW      ?                ; Buffer out pointer - Receive
           DW      ?                ; Buffer in pointer - Transmit
           DW      ?                ; Buffer out pointer - Transmit
           DW      ?                ; Buffer seg pointer - Receive
           DW      ?                ; Buffer seg pointer - Transmit

                                    ; Variable section for 8530

           DW      ?                ; Time since DCD
           DW      ?                ; Time since last transmit event

           DB      ?                ; Number of transmit event in progress

           DB      63               ; P-Persistance
           DB      2                ; Slot time
           DW      3                ; TXD
           DW      2                ; CRC wait
           DW      4770             ; Clock speed
           DB      1                ; Card type
           DB      0                ; Kiss type
           DB      0                ; Kiss flag

com3:

           DW      0                ; Next com block
           DW      ?                ; Segment of current receive buffer
           DW      ?                ; Segment of current transmit buffer
           DB      2                ; Comm number - 1
           DB      chip_8530        ; Chip type
           DW      OFFSET chip_tie1 ; Offset to common chip info
           DB      0                ; Flag byte
           DB      0                ; Option byte
           DB      ?                ; Data rate for this line
           DB      ?                ; Last receive status
           DB      0BH              ; Hardware interrupt vector address
           DW      304H             ; Base port address -- PORT "B"
           DB      0F7H             ; Interrupt mask
           DW      ?                ; Buffer in pointer - Receive
           DW      ?                ; Buffer out pointer - Receive
           DW      ?                ; Buffer in pointer - Transmit
           DW      ?                ; Buffer out pointer - Transmit
           DW      ?                ; Buffer seg pointer - Receive
           DW      ?                ; Buffer seg pointer - Transmit

                                    ; Variable section for 8530

           DW      ?                ; Time since DCD
           DW      ?                ; Time since last transmit event

           DB      ?                ; Number of transmit event in progress

           DB      63               ; P-Persistance
           DB      2                ; Slot time
           DW      3                ; TXD
           DW      2                ; CRC wait
           DW      4770             ; Clock speed
           DB      1                ; Card type
           DB      0                ; Kiss type
           DB      0                ; Kiss flag

;==========================================================================;
; Common chip tie ins                                                      ;
;==========================================================================;

chip_tie1:                                ; tie in for 8530 -- PACCOMM
                 DW        0              ; Channel A
                 DW        0              ; Channel B
                 DB        0              ; Modem control byte
                 DB        0              ; Clock control byte
