/*
   mkpath.c : Paul Healy, EI9GL.

   920816 : Added this header, bmh version.
            Todo:
               . check that the date is ok for nntp
               . generally check file writes for success
   921108 : moved makepath routines to mkpath.c

 * NNTP Server/Client - See RFC977
 * Jeffrey R. Comstock. - NR0D - Bloomington, Minnesota USA
 * Copyright 1990 Jeffrey R. Comstock, All Rights Reserved.
 * Permission granted for non-commercial copying and use, provided
 * this notice is retained.
 *
 * DB3FL 9107xx: heavily rewritten and bug fixing in file-handling
 *
 * ported to NOS by PE1NMB - 920120
 *
 * Mods by PA0GRI and WG7J
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dir.h>
#include <io.h>
#include "mkpath.h"

#undef PATHDEBUG

static int
makedir(char *path)
{
   if (path == NULL)
      return -1;
#ifdef PATHDEBUG
   printf("makedir: doing %s\n", path);
#endif
   if (access(path, 0) == -1) {
      char s[5];

      fprintf(stderr, "bmh: Create directory \"%s\"? [N] ", path);
      fgets(s, sizeof(s), stdin);
      if ( tolower(s[0]) != 'y')
         exit(-1);
      if (mkdir(path) == -1) {
         perror(path);
         return -1;
         }
      }

   return 0;
}

/*
 * creating path to a new newsgroup
 */
int
makepath(char *path)
{
   char *cp = path;

#ifdef PATHDEBUG
   printf("makepath: doing %s\n", path);
#endif
   if (*cp == '/')
      cp++;

   while (1) {
      cp = strchr(cp, '/');

      if ( cp == NULL )
         return makedir(path);
      else
         *cp = '\0';

      if (makedir(path) == -1)
         return -1;

      if (cp != NULL) {
         *cp = '/';
         cp++;
         }
      }
}

