#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

static char *months[12] = {"Jan","Feb","Mar","Apr","May","Jun",
			   "Jul","Aug","Sep","Oct","Nov","Dec"};

/*---------------------------------------------------------------*/
/*   n t i m e                                                   */
/*                                                               */
/*  Print out the time and date field as                         */
/*    "day-MONTH-year hh:mm:ss ZONE"                             */
/*   as required for Usenet News articles                        */
/*                                                               */
/*  930113   Costas Krallis SV1XV                                */
/*           based on "ptime()" from BM.EXE                      */
/*---------------------------------------------------------------*/
char *ntime(long t)
{
   static char str[40];
   struct tm *ltm;
   char tz[4];
   char *p;

   ltm = localtime(&t); /* Read the system time */

   if ((p = getenv("TZ")) == NULL)
      strcpy(tz, "GMT");
   else
      strncpy(tz, p, 3);

   /* Usenet News format */
   sprintf(str,"%.2d-%s-%02d %02d:%02d:%02d %.3s\n",
      ltm->tm_mday,
      months[ltm->tm_mon],
      ltm->tm_year,
      ltm->tm_hour,
      ltm->tm_min,
      ltm->tm_sec,
      tz);

   return(str);
}





