/*
   p a r s e . c

   Initially created for the BM project.

   Copyright 1986 Bdale Garbee, All Rights Reserved.
   Permission granted for non-commercial copying and use, provided
   this notice is retained.
   Copyright 1987 1988 Dave Trulli NN2Z, All Rights Reserved.
   Permission granted for non-commercial copying and use, provided
   this notice is retained.

   920603 : Created.
   920802 : Cleaned up parse a little (P. Healy, EI9GL).
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

/*
 * parse a line into argv array. Return argc, -1 on error.
 */
int parse(char *line, char *argv[], int maxargs)
{
   int argc = 0;

   while ( argc < maxargs ) {
      int qflag = 0;

      while (isspace(*line) || (*line == ',') )  /* Skip leading white space */
         line++;
      if(*line == '\0')
         break;

      if(*line == '"'){		/* Check for quoted token */
         line++;		/* Suppress quote */
         qflag = 1;
         }
      argv[argc++] = line;	/* Beginning of token */

/*  Find terminating delimiter */

      if (qflag) {
         if ( (line = strchr(line, '"')) == NULL )
            return(-1);
         *line++ = '\0';
         }
      else {
         char *cp;

/* Find space or tab. If not present, then we've already found the last token.
 * 920802 : note that bm would wrongly leave trailing tab chars after a token.
 */
         if( (cp = strpbrk(line, " \t,\n")) == NULL)
            break;
         *cp++ = '\0';
         line = cp;
      }
   }
   if (argc == maxargs)
      return(-1);

   argv[argc] = NULL;

   return(argc);
}

/*
 * replace terminating end of line marker with null
 */
char *rip(char *s)
{
   char *p = s;
   for (; *s; s++)
      if (*s == '\n') {
         *s = '\0';
         break;
      }
   return p;
}


