/* OS- and machine-dependent stuff for IBM-PC running MS-DOS and Turbo-C
 * Copyright 1991 Phil Karn, KA9Q
 */
#if defined(OS2)
#define INCL_WIN
#define INCL_DOSFILEMGR
#define INCL_DOSMISC
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <os2.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#if !defined(OS2)
#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <sys/stat.h>
#include <alloc.h>
#endif
#include <string.h>
#include <process.h>
#include <fcntl.h>
#include <stdarg.h>
#if !defined(OS2)
#include <bios.h>
#endif
#include "global.h"
#include "config.h"
#include "mbuf.h"
#include "proc.h"
#include "iface.h"
#include "internet.h"
#include "socket.h"
#include "smtp.h"
#include "cmdparse.h"
#include "dirutil.h"
#include "pc.h"
#include "session.h"

#define	CTLC	0x3
#define	DEL	0x7f

#if defined(OS2)
int Mtasker;	/* Null is for os2 */
char abClr[] = {0x1b, '[', '2', 'J'};
char *MKNAME (char *tmpname,unsigned int tmpnum);
int16 eac(int32 sum);
void keybrd(TID *tid);
void ticker(TID *tid);
void clrscr(void);
ULONG semInterrupts;
TID tidTicker;
#endif
static int kbchar __ARGS((void));
extern int Curdisp;
extern struct proc *Display;
FILE *Rawterm;
unsigned _stklen = 8192;
int Tick;
static int32 Starttime;
int32 Clock;

#ifdef MULTITASK
int Background = 0;
int Nokeys = 0;
extern unsigned Minheap;
#endif
extern int Tracesession;

int Watchdog = 0;			/* Watch Dog off by default */
int WDTick = 300*(1000 / MSPTICK);	/* 5 minutes watchdog timer */
int WDCurr = 300*(1000 / MSPTICK);	/* Initial count down timer */

/* This flag is set by setirq() if IRQ 8-15 is used, indicating
 * that the machine is a PC/AT with a second 8259 interrupt controller.
 * If this flag is set, the interrupt return code in pcgen.asm will
 * send an End of Interrupt command to the second 8259 as well as the
 * first.
 */
int Isat;

static char Ttbuf[BUFSIZ];
static char Tsbuf[BUFSIZ];
static int saved_break;

/* Keyboard input buffer */
#define	KBSIZE	256
#if !defined(PM)
static struct {
	char buf[KBSIZE];
	char *wp;
	char *rp;
	int cnt;
} Keyboard;
#endif

int
am_i_an_AT()
{
#if !defined(OS2)
	unsigned char *model_code = MK_FP(0xF000,0xFFFE);

	if(*model_code == 0xFC)
		return 1;
	else
#endif
		return 0;
}

/* Following code from Doug Crompton */
/* define the error messages for trapping disk problems
 */
static char *crit_err_msg[] = {
            "write protect",
            "unknown unit",
            "not ready",
            "unknown command",
            "data error (CRC)",
            "bad request",
            "seek error",
            "unknown media type",
            "sector not found",
            "printer out of paper",
            "write fault",
            "read fault",
            "general failure",
            "reserved",
            "reserved",
            "invalid disk change"
        };


int
errhandler(int errval,int ax,int bp,int si)
    {
#if !defined(OS2)
    char msg[80];
    unsigned di;
    int drive;
    int errorno;

    di= _DI;

    if (ax < 0)
        hardretn(3);
    drive = ax & 0x00FF;
    errorno = di & 0x00FF;
    sprintf(msg, "\r\nError: %s on drive %c\r\n$",
                 crit_err_msg[errorno], 'A' + drive);
    bdosptr(0x09,msg,0);
    hardretn(3);
    return 0;   /* to please the compiler */
#endif
}


/* Called at startup time to set up console I/O, memory heap */
void
ioinit()
{
#if !defined(OS2)
	/* Fail all I/O errors */
	harderr(errhandler);

	/* Save these two file table entries for something more useful */
	fclose(stdaux);
	fclose(stdprn);
	setbuf(stdout,Tsbuf);

	Rawterm = fopen("con","wb");
	setbuf(Rawterm,Ttbuf);
	/* this breaks tab expansion so you must use ANSI or NANSI */
	ioctl(fileno(Rawterm), 1, (ioctl(fileno(Rawterm),0) & 0xff) | 0x20);
	saved_break = getcbrk();
	setcbrk(0);
	Starttime = bioscnt();
	/* Link timer handler into timer interrupt chain */
	chtimer(btick);

	/* Find out what multitasker we're running under, if any */
	chktasker();
#else
   DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &Starttime, sizeof(Starttime));

	tidTicker = _beginthread(ticker,
			   NULL,
			   4096,
			   &tidTicker);
/*	DosSetPrty(PRTYS_THREAD, PRTYC_TIMECRITICAL, 0, tidTicker);*/
#endif
#if defined(MSDOS) && !defined(OS2)
	/* test to see if we're running on an AT class machine.
	 * Set Isat flag accordingly - N1BEE
         */
	Isat = am_i_an_AT();
#endif
	/* Initialize keyboard queue */
#if !defined(PM)
	Keyboard.rp = Keyboard.wp = Keyboard.buf;
#endif

}
/* Called just before exiting to restore console state */
void
iostop()
{
	struct iface *ifp,*iftmp;
	void (**fp)();
#if !defined(OS2)

	setbuf(Rawterm,NULLCHAR);

	ioctl(fileno(Rawterm), 1, ioctl(fileno(Rawterm), 0) & 0xff & ~0x20);
	setcbrk(saved_break);
#endif
	for(ifp = Ifaces;ifp != NULLIF;ifp = iftmp){
		iftmp = ifp->next;
		if_detach(ifp);
	}
	/* Call list of shutdown functions */
	for(fp = Shutdown;*fp != NULLVFP;fp++){
		(**fp)();
	}	

}
#ifdef SHELL
/* Spawn subshell */
int
doshell(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	char *command;
	int ret;
#if !defined(OS2)
#ifdef MULTITASK
	if(Background) {
		if(!start_back())
			return -1;
		Nokeys++;
	}
	free(mallocw(Minheap)); /* Force heap/core break to reserve a heap */
#endif
	if(argc == 1 || !stricmp(argv[1], "/c")) {
		if((command = getenv("COMSPEC")) == NULLCHAR)
			command = "COMMAND.COM";
		ret = spawnvp(P_WAIT,command,argv);
	} else {
		ret = spawnvp(P_WAIT,argv[1],(argv + 1));
	}

#endif

	return ret;
}
#endif

#ifdef ALLCMD
/* Spawn mailer as subshell */
int
dobmail(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	int ret = 0;

#if !defined(OS2)
	char *command;

#ifdef MULTITASK
	if(Background) {
		if(!start_back())
			return -1;
		Nokeys++;
	}
	free(mallocw(Minheap));
#endif

	if((command = getenv("MAILER")) == NULLCHAR)
		command = "BM.EXE";
	ret = spawnvp(P_WAIT,command,argv);

#ifdef MULTITASK
	if(Background) {
		Nokeys--;
		stop_back();
	}
#endif
#endif /*OS2*/
	smtptick(NULL);		/* tickle smtp to send any mail */
	return ret;
}
#endif /*ALLCMD*/

#ifdef MULTITASK
/* if multitask mode is set - allow NOS and shell/mail to share system time */
dobackg(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Background,"Multitasking DOS Shell ",argc,argv);
}
#endif

/* if watch-dog mode is set - make NOS reboot the system if it stalls */
dowatchdog(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Watchdog,"NOS Watch Dog",argc,argv);
}
#if !defined(PM)
/* Keyboard interrupt handler */
void
kbint()
{
	int sig = 0;
	int c;

#ifdef MULTITASK
	if(Background && Nokeys)
		return;
#endif
#if !defined(OS2)
	while((c = kbraw()) != -1 && Keyboard.cnt < KBSIZE){
		sig = 1;
		*Keyboard.wp++ = c;
		if(Keyboard.wp == &Keyboard.buf[KBSIZE])
			Keyboard.wp = Keyboard.buf;
		Keyboard.cnt++;
	}
	if(sig){
		psignal(&Keyboard,0);
	}
#else
	c = kbdKeyInfo.chChar;
	*Keyboard.wp++ = c;
	if(Keyboard.wp == &Keyboard.buf[KBSIZE])
		Keyboard.wp = Keyboard.buf;
	Keyboard.cnt++;
	psignal(&Keyboard,0);
#endif
}
static int
kbchar()
{
	char i_state;
	char c;

#ifdef MULTITASK
	if(Background && Nokeys)
		return -1;
#endif

	/*i_state = dirps();*/
	while(Keyboard.cnt == 0)
		pwait(&Keyboard);
	Keyboard.cnt--;
	/*restore(i_state);*/
	c = *Keyboard.rp++;
	if(Keyboard.rp == &Keyboard.buf[KBSIZE])
		Keyboard.rp = Keyboard.buf;
	return uchar(c);
}
#endif
/* Flush the raw terminal output */
void
rflush()
{
	fflush(Rawterm);
}

#ifdef MSDOS
#ifdef ALLCMD
struct funcstr {
	char fkey;
	char alloced;
	char *fvalue;
};

struct funcstr fkeys[] = {
	15,0,NULLCHAR,	/* tab + shift */
    59,1,NULLCHAR,  /* F1 */
    60,1,NULLCHAR,  /* F2 */
    61,1,NULLCHAR,  /* F3 */
    62,1,NULLCHAR,  /* F4 */
	63,0,NULLCHAR,	/* F5 */
	64,0,NULLCHAR,	/* F6 */
	65,0,NULLCHAR,	/* F7 */
	66,0,NULLCHAR,	/* F8 */
	67,0,NULLCHAR,	/* F9 */
	68,0,NULLCHAR,	/* F10 */
	71,1,"\010",		/* home*/
	72,1,"\033[A",	/* up arrow*/
	73,1,"\025",		/* pgup */
	75,1,"\033[D",	/* left arrow */
	77,1,"\033[C",	/* right arrow */
	79,1,"\005",		/* end */
	80,1,"\033[B",	/* down arrow */
	81,1,"\012",		/* pgdn */
	82,1,"\001",		/* ins */
	83,1,"\0177",		/* del */
	84,0,NULLCHAR,	/* F1 + shift*/
	85,0,NULLCHAR,	/* F2 + shift*/
	86,0,NULLCHAR,	/* F3 + shift*/
	87,0,NULLCHAR,	/* F4 + shift*/
	88,0,NULLCHAR,	/* F5 + shift*/
	89,0,NULLCHAR,	/* F6 + shift*/
	90,0,NULLCHAR,	/* F7 + shift*/
	91,0,NULLCHAR,	/* F8 + shift*/
	92,0,NULLCHAR,	/* F9 + shift*/
	93,0,NULLCHAR,	/* F10 + shift*/
	94,0,NULLCHAR,	/* F1 + control*/
	95,0,NULLCHAR,	/* F2 + control*/
	96,0,NULLCHAR,	/* F3 + control*/
	97,0,NULLCHAR,	/* F4 + control*/
	98,0,NULLCHAR,	/* F5 + control*/
	99,0,NULLCHAR,	/* F6 + control*/
	100,0,NULLCHAR,	/* F7 + control*/
	101,0,NULLCHAR,	/* F8 + control*/
	102,0,NULLCHAR,	/* F9 + control*/
	103,0,NULLCHAR,	/* F10 + control*/
	104,0,NULLCHAR,	/* F1 + alt*/
	105,0,NULLCHAR,	/* F2 + alt*/
	106,0,NULLCHAR,	/* F3 + alt*/
	107,0,NULLCHAR,	/* F4 + alt*/
	108,0,NULLCHAR,	/* F5 + alt*/
	109,0,NULLCHAR,	/* F6 + alt*/
	110,0,NULLCHAR,	/* F7 + alt*/
	111,0,NULLCHAR,	/* F8 + alt*/
	112,0,NULLCHAR,	/* F9 + alt*/
	113,0,NULLCHAR,	/* F10 + alt*/
	114,0,NULLCHAR,	/* PrtSc + ctl*/
	117,0,NULLCHAR,	/* end  + ctl */
	118,0,NULLCHAR,	/* pgup + ctl */
	119,0,NULLCHAR,	/* home + ctl */
	132,0,NULLCHAR,	/* pgdn + ctl */
	  0,0,NULLCHAR
};

char Leftover = 0;
char *Nextkey;
#endif /*ALLCMD*/
#endif /*MSDOS*/
#if !defined(PM)
/* Read characters from the keyboard, translating them to "real" ASCII.
 * If none are ready, block. The F-10 key is special; translate it to -2.
 */
#ifdef ALLCMD
int
kbread()
{
#if !defined(OS2)
#ifndef	MSDOS
	int c;
#else
	int c,i,j;

	if((c = Leftover) != 0)  {
		Leftover = *Nextkey++;
		return c;
	}
#endif	MSDOS
	if((c = kbchar()) == 0){
		/* Lead-in to a special char */
		c = kbchar();
		switch(c){
		case 3:		/* NULL (bizzare!) */
			c = 0;
			break;
        case 68:    /* F-10 key (used as command-mode escape) */
			if(fkeys[10].fvalue == NULLCHAR){
				c = -2;
				break;
			}
        default:    /* Dunno what it is */
#ifdef	MSDOS
            if(c > 58 && c < 68) {  /* F1 to F9 */
                if(fkeys[c-58].fvalue == NULLCHAR) {
                    c = (c - 56) * -1; /* NO fkey defined - WG7J */
                    break;
                }
            }
            for(i=0;(j = fkeys[i].fkey) != 0;i++)
				if(j == c) {
					Nextkey = fkeys[i].fvalue;
					if(Nextkey == NULLCHAR) {
						c = -1;
						return c;
					}
					if((c = *Nextkey++) != 0)
						Leftover = *Nextkey++;
					else
						c = -1;
					return c;
				}
#endif
			c = -1;
		}
	}
	return c;
#else /*ALLCMD*/

        int c;

        if((c = kbchar()) == 0){
                /* Lead-in to a special char */
                c = kbchar();
                switch(c){
                case 3:         /* NULL (bizzare!) */
                        c = 0;
                        break;
                case 68:        /* F-10 key (used as command-mode escape) */
                        c = -2;
                        break;
                case 83:        /* DEL key */
                        c = 0x7f;
                        break;
                default:        /* Dunno what it is */
                    if(c > 58 && c < 68)    /* F1 to F9 */
                        c = (c - 56) * -1;
                    else
                        c = -1;
                }
        }
        return c;
}

#endif /*ALLCMD*/

#ifdef	MSDOS
#ifdef ALLCMD
		/*c = kbchar();*/
		/*switch(c){*/
		switch(kbdKeyInfo.chScan){
		case 61:	/* F-3 key (used as line-repeat) */
			c = 2;
			break;
}
#else
int
kbread()
{
	int c;
	if((c = kbchar()) == 0){
		/* Lead-in to a special char */
		c = kbchar();
		switch(c){
		case 3:		/* NULL (bizzare!) */
			c = 0;
			break;
		case 68:	/* F-10 key (used as command-mode escape) */
			c = -2;
			break;
		case 83:	/* DEL key */
			c = 0x7f;
			break;
		default:	/* Dunno what it is */
			c = -1;
		}
	}
	return c;
}
#endif
#endif
int
dofkey(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	int c,i,j;
	char *q, *r;
	char str[100];

	if(argc == 1) {
	   tprintf("key num    key  num    key  num    key  num   key   num\n");
	   tprintf("f1   59    sf1   84    cf1   94    af1  104   pgup   73\n");
	   tprintf("f2   60    sf2   85    cf2   95    af2  105   pgdn   81\n");
	   tprintf("f3   61    sf3   86    cf3   96    af3  106   home   71\n");
	   tprintf("f4   62    sf4   87    cf4   97    af4  107   end    79\n");
	   tprintf("f5   63    sf5   88    cf5   98    af5  108   arup   72\n");
	   tprintf("f6   64    sf6   89    cf6   99    af6  109   ardn   80\n");
	   tprintf("f7   65    sf7   90    cf7  100    af7  110   ar l   75\n");
	   tprintf("f8   66    sf8   91    cf8  101    af8  111   ar r   77\n");
	   tprintf("f9   67    sf9   92    cf9  102    af9  112   ins    82\n");
	   tprintf("f10  68    sf10  93    cf10 103    af10 113   del    83\n");
	   tprintf("usage: fkey <key number> [<value> | \"string\"]\n");
	   return 0;
	}

	c = atoi(argv[1]);
	if(c == 0 || c > 255) {
		tprintf("fkey number out of range.\n");
		return 1;
	}

	for(j = 0;(i = fkeys[j].fkey) != 0; j++)
		if(i == c)
			break;

	if(i == 0){
		tprintf("fkey number not found\n");
		return 1;
	}

	if(argc == 2) {
		q = fkeys[j].fvalue;
		r = str;
		if(q == NULLCHAR)
			tprintf("fkey %d has no assigned value.\n",c);
		else {
			while(*q)
				if(*q < ' ') { /* This is ASCII dependent !! */
					*r++ = '^';
					*r++ = *q++ + 0x40;
				} else
					*r++ = *q++;
			*r = '\0';
			tprintf("fkey = %s\n",str);
		}
		return 0;
	}

	if(argc == 3) {
		if(fkeys[j].alloced)
			fkeys[j].alloced = 0;
		else
			if(fkeys[j].fvalue != NULLCHAR)
				free(fkeys[j].fvalue);

		r = str;
		q = argv[2];
		while(*q){
			if(*q == '^'){	/* ^ gives control char next */
				q++;
				if(*q == '^') {
					*r++ = *q++; /* No, he wants a ^ */
				} else {
					*r++ = *q++ & 0x1f;
				}
			} else
				*r++ = *q++;
		}
		*r = '\0';
		fkeys[j].fvalue = strdup(str);
	}
	return 0;
}
#endif /*ALLCMD*/
#endif /*MSDOS*/

/* Install hardware interrupt handler.
 * Takes IRQ numbers from 0-7 (0-15 on AT) and maps to actual 8086/286 vectors
 * Note that bus line IRQ2 maps to IRQ9 on the AT
 */
int
setirq(irq,handler)
unsigned irq;
INTERRUPT (*handler)();
{
#if !defined(OS2)
	return(0);
	/* Set interrupt vector */
	if(irq < 8){
		setvect(8+irq,handler);
	} else if(irq < 16){
		Isat = 1;
		setvect(0x70 + irq - 8,handler);
	} else {
		return -1;
	}
#endif
	return 0;
}
#if !defined(OS2)
/* Return pointer to hardware interrupt handler.
 * Takes IRQ numbers from 0-7 (0-15 on AT) and maps to actual 8086/286 vectors
 */
INTERRUPT
(*getirq)( unsigned int irq)
{
	/* Set interrupt vector */
	if(irq < 8){
		return getvect(8+irq);
	} else if(irq < 16){
		return getvect(0x70 + irq - 8);
	} else {
		return NULLVIFP;
	}
}
#endif
/* Disable hardware interrupt */
int
maskoff(irq)
unsigned irq;
{
#if !defined(OS2)
	if(irq < 8){
		setbit(0x21,(char)(1<<irq));
	} else if(irq < 16){
		irq -= 8;
		setbit(0xa1,(char)(1<<irq));
	} else {
		return -1;
	}
#endif
	return 0;
}
/* Enable hardware interrupt */
int
maskon(irq)
unsigned irq;
 {
#if !defined(OS2)
	if(irq < 8){
		clrbit(0x21,(char)(1<<irq));
	} else if(irq < 16){
		irq -= 8;
		clrbit(0xa1,(char)(1<<irq));
	} else {
		return -1;
	}
#endif
	return 0;
}
/* Return 1 if specified interrupt is enabled, 0 if not, -1 if invalid */
int
getmask(irq)
unsigned irq;
{
	if(irq < 8)
		return (inportb(0x21) & (1 << irq)) ? 0 : 1;
	else if(irq < 16){
		irq -= 8;
		return (inportb(0xa1) & (1 << irq)) ? 0 : 1;
	} else
		return -1;
}
/* Called from assembler stub linked to BIOS interrupt 1C, called on each
 * hardware clock tick. Signal a clock tick to the timer process.
 */
void
ctick()
{
	if(Watchdog)
		if(WDCurr-- == 0)
			sysreset();	
#if !defined(OS2)
	Tick++;
	psignal(&Tick,1);
#else
   DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &Clock, sizeof(Clock));
   Clock = Clock / MSPTICK;
#endif
}
/* Called from the timer process on every tick. NOTE! This function
 * can NOT be called at interrupt time because it calls the BIOS
 */
void
pctick()
{
#if !defined(OS2)
	long t;
	static long oldt;	/* Value of bioscnt() on last call */
	static long days;	/* # of times bioscnt() has rolled over */

	/* Update the time-since-boot */
	t = bioscnt();

	if(t < oldt)
		days++;	/* bioscnt has rolled past midnight */
	oldt = t;
	Clock = (days * 0x1800b0) + t - Starttime;
#else
   long lTmp;
   DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &lTmp, sizeof(lTmp));
   Clock = (lTmp - Starttime) / MSPTICK;
#endif
}

/* Set bit(s) in I/O port */
void
setbit(unsigned port, char bits)
{
	outportb(port,(char)inportb(port)|bits);
}
/* Clear bit(s) in I/O port */
void
clrbit(unsigned port, char bits)
{
	outportb(port,(char)(inportb(port) & ~bits));
}
/* Set or clear selected bit(s) in I/O port */
void
writebit(unsigned port, char mask,int val)
{
	register char x;

	x = inportb(port);
	if(val)
		x |= mask;
	else
		x &= ~mask;
	outportb(port,x);
}
/* Convert a pointer to a long integer */
long
ptol(p)
void *p;
{
	long x;
#if !defined(OS2)
	x = FP_OFF(p);
#ifdef	LARGEDATA
	x |= (long)FP_SEG(p) << 16;
#endif
#else
	x = OFFSETOF(p);
/*	x |= (long)SELECTOROF(p) << 16;*/
   return((long)p);
#endif
	return x;
}
void *
ltop(l)
long l;
{
	register unsigned short seg,offset;

	seg = l >> 16;
	offset = l;
#if !defined(OS2)
	return MK_FP(seg,offset);
#else
	return ((void *)l);
#endif
}
#ifdef notdef	/* Assembler versions in pcgen.asm */
/* Multiply a 16-bit multiplier by an arbitrary length multiplicand.
 * Product is left in place of the multiplicand, and the carry is
 * returned
 */
int16
longmul(multiplier,n,multiplicand)
int16 multiplier;
int n;				/* Number of words in multiplicand[] */
register int16 *multiplicand;	/* High word is in multiplicand[0] */
{
	register int i;
	unsigned long pc;
	int16 carry;

	carry = 0;
	multiplicand += n;
	for(i=n;i != 0;i--){
		multiplicand--;
		pc = carry + (unsigned long)multiplier * *multiplicand;
		*multiplicand = pc;
		carry = pc >> 16;
		}
	}
	return carry;
}
/* Divide a 16-bit divisor into an arbitrary length dividend using
 * long division. The quotient is returned in place of the dividend,
 * and the function returns the remainder.
 */
int16
longdiv(divisor,n,dividend)
int16 divisor;
int n;				/* Number of words in dividend[] */
register int16 *dividend;	/* High word is in dividend[0] */
{
	/* Before each division, remquot contains the 32-bit dividend for this
	 * step, consisting of the 16-bit remainder from the previous division
	 * in the high word plus the current 16-bit dividend word in the low
	 * word.
	 *
	 * Immediately after the division, remquot contains the quotient
	 * in the low word and the remainder in the high word (which is
	 * exactly where we need it for the next division).
	 */
	unsigned long remquot;
	register int i;

	if(divisor == 0)
		return 0;	/* Avoid divide-by-zero crash */
	remquot = 0;
	for(i=0;i<n;i++,dividend++){
		remquot |= *dividend;
		if(remquot == 0)
			continue;	/* Avoid unnecessary division */
#ifdef	__TURBOC__
		/* Use assembly lang routine that returns both quotient
		 * and remainder, avoiding a second costly division
		 */
		remquot = divrem(remquot,divisor);
		*dividend = remquot;	/* Extract quotient in low word */
		remquot &= ~0xffffL;	/* ... and mask it off */
#else
		*dividend = remquot / divisor;
		remquot = (remquot % divisor) << 16;
#endif
	}
	return remquot >> 16;
}
#endif
void
sysreset()
{
#if !defined(OS2)
	void (*foo) __ARGS((void));
	foo = MK_FP(0xffff,0);	/* FFFF:0000 is hardware reset vector */
	(*foo)();
#else
	DosExit(EXIT_PROCESS, -1);
#endif
}
#if !defined(PM)
void
newscreen(struct session *sp)
{
	if(sp != NULLSESSION)
		sp->screen = callocw(1,sizeof(struct screen));
}
void
freescreen(struct session *sp)
{
	if(sp == NULLSESSION || sp->screen == NULLSCREEN)
		return;
	if(sp->screen->save != NULLCHAR)
		free(sp->screen->save);
	free((char *)sp->screen);
}
#endif
/* Save specified session screen and resume console screen */
void
swapscreen(old,new)
struct session *old,*new;
{
#if !defined(OS2)
	struct text_info tr;

	if(old == new)
		return;	/* Nothing to do */

	fflush(Rawterm);
	gettextinfo(&tr);
	if(old != NULLSESSION){
		/* Save old screen */
		if(old->screen->save == NULLCHAR)
			old->screen->save
			 = malloc(2*tr.screenheight*tr.screenwidth);
		if(old->screen->save != NULLCHAR){
			if(old->split){
				window(1,1,80,25);
				tr.winbottom = 25;
			}
			gettext(tr.winleft,tr.wintop,tr.winright,
			 tr.winbottom,old->screen->save);
		}
		old->screen->row = tr.cury;
		old->screen->col = tr.curx;
	}
	if(new != NULLSESSION){
		/* Load new screen */
		if(new->screen->save != NULLCHAR){
			if(new->split){
				window(1,1,80,23);
				clrscr();
			} else {
				window(1,1,80,25);
				clrscr();
			}
			puttext(tr.winleft,tr.wintop,tr.winright,
			 tr.winbottom,new->screen->save);
			gotoxy(new->screen->col,new->screen->row);
			/* Free the memory (saves 4K on a continuous basis) */
			free(new->screen->save);
			new->screen->save = NULLCHAR;
		} else {
			clrscr();	/* Start with a fresh slate */
			if(new->split){
				new->tsavex = 1;
				new->tsavey = 1;
				new->bsavex = 1;
				new->bsavey = 24;
				window(1,1,80,25);
				cputs("_\b");
				window(1,1,80,23);
			}
		}
	}
	alert(Display,1);	/* Wake him up */
#endif
}
#if !defined(PM)
void
display(i,v1,v2)
int i;
void *v1;
void *v2;
{
	int c;
	struct session *sp;

	/* This is very tricky code. Because the value of "Current" can
	 * change any time we do a pwait, we have to be careful to detect
	 * any change and go back and start again.
	 */
	for(;;){
		sp = Current;

		if(sp->morewait){
			pwait(&sp->row);
			if(sp != Current || sp->row <= 0){
				/* Current changed value, or the user
				 * hasn't really hit a key
				 */
				continue;
			}
			/* Erase the prompt */
			fprintf(Rawterm,"\r        \r");
		}
		sp->morewait = 0;
		if((c = rrecvchar(sp->output)) == -1){
			/* the alert() in swapscreen will cause this to
			 * return -1 when current changes
			 */
			pwait(NULL);	/* Prevent a nasty loop */
			continue;
		}
		if(sp->split){
			if(c == 0x0a){
				cputs(Eol);
				clreol();
			} else
				putch(c);
		} else {
			putc(c,Rawterm);
		}
        /* Fix by Ron Murray, vk6zjm */
        if(sp->record != NULLFILE)      /* Don't save CR if ascii mode */
            if (c != '\r' || sockmode(sp->output, -1) != SOCK_ASCII)
                putc(c,sp->record);
        if(sp->flowmode && c == '\n' && --sp->row <= 0){
			fprintf(Rawterm,"--More--");
			sp->morewait = 1;
		}
	}
}
#endif

/* Return time since startup in milliseconds. If the system has an 
 * 8254 clock chip (standard on ATs and up) then resolution is improved
 * below 55 ms (the clock tick interval) by reading back the instantaneous
 * value of the counter and combining it with the global clock tick counter.
 * Otherwise 55 ms resolution is provided.
 *
 * Reading the 8254 is a bit tricky since a tick could occur asynchronously
 * between the two reads. The tick counter is examined before and after the
 * hardware counter is read. If the tick counter changes, try again.
 * Note: the hardware counter counts down from 65536.
 */
int32
msclock()
{
#if defined(OS2)
int32 time;
/*	return (Clock * MSPTICK);*/
    DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, &time, sizeof(time));
    return(time);
#else
	int32 hi;
	int16 lo;
	int16 count[4]; /* extended (48-bit) counter of timer clocks */

	if(!Isat)
		return Clock * MSPTICK;

	do {
		hi = Clock + Tick;
		lo = clockbits();
	} while(hi != Clock + Tick); /* Make sure a tick didn't just occur */

	count[0] = 0;
	count[1] = hi >> 16;
	count[2] = hi;
	count[3] = -lo;
	longmul(11,4,count);	/* The ratio 11/13125 is exact */
	longdiv(13125,4,count);
	return ((long)count[2] << 16) + count[3];
#endif
}
/* Return clock in seconds */
int32
secclock()
{
#if !defined(OS2)
	int32 hi;
	int16 lo;
	int16 count[4];	/* extended (48-bit) counter of timer clocks */

	if(!Isat)
		return Clock * MSPTICK / 1000L;

	do {
		hi = Clock + Tick;
		lo = clockbits();
	} while(hi != Clock + Tick); /* Make sure a tick didn't just occur */

	count[0] = 0;
	count[1] = hi >> 16;
	count[2] = hi;
	count[3] = -lo;
	longmul(11,4,count);	/* The ratio 11/13125 is exact */
	longdiv(13125,4,count);
	longdiv(1000,4,count);
	return ((long)count[2] << 16) + count[3];
#else
	return(Clock * MSPTICK / 1000L);
#endif
}

int
doisat(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return setbool(&Isat,"AT/386 mode",argc,argv);
}

/* Directly read BIOS count of time ticks. This is used instead of
 * calling biostime(0,0L). The latter calls BIOS INT 1A, AH=0,
 * wich resets the midnight overflow flag, losing days on the clock.
 */
long
bioscnt()
{
	int i_state;
	long rval = 0L;
#if !defined(OS2)
	i_state = dirps();
	rval = * (long far *)MK_FP(0x40,0x6c);
	restore(i_state);
#endif
	return rval;
}

/* same as getenv(), but return "" instead of NULL when it does not exist */
char *getnenv (name)
char *name;
{
	char *rv;

	if ((rv = getenv(name)) == NULL)
		 rv = "";			/* NULL replaced by "" */

	return rv;
}
#if defined(OS2)

char *MKNAME (char *tmpname, unsigned int tmpnum)
{
	char *tmpdir,*p;
	static char staticname[80];

	if (tmpname == NULL)
		tmpname = staticname;

	p = tmpdir = getnenv("TMP");		/* get tempdir name */
	if (p[0] != '\0')
		p += strlen(p) - 1;		/* point to last character */

	sprintf(tmpname,"%s%sTMP%u.$$$",tmpdir,
			((*p != '/' && *p != '\\')? "/":""),tmpnum);

	return tmpname;
}

unsigned int _tmpnum = 0;

int32 get32(char *cp)
{
union {
    unsigned long ul;
    unsigned short ui[2];
    } u;
unsigned short usTmp;
unsigned char uschar;
    u.ul = *(unsigned long *)cp;
    uschar = u.ui[0] >> 8;
    u.ui[0] = (u.ui[0] << 8) | (unsigned short)uschar;
    uschar = u.ui[1] >> 8;
    u.ui[1] = (u.ui[1] << 8) | (unsigned short)uschar;
    usTmp = u.ui[0];
    u.ui[0] = u.ui[1];
    u.ui[1] = usTmp;
    return((int32)u.ul);
}

char *put32 __ARGS((char *cp,int32 x))
{
union {
    unsigned long ul;
    unsigned short ui[2];
    } u;
unsigned char uschar;
    u.ul = (unsigned long)x;
    uschar = u.ui[0] >> 8;
    u.ui[0] = (u.ui[0] << 8) | (unsigned short)uschar;
    uschar = u.ui[1] >> 8;
    u.ui[1] = (u.ui[1] << 8) | (unsigned short)uschar;
    memcpy(cp, (char *)&u.ul + 2, sizeof(int16));
    memcpy(cp + 2, (char *)&u.ul, sizeof(int16));
    return(cp + sizeof(long));
}


int16 get16(char *cp)
{
unsigned short ui;
unsigned char uschar;
    ui = *(unsigned short *)cp;
    uschar = ui >> 8;
    ui = (ui << 8) | (unsigned short)uschar;
    return((int16)ui);
}

char *put16 __ARGS((char *cp,int16 x))
{
unsigned short ui;
unsigned char uschar;
    ui = (unsigned short)x;
    uschar = ui >> 8;
    ui = (ui << 8) | (unsigned short)uschar;
    memcpy(cp, (char *)&ui, sizeof(int16));
    return(cp + sizeof(short));
}

unsigned short lcsum(unsigned short *buf, unsigned short cnt)
{
unsigned short usTmp = 0;
unsigned long ulTmp = 0L;
unsigned int i;
    for (i = 0; i < cnt; i++)
	ulTmp += buf[i];
    usTmp = eac(ulTmp);
    return ((usTmp << 8) | (usTmp >> 8));
}

int16 clockbits(void)
{
    return(0);
}
int fInterruptsOn = 1;
int fInterruptDepth = 0;
void giveup(void)
{
   DosSleep(100);
}
int dirps(void)
{
int i_state;
   DosEnterCritSec();
   fInterruptDepth++;
   i_state = fInterruptsOn;
   fInterruptsOn = 0;
   return(i_state);
}
void restore(int fInterruptState)
{
   if(--fInterruptDepth == 0)
      fInterruptsOn = 0;
   DosExitCritSec();
}

int FASTCALL istate()
{
    return(fInterruptsOn);
}
int fTickerTerminate;


void uchtimer(void)
{
	/* Unlink timer handler from timer chain */
    fTickerTerminate = 1;
    return;
}
#if !defined(PM)
void keybrd(TID *tid)
{
int i_state;
    for(;;)
	{
	KbdCharIn(&kbdKeyInfo, IO_WAIT, Keyboard.hKbd);
	/*i_state = dirps();*/
	kbint();
	/*restore(i_state);*/
	}
}
#endif
void ticker(TID *tid)
{
int i_state;
    for(;;)
	{
	DosSleep(MSPTICK);
	Tick++;
   if (fTickerTerminate)
      _endthread();
	psignal(&Tick, 1);
	}
}
int stat(PSZ pszFileName, PFILESTATUS3 pFileStatus)
{
ULONG	rc;
    rc = DosQueryPathInfo(pszFileName,
                          FIL_STANDARD,
                          pFileStatus,
                          sizeof(FILESTATUS3));
    return(rc);
}
int rmdir(PSZ pszDir)
{
ULONG ulrc;
   ulrc = DosRmDir(pszDir);
   return((int)ulrc);
}

int chdir(PSZ pszDir)
{
ULONG ulrc;
   ulrc = DosChDir(pszDir);
   return((int)ulrc);
}

int mkdir(PSZ pszDir)
{
ULONG ulrc;
   ulrc = DosMkDir(pszDir, (PEAOP2)NULL);
   return((int)ulrc);
}

PCHAR strrev(PSZ pszSrc)
{
PSZ pszTmp;
int i, j;
   i = strlen(pszSrc) + 1;
   pszTmp = malloc(i);
   i--;
   pszTmp[i] = '\0';
   for (j = 0; j < i; j++)
      pszTmp[j] = pszSrc[i - (j + 1)];
   strcpy(pszSrc, pszTmp);
   free(pszTmp);
   return(pszSrc);
}

int access(PSZ pszFile, int iAction)
{
ULONG rc, ulAction;
HFILE hFile;
PFILESTATUS3 pStatus;
	pStatus = malloc(sizeof(FILESTATUS3));
	if (!pStatus)
		return(TRUE);
	rc = DosQueryPathInfo(pszFile,
				FIL_STANDARD,
				pStatus,
				sizeof(FILESTATUS3));
	free(pStatus);
	return(rc);
#if defined(OLD)
    rc = DosOpen((PSZ)pszFile,
		  &hFile,
		  &ulAction,
		  0L,
		  FILE_NORMAL |FILE_DIRECTORY,
		  FILE_OPEN,
		  OPEN_ACCESS_READONLY | OPEN_SHARE_DENYNONE |
		  OPEN_FLAGS_RANDOM,
		  (PEAOP2)NULL);
    if (rc == 0)
	DosClose(hFile);
    switch (rc)
	{
	case ERROR_ACCESS_DENIED:
	case ERROR_DISK_FULL:
	case ERROR_EA_LIST_INCONSISTENT:
	case ERROR_FILENAME_EXCED_RANGE:
	case ERROR_INVALID_ACCESS:
	case ERROR_INVALID_EA_NAME:
	case ERROR_INVALID_PARAMETER:
	case ERROR_PATH_NOT_FOUND:
	case ERROR_SHARING_BUFFER_EXCEEDED:
	case ERROR_SHARING_VIOLATION:
	case ERROR_TOO_MANY_OPEN_FILES:
	    return((int)TRUE);

	default:
	    return((int)FALSE);
	}
#endif
}

void clrscr(void)
{
   return;
}
#endif
