/*------------------------------------------------------------------*/
/*  p n e w s . c                                                   */
/*                                                                  */
/*  Create and spool Usenet News article via KA9Q/WG7J NOS.         */
/*                                                                  */
/*   Costas Krallis (SV1XV)                                         */
/*   <kkrallis@leon.nrcps.ariadne-t.gr>                             */
/*                                                                  */
/*  Based on POST.EXE (920816) by Paul Healy (EI9GL) for the        */
/*  BMH project.                                                    */
/*  Uses code developed by Bdale Garbee (N3EUG), D. Trulli (NN2Z)   */
/*  and others for the BM mailer.                                   */
/*                                                                  */
/*  HISTORY                                                         */
/*   930114  V 1.0    Initial beta-test release.                    */
/*   930115  V 1.05   Minor fixups. Added "version.c".              */
/*------------------------------------------------------------------*/

#include <stdio.h>
#include <process.h>
#include <string.h>

#include "rc.h"
#include "nntp.h"
#include "util.h"

extern char version[];

static char InfoMsg[] = "Posting news article via NOS nntp.";

/*-------------------------------------------------------------------*/
/*   m a i n                                                         */
/*                                                                   */
/*   Process command line and invoke "post()".                       */
/*-------------------------------------------------------------------*/
void main(int argc, char **argv)
{
   char group[120], subject[120];
   int ret;

   if (loadconfig() == -1) exit(1);

   if((argc == 2) && (strncmp(argv[1], "-?", 2) == 0)){
	printf("%s\n",  InfoMsg);
	printf("Usage: pnews [newsgroup]\n");
	exit(1);
	}

   cls();
   printf("%s\n%s\n\n", version, InfoMsg);

   if(argc == 2){
	strcpy(group, argv[1]);
	printf("Newsgroup: %s\n", group);
	}
   else{
   	printf("Newsgroup: ");
   	gets(group);
	}

   printf("Subject: ");
   gets(subject);

   ret = post(group, subject);

   exit(ret);

}


