/*
   post.c : Copyright Paul Healy, EI9GL, 1992.

   920816 : Created.
*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include "config.h"
#include "help.h"
#include "rc.h"
#include "misc.h"
#include "buf.h"
#include "mailfile.h"
#include "header.h"
#include "mailer.h"
#include "nntp.h"

#ifdef BMH
#define main post_main
#endif

static int
copyright(int argc, char *argv[])
{
   char *usage = "post (post news)";

   if (ishelp(argc, argv)) {
      if (helplevel()==1) {
         fputs(usage, stdout);
         return 1;
         }
      fprintf(stdout, "usage: %s     ", usage);
      version(stdout);
      fputs("post is derived from the NOS NR0D NNTP server/client:\n"
         "Copyright 1990 Jeffrey R. Comstock, All Rights Reserved.\n"
         "Permission granted for non-commercial copying and use, provided\n"
         "this notice is retained.", stdout);
      exit(0);
      }
   return 0;
}

int
post(Mailfile *m, int argc, char *argv[])
{
   char filename[MAXNAMLEN];
   FILE *fp;

   if (mail_getfile(m, argc, argv, "post") == -1)
      return -1;

   if ((fp = tempfile("post", filename, "w")) == NULL)
      return -1;
   
   fprintf(fp, "Newsgroups: %s\nSubject: \n--------\n",
      mail_newsgroup(m) == NULL ? "" : mail_newsgroup(m));

   dosignature(fp);
   fclose(fp);

   if (call_ed("post", filename) == -1) {
      unlink(filename);
      return -1;
      }

   return dowhatnow("post", filename, postit);
}

int
main(int argc, char *argv[])
{
   Mailfile m;

   if (copyright(argc, argv))
      return 0;

   mail_zero(&m);

   post(&m, argc, argv);

   return mail_savestate(&m);
}

