/*
   range.c: Copyright 1993, Paul Healy.

   930703 : Created
*/
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include "range.h"
#include "letter.h"

int
range_init(range r[], int argc, char *argv[])
{
   int i;

   r[0].hi = argc;

   for (i=1; i<argc; i++)
      if (isdigit(argv[i][0])) {
         char *p = strchr(argv[i], '-');

         r[i].lo = atoi(argv[i]);
         r[i].hi = (p==NULL) ? r[i].lo : atoi(p+1);
         }
      else if (strcmp(argv[i], "all") == 0) {
         r[i].lo = 1;
         r[i].hi = INT_MAX;
         }

   return 0;
}

int
range_inside(range r[], int m)
{
   int i;

   for (i=1; i<r[0].hi; i++)
      if ((m>=r[i].lo) && (m<=r[i].hi))
         return 1;

   return 0;
}

int
range_done(range r[], int m)
{
   int i;

   for (i=1; i<r[0].hi; i++)
      if ((m==r[i].lo) && (m==r[i].hi)) {
         r[i].lo = 0;
         r[i].hi = 0;
         return 1;
         }

   return 0;
}

int
range_markread(range r[], folder f)
{
   int i;

   for (i=1; i<r[0].hi; i++)
      let_markrange(f, r[i].lo, r[i].hi);

   return 0;
}

int
range_markdeleted(range r[], folder f)
{
   int i;

   for (i=1; i<r[0].hi; i++)
      let_markdeleted(f, r[i].lo, r[i].hi);

   return 0;
}
