/*
   rc.h : Copyright Paul Healy, EI9GL, 1992.

   920603 : Created.
*/
#ifndef _rc_h_
#define _rc_h_

/*
 * Note: internal user variable names differ from those found in bmh.rc
 * for historical reasons. The ordering of this enum derives from the
 * alphabetical order of the form in bmh.rc (for bsearch'ing).
 */
typedef enum {
      alias,    /* alias file */
      bufsize,  /* internal mail file buffer (40k) */
      maxcol,   /* number of screen character columns */
      current,  /* file holding current folder/msg */
      dayfirst, /* ddmmyy instead of mmddyy */
      editor,   /* user's favorite text editor */
      editline, /* call DOS fn 0A for console input */
      folder,   /* directory for saving read mail */
      fullname, /* fullname of user */
      hostname, /* name of this host */
      index,    /* re-create jnos-style index after a change to mail file */
      maxlet,   /* maximum number of msgs in a file */
      savebox,  /* name of the mbox text file */
      mqueue,   /* defined mqueue outbound directory */
      multitask,/* try and give up timeslices to a multitasker */
      newsdir,  /* news directory */
      newshost, /* news posting hostname for path line */
      organ,    /* nntp organization header */
      quote,    /* quote string to prefix quoted message */
      record,   /* record outbound mail in this file */
      replyto,  /* address for reply-to header */
      rewrite,  /* rewrite file */
      maxrow,   /* number of screen character rows */
      screen,   /* screen access mode under Turbo C */
      signature,/* location of sig file  */
      maildir,  /* mail directory */
      source,   /* pull in rc info from another file */
      spooldir, /* spool directory - areas file etc */
      swap,     /* msdos: swap out bmh program when editing or listing */
      tmpdir,   /* directory for temporary files */
      tsbids,   /* add time stamp to bids in history file */
      username, /* name of this user from rc file */
      viewer,   /* program to view files with */
      zone      /* timezone variable to override automatic choice(s) */
   } UserVar;

char *getruncom(char *runcom);
int loadconfig(void);
char *getrc(UserVar u);

#endif
