                       README.PLT
              written by Ken Swaggart W7KKE

The QBASIC program PLOTTER.BAS is written for a CALCOMP 4000
plotter, but can probably be modified for other plotter types.
The baud rate and parity is set as a veriably in the program. It
is currently written to have the plotter attached to COM 2, with
the plotter sending data at 9600 baud, even parity.

  1. Place a map, or map section, on the plotter. Must be
Mercator projection with lat/long lines parallel with edge of
plotter. Note that the active plotting surface starts about 1
inch in from the edges of the plotter.

  2. Choose a lat/long in the vicinity of the upper left map
corner and the lower right corner. These points are used to
calibrate the plotter surface to the map.

  3. Run the program. Enter the initial lat and longs as
prompted. Those which require degrees and minutes are entered as
DD,MM and the MM can be MM.MM of course. Note that a comma
separates the DD and MMs.

  4. Each map segment prompts for a segment name to ease in any
debugging. Then just point to each position you wish to digitize.
The program beeps and displays the converted data on the screen.
My plotter occasionally hiccups and puts in an odd x/y. I prune
these out with a text editor when I've finished.

  5. After all the points for one map segment have been
digitized, press "F1" and tap the plotting surface to end that
segments. You will be prompted for another segment, map name
labels, or to exit the program.

  6. After finishing all your map lines, choose the map label
option on the menu and follow the prompts. Remember the names are
right justified on APRS when you point to where you want the name
to appear.

  7. When finished with the labels, press "F1" and tap the
plotter surface with the pen.

  8. Exit the program after naming you file with "name.MAP". Use
MAPFIX.BAS to check your results and use a text editor to smooth
up any map intersections.  

  9. To use the map in APRS, add the map to the APRS directory
and the map name, center decimal coordinates, and range to be
displayed, to the MAPLIST.MAP file. You will probably need to
delete an existing map name to keep from exceeding the number of
maps allowed. Remember to place the new map in the proper order
(more important maps at the end) to get the right map to display
when you have overlapping maps. The more detailed map of interest
should be at the end of the file.


THE FOLLOWING DESCRIBES THE CALCOMP Model 4110 Plotter in detail:
------------------------------------------------------------------

Plotting surface 12"x12" active, plastic surface is 12 3/4 x
 12 3/4.

Data is serial ASCII, even parity, with 4 characters of x
position and 5 characters of Y. Think 1st Y character is pen
status.

Power input is pin 24 +12vdc at 290-300 ma. Pin 25 is power
return

Data Ranges:
  X: 0 = left  4000 = right
  y: 0 = bottom  4000 = top

Pen status:
0 = point mode
1 = run mode, pen down
9 = run mode, pen up

There is an "A/B" switch on back of my plotter next to D25 plug.
I run in "B" which only sends a posit when pen is depressed on
surface (point mode).

Pin connections:
1  NC
2  +/- 15 v RS-232 data output from plotter.
3  + 5v from board (probably for some original interface device)
4  "             "                      "
5  0/+5v TTL data output
6  "                "
7 Ground (data return)
8   |
9   |- Tied together in various combinations to select baud rate.
10  |
11  |
12 - 23 Unknown. Appear to be open.
24  +12 vdc  power input
25  ground


Baud rate programming
Baud Rate               PIN          (X=connection to ground)
                8     9     10     11
  110         
  2400         X
  1200                X
   150         X      X
   300                      X
   200?        X            X
  4800               X      X
 OFF           X     X      X
   150                            X
   600         X                  X
    45?        X     X            X
 2400                       X     X
   135?        X            X     X
 9600                X      X     X  *QBASIC program rate
   OFF         X     X      X     X

