/*  DSPIO.H -- Header for the DSP CARD 3 Interface routines
 *
 *  Copyright (C) by Jarkko Vuori 1990
 *  Author(s): J Vuori
 *  Modification(s):
 */

/* host port addresses */
#define   ICR	0x0
#define   ISR	0x2
#define   RXH	0x5
#define   RXM	0x6
#define   RXL	0x7
#define   TXH	0x5
#define   TXM	0x6
#define   TXL	0x7

typedef enum {
    p, x, y
} DATASPACE;

int  OpenCardIo(int sel);
void ResetCard(void);
void SelectSSI(int source);
int  WriteByte(int address, int c);
int  ReadByte(int address);
void CloseCardIo(void);

int OpenLodFile(char *name);
int ReadWord(DATASPACE *space, unsigned *address, long *word);
int CloseLodFile(void);

void DownLoad(int fMsg);
long ReadHostWord(void);
void CheckMemDump(void);
