/* Login automatico Telnet con password crittografata
 * IK1CHE 13/05/90
 */
#include <stdio.h>
#ifdef	__TURBOC__
#include <io.h>
#include <fcntl.h>
#endif
#include "global.h"
#include "mbuf.h"
#include "socket.h"
#include "telnet.h"
#include "session.h"
#include "proc.h"
#include "tty.h"
#include "commands.h"
#include "netuser.h"
#include "files.h"

void rlogrecv __ARGS((struct telnet *tn,int argc,char *argv[]));

/* Execute user rlog command */
int
dorlog(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	struct session *sp;
	struct sockaddr_in fsocket;

	/* Allocate a session descriptor */
	if((sp = newsession(argv[1],TELNET,0)) == NULLSESSION){
		tputs(TooManySessions);
		return 1;
	}
	fsocket.sin_family = AF_INET;
	fsocket.sin_port = IPPORT_TELNET;

	tprintf("Resolving %s... ",sp->name);
	if((fsocket.sin_addr.s_addr = resolve(sp->name)) == 0){
		tprintf(Badhost,sp->name);
		keywait(NULLCHAR,1);
		freesession(sp);
		return 1;
	}
	if((sp->s = socket(AF_INET,SOCK_STREAM,0)) == -1){
		tprintf("Can't create socket\n");
		keywait(NULLCHAR,1);
		freesession(sp);
		return 1;
	}
	return rlog_connect(sp,(char *)&fsocket,SOCKSIZE,argc,argv);
}
/* Specific connect routine of rlog */
int
rlog_connect(sp,fsocket,len,argc,argv)
struct session *sp;
char *fsocket;
int len;
int argc;
char *argv[];
{
	unsigned int index;
	struct telnet tn;

	index = sp - Sessions;
	memset((char *)&tn,0,sizeof(tn));
	tn.eolmode = Tn_cr_mode;
	tn.session = sp;	/* Upward pointer */
	sp->cb.telnet = &tn;	/* Downward pointer */
	sockmode(sp->s,SOCK_ASCII);	/* Default to ascii mode */

	tprintf("Trying %s...\n",psocket((struct sockaddr *)fsocket));
	if(connect(sp->s,fsocket,len) == -1){
		tprintf("rlog session %u failed: %s errno %d\n",
		 index, sockerr(sp->s),errno);

		keywait(NULLCHAR,1);
		freesession(sp);
		return 1;
	}
	tprintf("rlog session %u connected to %s\n",index,sp->name);
	rlogrecv(&tn,argc,argv);
	return 0;
}

/* Rlog input routine */
void
rlogrecv(tn,argc,argv)
struct telnet *tn;
int argc;
char *argv[];
{
	int c,s,index;
	struct session *sp;
	char *cp;
	char buftmp[50];
	char buftmp1[17];

	sp = tn->session;
	s = sp->s;

	/* We run both the network and local sockets in transparent mode
	 * because we have to do our own eol mapping
	 */
/*	seteol(s,"");
	seteol(Curproc->input,"");
	seteol(Curproc->output,""); */

	/* Read real keystrokes from the keyboard */
/*	sp->ttystate.crnl = 0; */

	/* Make sure network output gets flushed appropriately */
/*	setflush(s,'\n'); */

	index = sp - Sessions;

	/* Fork off the transmit process */
	sp->proc1 = newproc("rlog_out",1024,tel_output,0,tn,NULL,0);

	/* Login procedure : Wait ".... login : ", we use ':' as a marker */

	while((c = recvchar(s)) != -1) {
		tputc((char)c);
		if(((char)c & 0x7f) == ':') {
			(void)recvchar(s);	/* eat the blank */
			tputc(' ');
			break;
		}
	}
	if(c == -1) {
		goto quit;
	}

	/* Send username to remote */
	usprintf(s,"%s\n",argv[2]);
	tprintf("%s\n",argv[2]);

	/* Wait for the challenge, now the marker is '>' */

	cp = buftmp;
	while((c = recvchar(s)) != -1) {
		tputc((char)c);
		*cp++ = (char)c & 0x7f;
		if(((char)c & 0x7f) == '>') {
			*cp = '\0';
			(void)recvchar(s);	/* eat the blank */
			tputc(' ');
			break;
		}
	}
	if(c == -1) {
		goto quit;
	}

	/* Encrypt the challenge with the key & send the response */

	buftmp[28] = '\0';
	epass(htol(&buftmp[12]),argv[3],buftmp1);
	usprintf(s,"%s\n",buftmp1);
	tprintf("%s\n",buftmp1);

	/* Process input on the connection */
	while((c = recvchar(s)) != -1){
		if(c != IAC){
			/* Ordinary character */
/*			if(!tn->remote[TN_TRANSMIT_BINARY])
				c &= 0x7f; */

			tputc((char)c);
			continue;
		}
		/* IAC received, get command sequence */
		c = recvchar(s);
		switch(c){
		case WILL:
			c = recvchar(s);
			willopt(tn,c);
			break;
		case WONT:
			c = recvchar(s);
			wontopt(tn,c);
			break;
		case DO:
			c = recvchar(s);
			doopt(tn,c);
			break;
		case DONT:
			c = recvchar(s);
			dontopt(tn,c);
			break;
		case IAC:	/* Escaped IAC */
			tputc(IAC);
			break;
		}
	}
quit:	/* A close was received from the remote host.
	 * Notify the user, kill the output task and wait for a response
	 * from the user before freeing the session.
	 */
	sockmode(sp->output,SOCK_ASCII); /* Restore newline translation */
	cp = sockerr(s);
	tprintf("%s session %u", Sestypes[sp->type],index);
	tprintf(" closed: %s\n", cp != NULLCHAR ? cp : "EOF");
	killproc(sp->proc1);
	sp->proc1 = NULLPROC;
	close_s(sp->s);
	sp->s = -1;
	keywait(NULLCHAR,1);
	freesession(sp);
}
