
   RMAILER(1)(RATS - Radio Amateur Telecommunications Society)RMAILER(1)

     NAME
          rmailer - multi-receipient message processor

     SYNOPSIS
  rmailer [-r ifil] [-w ofil] [-d ddir] [-l ldir] [-a+] [-s] [-i$] [-t+] hname

  fbbrmail ifil

     DESCRIPTION
          RMAILER reads a standard PBBS export file (ifil default
          rmailer.exp) consisting of messages for the program to process
          and writes a copy for each of the specified receipients to a
          standard PBBS import file (ofil default rmailer.imp) that the
          PBBS program then imports and distributes.  The program will
          remove the input file on successful completion (unless the -s
          switch is specified).

          The local system's heirarchical name (hname) is required to be
          the final argument on the command line. The switches and their
          arguments may appear in any sequence preceeding hname.  The a,
          i, s and t switches may be given via the environmental variable
          RMO (ex.  set RMO=t-a+i$ ).

          The determination of the receipient list is driven by the to
          field of the Sx command line of the message as follows:

          RMAIL   - The list is contained in a RFC-822 style "To:" line
                    (continuation lines begining with a space or tab
                    permitted) with the first address being "rmail@hname"
                    and containing at least one more address.  The list
                    may have additional RMAIL lists within starting with
                    "rmail@bbs" and ending with "***EOF".

          lstname - Where there is a file in the directory ddir (default
                    SYS) named lstname.dst which lists receipients one per
                    line and may include RMAILs as detailed above.

          otherTo - Any other to field contents are taken to be a message
                    that has been re-addressed and is to be resent the
                    BBS is picked up from the Sx command line and re-used.

          Once the list for the message is determined the new messages are
          created.  The message as received is placed with a timestamp in
          a log file {RMAIL|lstname|RESEND}{YY.MON|.LOG} (YY.MON = 2-digit
          year and three letter month set by -t+, LOG by -t-) in ldir
          (default .).  New messages are generated with prior "R:" headers
          removed and "Resent-Sender:" and new "To:" lines prepended to the
          RFC-822 style headers (if there are no RFC-822 headers then
          "Reply-To:" and "Subject:" are built from the original message and
          also added).  The new S command line is constructed so as to allow
          the BBS to decide B vs P and to force assignment of a new BID/MID
          (MID/BID assignment character set using -ix where x is $ or % or #
          any other value for x to cancel MID forcing).

          A confirmation message will be sent to the message originator for
          postings to mailing lists or of RMAILs if *CONFIrm is included as
          an 'addressee'.  An "Address Correction Notice" is returned to the
          sender of a resent message giving the corrected address for future
          reference (suppressed by the -a- switch).  All message senders are
          logged in the ddir directory in a file named "Reply-To.log".  The
          record format is "call call@bbs" one record per line (ROSErver/PRMBS
          v1.78 and later will use this file as the final lookup for mail to
          call at the local system if call is not a registered user).  It
          is suggested to sort and remove dupes from the file occasionaly.

          The RMAIL function also supports rmail to a buletin routing 
          with an assigned BID$.  The buletin "address" must be the first
          address on the "To:" line after the "rmail@<bbs>".  The
          assigned BID$ is appended to the "rmail@<bbs>" on the "To:"
          line (e.g.  "To: rmail@kb4cyc.nj.usa$bid_this, users@tribbs,
          kb2ear@kb2ear, kb4cyc").

          RMAILER wil also function as a server under the F6FBB BBS.  To
          enable this method of operation the program is renamed as
          FBBRMAIL instead of RMAILER (or any other name containing "FBB")
          or the letter 'F' is included in the value of the RMO environmental
          variable ('F' is not available on the command line due to the
          constraints on FBB server programs).  For the FBB server the log
          and distribution files are placed in the LOG and FWD sub-directories
          of the SYSTEM directory respectively.  As with any server entries
          for the appropriate to fields (RMAIL and any mailing lists) are
          added to INIT.SRV (such as:  RMAIL FBBRMAIL.EXE).

          Messages to a distribution list with a subject begining with LIST, 
          SENDLIST, SUBSCRIBE, ADD, UNSUBSCRIBE or REMOVE will perform the
          indicated function rather than expand (subject to controls set by
          *NOLIST or *RESTRICT entries in the list).

          If the second 'address' on the "To:" line of an incomming RMAIL
          is *NOXTO then that "To:" line is suppressed rather than sent
          along as an "X-To:" line in the header of the expanded message.

     AUTHOR
          Frank Warren (KB4CYC)

     CURRENT RELEASE
          2.13
