#include <stdio.h>
#include <time.h>
#include <osbind.h>		/* Pexec call */
#include <stdlib.h>
#include <fcntl.h>
#include <portab.h>
#ifdef SYS5
#include <fcntl.h>
#include <sys/types.h>
#endif /* SYS5 */
#include "bm.h"

#ifdef ATARI
#define time_t	long
#endif

extern int bmmode;

#define TRUE	-1
#define FALSE	0

char *ptime();

char *uu_fullname, *uu_myname, *uu_user, *uu_mydomain;


/*
   genv - obtain a value form an environment variable
*/

char *genv(envname, defvalue)
char *envname, *defvalue;
{
	char *envvalue, *space;
	int debuglevel = 0;

	if (debuglevel > 6)
		printf("genv: envname=%s \tdefvalue=%s\t",envname,defvalue);
	if ((envvalue = getenv(envname)) != NULL) {
		if (debuglevel > 6)
			printf("envvalue=%s\n",envvalue);
		space = malloc((unsigned)(strlen(envvalue) + 1));
		(void)strcpy(space, envvalue);
		return(space);
	} else {
		if (debuglevel > 6)
			printf("\n");
		return(defvalue);
	}
}


/* send a message */
dosmtpsend(mfp,recip,subject,inreplyto)
FILE *mfp;
char *recip;
char *subject;
char *inreplyto;
{
	char	smtp_to[LINELEN], 
		smtp_subject[LINELEN], 
		smtp_inreplyto[SLINELEN],
		tfilename[LINELEN], 
		wfilename[LINELEN],
		tstring[LINELEN],		/* temp for integer conv */
		prefix[20];
	char	*rindex();
	char	*tohost;
	char	*p;
	long	sequence;
	FILE	*tfile, *wfile;
	time_t	t;
	FILE	*fp;
	char	name[64];
	long	execstat;
	char	command[128];
	char	*cp;
/*	char	*uu_fullname, *uu_myname, *uu_user, *uu_mydomain;	*/

	sequence = get_msgid();
	sprintf(prefix,"%ld",sequence);

	if(recip == NULLCHAR){
		/* prompt and get To: */
		printf("\nTo: ");
		gets(smtp_to);
	} else
		strcpy(smtp_to,recip);
	
	if (subject == NULL && tty) {
		/* prompt and get Subject: */
		printf("Subject: ");
		gets(smtp_subject);
		if (smtp_subject[0] == '\0')
			strcpy(smtp_subject,"(no subject)");
	} else
		strcpy(smtp_subject,subject);

	if (inreplyto == NULL) {
		strcpy(smtp_inreplyto,"\0");
	} else {
		rip(inreplyto);
		strcpy(smtp_inreplyto,inreplyto);
	}

	/* Prompt and get CC: */
#ifdef	notdef
	printf("CC:      ");
	gets(smtp_cc);
#endif

#ifndef ATARI
	if (mlock(mailqdir,prefix)) {
		printf(" Cannot create lock file\n");
		return 1;
	}
#endif

	time(&t);
	/* open textfile in mqueue directory */
	sprintf(tfilename,"%s%ld%s",mailqdir,sequence,".txt");
	tfile = fopen(tfilename,"w+");		/* open textfile for write */
	if (tfile == NULLFILE) {
		perror(tfilename);
#ifndef ATARI
		rmlock(mailqdir,prefix);
#endif
		return 1;
	}

	if (bmmode != 0) {
		/* get header data from environment vars */
		uu_fullname = genv("FULLNAME","Guest User");
		uu_myname   = genv("MYNAME","noname");
		uu_user     = genv("USER","guest");
		uu_mydomain = genv("MYDOMAIN","noname.UUCP");
		/* rmail needs a line "From <name> <ctime>" */
		time(&t);
		cp = ctime(&t);
		rip(cp);
		fprintf(tfile,"From %s %s\n",uu_user,cp);
/*	}
	if (bmmode != 0) { */
		/* write UUCP Header */
		fprintf(tfile,"Message-ID: <%ld@%s>\n",sequence,uu_mydomain);
		fprintf(tfile,"Date: %s",ptime(&t));
		fprintf(tfile,"From: \"%s\" <%s@%s>\n",uu_fullname,uu_user,
			uu_mydomain);
		fprintf(tfile,"To: %s\n",smtp_to);
	} else {
	/* write RFC822-compatible headers using above information */
		fprintf(tfile,"Date: %s",ptime(&t));
		fprintf(tfile,"Message-Id: <%ld@%s>\n",sequence,hostname);
		fprintf(tfile,"From: %s@%s",username,hostname);
		if (*fullname != '\0')
			fprintf(tfile," (%s)",fullname);
		fprintf(tfile,"\n");
		if (*replyto != '\0')
			fprintf(tfile,"Reply-To: %s\n",replyto);
		fprintf(tfile,"To: %s\n",smtp_to);
#ifdef	notdef
		fprintf(tfile,"cc: %s\n",smtp_cc);
#endif
	}
	fprintf(tfile,"Subject: %s\n",smtp_subject);	/* was: %s\n", */

	if (*smtp_inreplyto != '\0')
		fprintf(tfile,"In-Reply-To: %s\n",smtp_inreplyto);	/* was: %s\n" */

	sprintf(name,"%s%s.hdr",mailqdir,username);
	if ((fp = fopen(name,"r")) != NULLFILE) {
		while(!feof(fp)) {
			fgets(tstring,LINELEN,fp);
			rip(tstring);
			if (strlen(tstring) > 3)
				fprintf(tfile,"%s\n",tstring);
		}
		fclose(fp);
	}

/*	fprintf(tfile,"X-Mailer: Bdale's Messy-Dos Mailer v3.0\n");	*/

	fprintf(tfile,"\n");       /* add empty line as separator */

	if (*smtp_inreplyto != '\0' && mfp != NULLFILE) {
		printf("\nInclude original message in reply (ny)? ");
		if ((gemdos(8) & 0x7f) == 'y') {
			fprintf(tfile,"In message %s you write:\n",smtp_inreplyto);
			while(!feof(mfp)) {
				fgets(tstring,LINELEN,mfp);
				rip(tstring);
				fprintf(tfile,"> %s\n",tstring);
			}
/*			fprintf(tfile,"\n");	*/	/* add empty line */
		}
	}

	if(mfp != NULLFILE && *smtp_inreplyto == '\0'){
		while(!feof(mfp)){
			fgets(tstring,LINELEN,mfp);
			rip(tstring);
			fprintf(tfile,"%s\n",tstring);
		}
		fclose(tfile);
	} else {
		/* sending a message not from a file */
                /* copy text from console to the file */
	if (tty) {
	printf("\nType message text.  Enter a '.' or ctrl/D in column one to end.");
	printf("\nCommands: ~p - redisplay msg, ~e - invoke editor, ~? - help\n\n");
	}
		for(;;) {
			/* read line from console  ie stdin */
			if (gets(tstring) == NULLCHAR)
				break;
			if(strcmp(tstring,".") == 0 || tstring[0] == '\004')
				break;	
#ifdef ATARI
			if (*tstring == '~') {
#else
			if (*tstring == '~'  && isatty(fileno(stdin))) {
#endif
				switch(tstring[1]) {
				case 'p':
					/* Print the message so far */
					fseek(tfile,0L,0);
					while(!feof(tfile)){
						fgets(tstring,sizeof(tstring),tfile);
						fputs(tstring,stdout);
					}
					break;
				case 'e':
					/* Drop into editor */
					fclose(tfile);
					backslash(tfilename);
					sprintf(tstring,"%s %s",editor,tfilename);
					/* call editor to enter message text */
					/*system(tstring);*/
			execstat = exec(editor,tfilename);
			if(execstat != 0) {
				printf("Pexec: errorcode %ld\n",execstat);
			}
					tfile = fopen(tfilename,"a+");
					break;
				case 'q':
					fclose(tfile);
					unlink(tfilename);
#ifndef ATARI
					rmlock(mailqdir,prefix);
#endif
					printf("Abort\n");
					return 0;
				case 'r': {
					int		c;
					FILE  *infl;
					p = &tstring[2];
					while(*p == ' ' || *p == '\t')
						p++;
					if (*p == '\0') 
						printf("No file name specified\n");
					else
						if((infl = fopen(p,"r")) == NULLFILE)
								printf("No such file\n");
						else {
								printf("Reading file %s\n",p);
								while((c = getc(infl)) != EOF)
									putc(c,tfile);
								fclose(infl);
						}
				
					break;
				}
				case 'm': {
					int	msg;
					p = &tstring[2];
					while(*p == ' ' || *p == '\t')
						p++;
					if (*p == '\0') {
						printf("No message number specified\n");
						break;
					}
					msg = atoi(p);
					if (mfile == NULLFILE || msg < 1 || msg > nmsgs)
						printf("no such message\n");
					else {
						printf("Inserting message %d\n",msg);
						savemsg(msg,tfile,1);
					}
					break;
				}
				case '~':
					fprintf(tfile,"%s\n",&tstring[1]);
					break;
				case '?':
					printf("~e - Invoke Editor\n");
					printf("~p - Display message buffer\n");
					printf("~q - Abort this message\n");
					printf("~r file - Read file into buffer\n");
					printf("~m msg - message into buffer\n");
					printf("~~ - Enter a ~ into message\n");
					break;
				default:
					printf("Unknown ~ escape. ~? for help\n");
				}
				printf("(continue)\n");
			} else
				fprintf(tfile,"%s\n",tstring);
		}
		if (tty)
			printf("EOF\n");
		/* read in .signature file */
		if (bmmode == 0)
			sprintf(name,"%s%s.sm",mailqdir,username);
		else
			sprintf(name,"%s%s.uu",mailqdir,uu_user);
		if ((fp = fopen(name,"r")) != NULLFILE) {
			printf("\nAppend signature file? ");
			if (getchar() == 'y') {
				while(!feof(fp)) {
					fgets(tstring,LINELEN,fp);
					rip(tstring);
					if (strlen(tstring) > 2)
						fprintf(tfile,"%s\n",tstring);
				}
				fclose(fp);
			}
		}
		fclose(tfile);
	}
	if ((tohost = rindex(smtp_to,'@')) == NULLCHAR)
		tohost = hostname;	/* local mail */
	else
		tohost++;

if (bmmode == 0) {
	/* open a workfile in the mqueue directory */
	sprintf(wfilename,"%s%ld%s",mailqdir,sequence,".wrk");
	if ((wfile = fopen(wfilename,"w")) == NULLFILE) {
		printf("Error: Unable to open work file\n");
	} else {
		fprintf(wfile,"%s\n",tohost);
		fprintf(wfile,"%s@%s\n",username,hostname);
		fprintf(wfile,"%s\n",smtp_to);
		fclose(wfile);
	}
} else {
	/*printf("tfilename= '%s'\n",tfilename);*/

	sprintf(command,"rmail %s",smtp_to);
	execstat = mi_exec(tfilename,"\0",command);

	if (execstat != 0)
		printf("Pexec: error %ld\n",execstat);
}

	/* remove lock in mqueue directory */
#ifndef ATARI
	rmlock(mailqdir,prefix);	/* erase the lock file */
#endif

	if(tty)
		printf("Message-Id %ld  Done.\n",sequence);
	return 0;
}

/* Return Date/Time in Arpanet format in passed string */
char *
ptime(t)
time_t *t;
{
	register struct tm *ltm;
	static char str[40];
	/* Print out the time and date field as
	 *		"DAY day MONTH year hh:mm:ss ZONE"
	 */
	static char *days[7] = {
		"Sun","Mon","Tue","Wed","Thu","Fri","Sat" };

	static char *months[12] = {
		"Jan","Feb","Mar","Apr","May","Jun",
		"Jul","Aug","Sep","Oct","Nov","Dec" };

	/* Read the system time */
	ltm = gmtime(t);

	/* most of the importent things are decoded , encript into string */
	sprintf(str,"%s, %.2d %s %02d %02d:%02d:%02d %.3s\n",
		days[ltm->tm_wday],
		ltm->tm_mday,
		months[ltm->tm_mon],
		ltm->tm_year,
		ltm->tm_hour,
		ltm->tm_min,
		ltm->tm_sec,
		timezone);
	return(str);
}

/* replace all '/' with '\' in the passed string. */
backslash(s)
char *s;
{
  while (*s != '\0') {
    if (*s == '/')       /* replace slash with backslash */
      *s = '\\';   
    s++;
  }
}



/*
 * return = 0 = success
 */

int
mi_exec(in,out,line)
char *in, *out, *line;
{
	int	in_handle,out_handle,nstd_handle,ret_code,ret,i;
	char	cmd[20],par_line[120];
	int	debug = 0;

	for(i=0; line[i] ; i++){	/* get command from LINE	*/
		if(line[i]==' '){	/* breakcharacter found		*/
			cmd[i]='\0';	/* terminate command		*/
			break;
		}
		cmd[i] = line[i];	/* copy command			*/
	}

	if( cmd[0] == 0 )
		return(-1);		/* is there really a command?	*/

	strcpy(par_line,&line[i+1]);	/* skip blank, copy parameters	*/

	if(debug > 1)
		printf("Mi_Exec: Command='%s' Parameters='%s'\n",cmd,par_line);

	/* Do I/O redirection here */
	in_handle = out_handle = 0;

	if(strlen(in) != 0) {			/* Input redirection?	*/
		/*printf("in='%s'\n",in);*/
		if ((nstd_handle = Fdup(0)) < 0) {
			printf("Fdup: error %d\n",nstd_handle);
			return(nstd_handle);
		} else {
			if( (in_handle=Fopen(in,0)) < 0 )
				return(in_handle);
		}
	}

	if(strlen(out)!=0) {			/* Output redirection?	*/
		/*printf("out='%s'\n",out);*/
		if( (out_handle=Fopen(out,1)) < 0 ){
			Fclose(in_handle);
			return(out_handle);
		}
	}

	if(debug > 2)
		printf("Mi_Exec: In=%d Out=%d\n",in_handle,out_handle);

	if(in_handle) {
		Fforce(0,in_handle);
	}

	if(out_handle)
		Fforce(0,out_handle);

	ret_code = exec(cmd,par_line);

	ret = Fforce(0,nstd_handle);

	ret = Fclose(out_handle);

	ret = Fforce(0,nstd_handle);

	return(ret_code);
}




static exec(command,args)
char *command;
char *args;
{
	/* ... */
	return(n);
}
