#include <stdio.h>
#include <string.h>
#include <time.h>
#if	(defined(UNIX) || defined(MICROSOFT))
#include <sys/types.h>
#endif
#include "bm.h"


char *ptime();

/* send a message */
dosmtpsend(mfp,toargs,nargs,subject)
FILE *mfp;
char *toargs[];
int nargs;
char *subject;
{
	char	smtp_subject[LINELEN], 
		tstring[LINELEN];
	char	*tmpnam();
	char	*p;
	char 	*tf;		/* temp file name */
	int	n;
	long	sequence;
	struct	addr *tolist,*tp;
	register FILE	*tfile;
	time_t	t;

	sequence = get_msgid();

	*smtp_subject = '\0';
	if (subject == NULL && tty) {
		/* prompt and get Subject: */
		printf("Subject: ");
		gets(smtp_subject);
	} else
		strcpy(smtp_subject,subject);

	/* Prompt and get CC: */
#ifdef	notdef
	printf("CC:      ");
	gets(smtp_cc);
#endif


	if ((tolist = make_tolist(nargs,toargs)) == NULLADDR) {
		printf("Send aborted\n");
		return 0;
	}

	time(&t);
	tf = tmpnam(NULL);
		/* open textfile for write */
	if ((tfile = fopen(tf,"w+")) == NULLFILE) {
		perror(tf);
		del_addrlist(tolist);
		return 1;
	}

	/* write RFC822-compatible headers using above information */
	fprintf(tfile,"Date: %s",ptime(&t));
	fprintf(tfile,"Message-Id: <%ld@%s>\n",sequence,hostname);
	fprintf(tfile,"From: %s@%s",username,hostname);
	if (fullname != NULLCHAR && *fullname != '\0')
		fprintf(tfile," (%s)",fullname);
	fprintf(tfile,"\n");
	if (replyto != NULLCHAR && *replyto != '\0')
		fprintf(tfile,"Reply-To: %s\n",replyto);
	strcpy(tstring,"To: ");
	for (tp = tolist; tp != NULLADDR; tp = tp->next) {
		strcat(tstring,tp->user);
		strcat(tstring,"@");
		strcat(tstring,tp->host);
		n = strlen(tstring);
		if (tp->next) {
			if (n > 50) {
				fprintf(tfile,"%s,\n\t",tstring);
				*tstring = '\0';
			} else
				strcat(tstring,", ");
		}
	}
	fprintf(tfile,"%s\n",tstring);       /* add empty line as separator */
#ifdef	notdef
	fprintf(tfile,"cc: %s\n",smtp_cc);
#endif
	fprintf(tfile,"Subject: %s\n",smtp_subject);
	fprintf(tfile,"\n");       /* add empty line as separator */

	if(mfp != NULLFILE){
		while(!feof(mfp)){
			fgets(tstring,LINELEN,mfp);
			rip(tstring);
			fprintf(tfile,"%s\n",tstring);
		}
	} else {
		/* sending a message not from a file */
		/* copy text from console to the file */
		if (tty) {
			printf("\nType message text.  Enter a '.' or ctrl/D in column one to end.");
			printf("\nCommands: ~p - redisplay msg, ~e - invoke editor, ~? - help\n\n");
		}
		for(;;) {
			/* read line from console  ie stdin */
			if (gets(tstring) == NULLCHAR)
				break;
			if(strcmp(tstring,".") == 0 || tstring[0] == '\004')
				break;
			if (*tstring == '~'  && isatty(fileno(stdin))) {
				switch(tstring[1]) {
				case 'p':
					/* Print the message so far */
					fseek(tfile,0L,0);
					while (fgets(tstring,sizeof(tstring),tfile) != NULLCHAR)
						fputs(tstring,stdout);
					break;
				case 'e':
					/* Drop into editor */
					fclose(tfile);
					if (editor == NULLCHAR) {
						printf("No editor defined\n");
						break;
					}
					sprintf(tstring,"%s %s",editor,tf);
					/* call editor to enter message text */
					system(tstring);
					tfile = fopen(tf,"a+");
					break;
				case 'q':
					fclose(tfile);
					(void) unlink(tf);
					printf("Abort\n");
					return 0;
				case 'r': 
					{
						int	c;
						FILE  *infl;
						p = &tstring[2];
						while(*p == ' ' || *p == '\t')
							p++;
						if (*p == '\0')
							printf("No file name specified\n");
						else
							if((infl = fopen(p,"r")) == NULLFILE)
								printf("No such file\n");
							else {
								printf("Reading file %s\n",p);
								while((c = getc(infl)) != EOF)
									putc(c,tfile);
								fclose(infl);
							}

						break;
					}
				case 'm': 
					{
						int	msg;
						p = &tstring[2];
						while(*p == ' ' || *p == '\t')
							p++;
						if (*p == '\0')
							msg = current;
						else
							msg = atoi(p);
						if (mfile == NULLFILE || msg < 1 || msg > nmsgs)
							printf("no such message\n");
						else {
							printf("Inserting message %d\n",msg);
							msgtofile(msg,tfile,0);
						}
						break;
					}
				case '~':
					fprintf(tfile,"%s\n",&tstring[1]);
					break;
				case '?':
					printf("~e - Invoke Editor\n");
					printf("~p - Display message buffer\n");
					printf("~q - Abort this message\n");
					printf("~r file - Read file into buffer\n");
					printf("~m msg - message into buffer\n");
					printf("~~ - Enter a ~ into message\n");
					break;
				default:
					printf("Unknown ~ escape. ~? for help\n");
				}
				printf("(continue)\n");
			} else
				fprintf(tfile,"%s\n",tstring);
		}
		if (tty)
			printf("EOF\n");

	}
	queuejob(tfile,tolist);
	recordmsg(tfile,tolist->user);
	fclose(tfile);
	del_addrlist(tolist);
	(void) unlink(tf);
	return 0;
}

/* Return Date/Time in Arpanet format in passed string */
char *
ptime(t)
long *t;
{
	register struct tm *ltm;
	struct tm *gmtime();
	static char tz[4];
	static char str[40];
	extern char *getenv();
	/* Print out the time and date field as
	 *		"DAY day MONTH year hh:mm:ss ZONE"
	 */
	char *p;
	static char *days[7] = {
    "Sun","Mon","Tue","Wed","Thu","Fri","Sat" };

	static char *months[12] = {
		"Jan","Feb","Mar","Apr","May","Jun",
		"Jul","Aug","Sep","Oct","Nov","Dec" };

	/* Read the system time */
	ltm = localtime(t);

	if (*tz == '\0')
		if ((p = getenv("TZ")) == NULL)
			strcpy(tz,"GMT");
		else
			strncpy(tz,p,3);

	/* rfc 822 format */
	sprintf(str,"%s, %.2d %s %02d %02d:%02d:%02d %.3s\n",
		days[ltm->tm_wday],
		ltm->tm_mday,
		months[ltm->tm_mon],
		ltm->tm_year,
		ltm->tm_hour,
		ltm->tm_min,
		ltm->tm_sec,
		tz);
	return(str);
}

/* save copy in the record file */
recordmsg(dfile,to) 
FILE *dfile;
char *to;
{
	register int c;
	FILE 	*fp;
	time_t	t;

	if (record == NULLCHAR)
		return 1;
	fseek(dfile,0L,0);
	if ((fp = fopen(record,"a")) == NULLFILE) {
		printf("Unable to append to %s\n",record);
	} else {
		(void) time(&t);
		fprintf(fp,"From %s %s",to,ctime(&t));
		while((c = getc(dfile)) != EOF)
			if(putc(c,fp) == EOF)
				break;
		if (ferror(fp)) {
			fclose(fp);
			return 1;
		}
		fclose(fp);
	}
	return 0;
}

/* place a mail job in the outbound queue */
int
queuejob(dfile,tolist)
FILE *dfile;
struct addr *tolist;
{
	FILE *fp;
	char tmpstring[50];
	register struct addr *tp,*sp;
	char prefix[9];
	int c;
	long id;

	for (tp = tolist; tp != NULLADDR; tp = tp->next) {
		if (tp->sent)
			continue;
		fseek(dfile,0L,0);
		id = get_msgid();
		sprintf(prefix,"%ld",id);
		(void) mlock(mailqdir,prefix);
		sprintf(tmpstring,"%s/%s.txt",mailqdir,prefix);
		if((fp = fopen(tmpstring,"w")) == NULLFILE) {
			printf("unable to open %s\n",tmpstring);
			(void) rmlock(mailqdir,prefix);
			return 1;
		}
		while((c = getc(dfile)) != EOF)
			if(putc(c,fp) == EOF)
				break;
		if (ferror(fp)) {
			fclose(fp);
			(void) rmlock(mailqdir,prefix);
			return 1;
		}
		fclose(fp);
		sprintf(tmpstring,"%s/%s.wrk",mailqdir,prefix);
		if((fp = fopen(tmpstring,"w")) == NULLFILE) {
			(void) rmlock(mailqdir,prefix);
			return 1;
		}
		fprintf(fp,"%s\n%s@%s\n",tp->host,username,hostname);
		fprintf(fp,"%s@%s\n",tp->user,tp->host);
		tp->sent++;
		/* find and other addresses to the same host */
		for (sp = tp->next; sp != NULLADDR; sp = sp->next) {
			if (sp->sent)
				continue;
			if (strcmp(tp->host,sp->host) == 0) {
				fprintf(fp,"%s@%s\n",sp->user,sp->host);
				sp->sent++;
			}
		}
		fclose(fp);
		(void) rmlock(mailqdir,prefix);
	}
	return 0;
}

/* convert a arg list to an list of address structures */
struct addr *
make_tolist(argc,argv)
int argc;
char *argv[];
{
	struct addr *tolist, *tp, *last;
	int i;
	char *user, *host;
	tolist = NULLADDR;
	for (i = 0,last = NULLADDR ; i < argc; i++) {
		tp = (struct addr *)calloc(1,sizeof(struct addr));
		if (tp == NULLADDR) {
			printf("Out of memory\n");
			del_addrlist(tolist);
			return NULLADDR;
		}
		user = argv[i];
		if ((host = strchr(user ,'@')) != NULLCHAR)
			*host++ = '\0';
		else
			host = hostname;

		if ((tp->user = malloc((unsigned)strlen(user)+1)) == NULLCHAR) {
			printf("Out of memory\n");
			del_addrlist(tolist);
			return NULLADDR;
		}
		strcpy(tp->user,user);
		if ((tp->host = malloc((unsigned)strlen(host)+1)) == NULLCHAR) {
			printf("Out of memory\n");
			del_addrlist(tolist);
			return NULLADDR;
		}
		strcpy(tp->host,host);

		if (last != NULLADDR)
			last->next = tp;
		else
			tolist = tp;
		last = tp;
	}
	return tolist;
}

/* delete a list of mail addresses */
del_addrlist(list)
struct addr *list;
{
	struct addr *tp, *tp1;;
	for (tp = list; tp != NULLADDR; tp = tp1) {
		tp1 = tp->next;
		if (tp->user != NULLCHAR);
			free(tp->user);
		if (tp->host != NULLCHAR);
			free(tp->host);
		(void) free((char *)tp);
	}
}
