#ifndef	_SLIP_H
#define	_SLIP_H

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#ifndef _IFACE_H
#include "iface.h"
#endif

#ifndef _SLHC_H
#include "slhc.h"
#endif

#define SLIP_MAX 5		/* Maximum number of slip channels */

#define	FR_END		0300	/* Frame End */
#define	FR_ESC		0333	/* Frame Escape */
#define	T_FR_END	0334	/* Transposed frame end */
#define	T_FR_ESC	0335	/* Transposed frame escape */

#if 0
/* Slip protocol control structure */
struct slip {
	struct iface *iface;
	char escaped;		/* Receiver State control flag */
#define SLIP_FLAG	0x01		/* Last char was a frame escape */
#define SLIP_VJCOMPR	0x02		/* TCP header compression enabled */
	struct mbuf *rbp_head;	/* Head of mbuf chain being filled */
	struct mbuf *rbp_tail;	/* Pointer to mbuf currently being written */
	char *rcp;		/* Write pointer */
	int16 rcnt;		/* Length of mbuf chain */
	struct mbuf *tbp;	/* Transmit mbuf being sent */
	int16 errors;		/* Receiver input errors */
        int type;               /* Protocol of input */
	int (*send) __ARGS((int,struct mbuf *));	/* send mbufs to device */
	int (*get) __ARGS((int));	/* fetch input chars from device */
	struct slcompress *slcomp;	/* TCP header compression table */
};
#endif

/* Slip protocol control structure */
struct slip_s {
	struct iface *iface;

	struct slcompress *slhcp;	/* header compression, if any */

	byte_t flags;
#define SLIP_VJWILL	0x20
#define SLIP_VJWANT	0x40
#define SLIP_VJSLOT	0x80

	byte_t trace;			/* trace flags for connection */

	int32 OutOpenFlag;		/* # of open flags sent */
	int32 InOpenFlag;		/* # of open flags */
};

/* In slip.c: */
int slip_init __ARGS((struct iface *iface));
int slip_raw __ARGS((struct iface *iface, struct mbuf *data));
void slip_proc __ARGS((struct iface *iface, struct mbuf *bp));

#endif  /* _SLIP_H */
