#define SMTP_PORT        25                /* well-known port for smtp */
#define SMTPCLITIME        900                /* 15 minutes between client starts */

/* currently, the below definitions are set up to put incoming mail activity
   in \spool\mail, and outgoing mail activity in \spool\mqueue.  Twiddle to
   suit, this is for pseudo-compatibility with 4bsd, since that's what I'm
   most familiar with...    Bdale  */

/* Mail box file name template - edit to taste */

#define	       MAILSPOOL  makefname("TCPIP_SPOOL", "/mail/%s.txt")
#define        MAILQDIR   makefname("TCPIP_SPOOL", "/mqueue/")
#define        MAILQUEUE  makefname("TCPIP_SPOOL", "/mqueue/\*.wrk")
#define        MAILLOCK   makefname("TCPIP_SPOOL", "/mqueue/lockfile")

extern char hostname[];
#define        LINELEN                128
#define SLINELEN        32

/* Recipient address entry */
struct addr {
        struct addr *next;
        char *val;
};
#define        NULLADDR        (struct addr *)NULL

/* Per-session control block */
struct mail {
        struct tcb *tcb;        /* TCP control block pointer */
        char state;
#define        COMMAND_STATE        0
#define        DATA_STATE        1

        char *system;                /* Name of remote system */
        struct addr *to;        /* Linked list of recipients */
        char buf[LINELEN];        /* Input buffer */
        char cnt;                /* Length of input buffer */
        FILE *data;                /* Temporary input file pointer */
};
#define        NULLMAIL        (struct mail *)NULL

struct smtp_msg {
        struct tcb *tcb;        /* tcp task control buffer */
        char cts;                /* used as boolean, true if space avail in
                                   tcp buffer */
        char state;                /* state machine placeholder */
#define CLI_OPEN_STATE        0
#define        CLI_HELO_STATE        1
#define CLI_MAIL_STATE        2
#define CLI_RCPT_STATE        3
#define CLI_DATA_STATE        4
#define        CLI_SEND_STATE        5
#define        CLI_UNLK_STATE        6
#define CLI_QUIT_STATE        7
        char        *filename;        /* name of workfile */
        char buf[LINELEN];        /* Input buffer */
        char cnt;                /* Length of input buffer */
        FILE *wfile, *tfile;
};

