/*
   spawn.c : Copyright Paul Healy, EI9GL, 1992.

   920105 : Created.
*/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <ctype.h>
#include <string.h>
#include "config.h"
#include "rc.h"
#include "spawn.h"

#ifdef SWAP
# include "../spawn/spawno.h"

static char *overlay_path = NULL;

static int
doswap(void)
{
   static int done = 0;
   static int result = 0;
   int swaptype = -1;
   char *s;

   if (done)
      return result;
   else
      done = 1;

   s = getrc(swap);

   if ( (s == NULL) || (tolower(*s) == 'n'))
      result = 0;
   else if (tolower(*s) == 'y') {
      result = 1;
      swaptype = SWAP_ANY;
      }
   else if (isdigit(*s)) {
      result = 1;
      swaptype = (int) strtol(s, NULL, 0);
      }
   else {
      fprintf(stderr, "bmh: bad swap setting (%s), check your rc file\n", s);
      exit(-1);
      }

    if (result) {
      if ( (overlay_path = strchr(s, ',')) != NULL) {
         overlay_path++;
         overlay_path = strdup(overlay_path);
         }
      init_SPAWNO(overlay_path, swaptype);
      }

   return result;
}
#endif /* SWAP */

/*
 * called by the shell command in bmh
 */
int
run_vp(int mode, char *path, char *argv[])
{
#ifdef SWAP
   if (doswap())
      return spawnvpo(overlay_path, path, argv);
   else
#endif /* SWAP */
      return spawnvp(mode, path, argv);
}

/*
 * called to invoke the editor and the list program
 */
int
run_lp(int mode, char *path, char *filename)
{
#ifdef SWAP
   if (doswap())
      return spawnlpo(overlay_path, path, path, filename, NULL);
   else
#endif /* SWAP */
      return spawnlp(mode, path, path, filename, NULL);
}




