#ifndef _TERMINAL_H
#define _TERMINAL_H

/*
 *  Includes
 */

#ifndef _SESSION_H
#include "session.h"
#endif

/*
 * local function codes
 */

enum	{
	slc_synch	=	1,
	slc_brk,
	slc_ip,
	slc_ao,
	slc_ayt,
	slc_eor,
	slc_abort,
	slc_eof,
	slc_susp,

	slc_ec,
	slc_el,
	slc_ew,
	slc_rp,
	slc_lnext,
	slc_xon,
	slc_xoff,
	slc_forw1,
	slc_forw2,
	slc_mcl,
	slc_mcr,
	slc_mcwl,
	slc_mcwr,
	slc_mcbol,
	slc_mceol,
	slc_insert,
	slc_over,
	slc_ecr,
	slc_ewr,
	slc_ebol,
	slc_eeol,

	slc_escape	=	256,
	slc_ignore,
	slc_ascii,
	};

/*
 *  keyboard codes
 */

enum	{
	key_alt_esc	    =	 0x0100,
	key_nul 	    =	 0x0300,
	key_alt_back_space  =	 0x0E00,
	key_shf_tab	    =	 0x0F00,
	key_alt_Q	    =	 0x1000,
	key_alt_W	    =	 0x1100,
	key_alt_E	    =	 0x1200,
	key_alt_R	    =	 0x1300,
	key_alt_T	    =	 0x1400,
	key_alt_Y	    =	 0x1500,
	key_alt_U	    =	 0x1600,
	key_alt_I	    =	 0x1700,
	key_alt_O	    =	 0x1800,
	key_alt_P	    =	 0x1900,
	key_alt_left_bracket=	 0x1A00,
	key_alt_right_bracket=	 0x1B00,
	key_alt_enter	    =	 0x1C00,
	key_alt_A	    =	 0x1E00,
	key_alt_S	    =	 0x1F00,
	key_alt_D	    =	 0x2000,
	key_alt_F	    =	 0x2100,
	key_alt_G	    =	 0x2200,
	key_alt_H	    =	 0x2300,
	key_alt_J	    =	 0x2400,
	key_alt_K	    =	 0x2500,
	key_alt_L	    =	 0x2600,
	key_alt_semicolon   =	 0x2700,
	key_alt_quote	    =	 0x2800,
	key_alt_back_quote  =	 0x2900,
	key_alt_back_slash  =	 0x2B00,
	key_alt_Z	    =	 0x2C00,
	key_alt_X	    =	 0x2D00,
	key_alt_C	    =	 0x2E00,
	key_alt_V	    =	 0x2F00,
	key_alt_B	    =	 0x3000,
	key_alt_N	    =	 0x3100,
	key_alt_M	    =	 0x3200,
	key_alt_comma	    =	 0x3300,
	key_alt_period	    =	 0x3400,
	key_alt_slash	    =	 0x3500,
	key_num_alt_star    =	 0x3700,
	key_f1		    =	 0x3B00,
	key_f2		    =	 0x3C00,
	key_f3		    =	 0x3D00,
	key_f4		    =	 0x3E00,
	key_f5		    =	 0x3F00,
	key_f6		    =	 0x4000,
	key_f7		    =	 0x4100,
	key_f8		    =	 0x4200,
	key_f9		    =	 0x4300,
	key_f10 	    =	 0x4400,
	key_home	    =	 0x4700,
	key_edt_home	    =	 0x47E0,
	key_up		    =	 0x4800,
	key_edt_up	    =	 0x48E0,
	key_pgup	    =	 0x4900,
	key_edt_pgup	    =	 0x49E0,
	key_num_alt_minus   =	 0x4A00,
	key_left	    =	 0x4B00,
	key_edt_left	    =	 0x4BE0,
	key_num_5	    =	 0x4C00,
	key_right	    =	 0x4D00,
	key_edt_right	    =	 0x4DE0,
	key_num_alt_plus    =	 0x4E00,
	key_end 	    =	 0x4F00,
	key_edt_end	    =	 0x4FE0,
	key_down	    =	 0x5000,
	key_edt_down	    =	 0x50E0,
	key_pgdn	    =	 0x5100,
	key_edt_pgdn	    =	 0x51E0,
	key_ins 	    =	 0x5200,
	key_edt_ins	    =	 0x52E0,
	key_del 	    =	 0x5300,
	key_edt_del	    =	 0x53E0,
	key_shf_f1	    =	 0x5400,
	key_shf_f2	    =	 0x5500,
	key_shf_f3	    =	 0x5600,
	key_shf_f4	    =	 0x5700,
	key_shf_f5	    =	 0x5800,
	key_shf_f6	    =	 0x5900,
	key_shf_f7	    =	 0x5A00,
	key_shf_f8	    =	 0x5B00,
	key_shf_f9	    =	 0x5C00,
	key_shf_f10	    =	 0x5D00,
	key_ctl_f1	    =	 0x5E00,
	key_ctl_f2	    =	 0x5F00,
	key_ctl_f3	    =	 0x6000,
	key_ctl_f4	    =	 0x6100,
	key_ctl_f5	    =	 0x6200,
	key_ctl_f6	    =	 0x6300,
	key_ctl_f7	    =	 0x6400,
	key_ctl_f8	    =	 0x6500,
	key_ctl_f9	    =	 0x6600,
	key_ctl_f10	    =	 0x6700,
	key_alt_f1	    =	 0x6800,
	key_alt_f2	    =	 0x6900,
	key_alt_f3	    =	 0x6A00,
	key_alt_f4	    =	 0x6B00,
	key_alt_f5	    =	 0x6C00,
	key_alt_f6	    =	 0x6D00,
	key_alt_f7	    =	 0x6E00,
	key_alt_f8	    =	 0x6F00,
	key_alt_f9	    =	 0x7000,
	key_alt_f10	    =	 0x7100,
	key_ctl_print	    =	 0x7200,
	key_ctl_left	    =	 0x7300,
	key_edt_ctl_left    =	 0x73E0,
	key_ctl_right	    =	 0x7400,
	key_edt_ctl_right   =	 0x74E0,
	key_ctl_end	    =	 0x7500,
	key_edt_ctl_end     =	 0x75E0,
	key_ctl_pgdn	    =	 0x7600,
	key_edt_ctl_pgdn    =	 0x76E0,
	key_ctl_home	    =	 0x7700,
	key_edt_ctl_home    =	 0x77E0,
	key_alt_1	    =	 0x7800,
	key_alt_2	    =	 0x7900,
	key_alt_3	    =	 0x7A00,
	key_alt_4	    =	 0x7B00,
	key_alt_5	    =	 0x7C00,
	key_alt_6	    =	 0x7D00,
	key_alt_7	    =	 0x7E00,
	key_alt_8	    =	 0x7F00,
	key_alt_9	    =	 0x8000,
	key_alt_0	    =	 0x8100,
	key_alt_minus	    =	 0x8200,
	key_alt_equal	    =	 0x8300,
	key_ctl_pgup	    =	 0x8400,
	key_edt_ctl_pgup    =	 0x84E0,
	key_f11 	    =	 0x8500,
	key_f12 	    =	 0x8600,
	key_shf_f11	    =	 0x8700,
	key_shf_f12	    =	 0x8800,
	key_ctl_f11	    =	 0x8900,
	key_ctl_f12	    =	 0x8A00,
	key_alt_f11	    =	 0x8B00,
	key_alt_f12	    =	 0x8C00,
	key_num_ctl_up	    =	 0x8D00,
	key_edt_ctl_up	    =	 0x8DE0,
	key_num_ctl_minus   =	 0x8E00,
	key_num_ctl_5	    =	 0x8F00,
	key_num_ctl_plus    =	 0x9000,
	key_num_ctl_down    =	 0x9100,
	key_edt_ctl_down    =	 0x91E0,
	key_num_ctl_ins     =	 0x9200,
	key_edt_ctl_ins     =	 0x92E0,
	key_num_ctl_del     =	 0x9300,
	key_edt_ctl_del     =	 0x93E0,
	key_ctl_tab	    =	 0x9400,
	key_num_ctl_slash   =	 0x9500,
	key_num_ctl_star    =	 0x9600,
	key_edt_alt_home    =	 0x9700,
	key_edt_alt_up	    =	 0x9800,
	key_edt_alt_pgup    =	 0x9900,
	key_edt_alt_left    =	 0x9B00,
	key_edt_alt_right   =	 0x9D00,
	key_edt_alt_end     =	 0x9F00,
	key_edt_alt_down    =	 0xA000,
	key_edt_alt_pgdn    =	 0xA100,
	key_edt_alt_ins     =	 0xA200,
	key_edt_alt_del     =	 0xA300,
	key_num_alt_slash   =	 0xA400,
	key_alt_tab	    =	 0xA500,
	key_num_alt_enter   =	 0xA600,

	key_enter		=	0x1C0D,
	key_ctl_enter		=	0x1C0A,
	key_ctl_r		=	0x1312,
	key_ctl_u		=	0x1615,
	key_backspace		=	0x0E08,
	};

/*
 *  Entries
 */

void kbinit             __ARGS((void));
void kbint		__ARGS((void));
void freescreen 	__ARGS((struct session *sp));
void newscreen		__ARGS((struct session *sp));
void swapscreen 	__ARGS((struct session *old,struct session *new));

#endif
