/* TTY input line editing
 * Copyright 1991 Phil Karn, KA9Q
 * split screen by G. J. van der Grinten, PA0GRI
 */
#include <stdio.h>
#ifdef __TURBOC__
#include <conio.h>
#endif
#include <ctype.h>
#include "global.h"
#include "config.h"
#include "mbuf.h"
#include "session.h"
#include "tty.h"
#include "socket.h"
#if defined(OS2)
#define INCL_WIN
#include <os2.h>
extern char Eol[5];
#define UM_BS WM_USER + 7
#define UM_INSERT WM_USER + 20
#endif

extern FILE *Rawterm;
static char buf[2];

#define	OFF	0
#define	ON	1

#define	LINESIZE	256

#define CTLR    18      /* reprint current line */
#define CTLU    21      /* delete current line in total */
#define	CTLW	23		/* erase last word including preceding space */
#define	CTLZ	26		/* EOF char in dos */
#define	CTLB	02		/* use as F3 in dos but no editing */
#define DEL	0x7f

#ifdef ALLSERV

static int  Lastsize = 1;
static char Lastline[LINESIZE+1] = "\n";

/* Accept characters from the incoming tty buffer and process them
 * (if in cooked mode) or just pass them directly (if in raw mode).
 *
 * Echoing (if enabled) is direct to the raw terminal. This requires
 * recording (if enabled) of locally typed info to be done by the session
 * itself so that edited output instead of raw input is recorded.
 * Control-W added by g1emm again.... for word delete.
 * Control-B/Function key 3 added by g1emm for line repeat.
 */

struct mbuf *
ttydriv(struct session *sp, char c)
{
struct mbuf *bp;
char *cp,*rp;
int cnt;
BOOL rc;
	buf[1] = '\0';
	switch(sp->ttystate.edit){
	case OFF:
		bp = ambufw(1);
		*bp->data = c;
		bp->cnt = 1;
		if(sp->ttystate.echo){
			if(sp->split){
#if !defined(OS2)
				sp->tsavex = wherex();
				sp->tsavey = wherey();
				window(1,24,80,25);
				gotoxy(sp->bsavex,sp->bsavey);
				highvideo();
				putch(c);
				normvideo();
				cputs("_\b");
				sp->bsavex = wherex();
				sp->bsavey = wherey();
				window(1,1,80,23);
				gotoxy(sp->tsavex,sp->tsavey);
#endif
			} else {
#if defined(OS2)
				buf[0] = c;
				do {
				rc = WinPostMsg(sp->hwndSession, UM_INSERT, MPFROMP(buf), 0L);
				if (rc == FALSE)
					DosSleep(MSPTICK);
				} while (rc = FALSE);
#else
				putc(c,Rawterm);
#endif
			}
		}
		return bp;
	case ON:
		if(sp->ttystate.line == NULLBUF)
			sp->ttystate.line = ambufw(LINESIZE);

		bp = sp->ttystate.line;
		cp = bp->data + bp->cnt;
		/* Perform cooked-mode line editing */
#ifdef notdef
        switch(c & 0x7f){
#endif
        /* Allow for international character sets - WG7J */
        switch(c){
        case '\r':  /* CR and LF both terminate the line */
		case '\n':
			if(sp->ttystate.crnl)
				*cp = '\n';
			else
				*cp = c;
			if(sp->ttystate.echo){
				if(sp->split){
#if !defined(OS2)
					highvideo();
					rp = bp->data;
					while(rp < cp) {
						putch(*rp++);
					}
					normvideo();
					clreol();
					cputs(Eol);
					clreol();
					sp->tsavex = wherex();
					sp->tsavey = wherey();
					window(1,24,80,25);
					clrscr();
					cputs("_\b");
					sp->bsavex = wherex();
					sp->bsavey = wherey();
					window(1,1,80,23);
					gotoxy(sp->tsavex,sp->tsavey);
#endif
				} else {
#if !defined(OS2)
					fputs(Eol,Rawterm);
#else
					do {
					rc = WinPostMsg(sp->hwndSession, UM_INSERT, MPFROMP(Eol), 0L);
					if (rc == FALSE)
						DosSleep(MSPTICK);
					} while (rc = FALSE);
#endif
				}
			}
			bp->cnt += 1;
			sp->ttystate.line = NULLBUF;
			Lastsize = bp->cnt;
			memcpy(Lastline, bp->data, Lastsize);			
			return bp;
		case DEL:
		case '\b':	/* Character delete */
			if(bp->cnt != 0){
				bp->cnt--;
				if(sp->ttystate.echo){
					if(sp->split){
#if !defined(OS2)
						sp->tsavex = wherex();
						sp->tsavey = wherey();
						window(1,24,80,25);
						gotoxy(sp->bsavex,sp->bsavey);
						cputs(" \b\b_\b");
						sp->bsavex = wherex();
						sp->bsavey = wherey();
						window(1,1,80,23);
						gotoxy(sp->tsavex,sp->tsavey);
#endif
					} else {
#if !defined(OS2)
						fputs("\b \b",Rawterm);
#else
						do {
						rc = WinPostMsg(sp->hwndSession, UM_BS, MPFROMP("\b \b"), 0L);
						if (rc == FALSE)
							DosSleep(MSPTICK);
						} while (rc = FALSE);
#endif
					}
				}
			}
			break;
		case CTLR:	/* print line buffer */
			if(sp->ttystate.echo){
				if(sp->split) {
#if !defined(OS2)
					sp->tsavex = wherex();
					sp->tsavey = wherey();
					window(1,24,80,25);
					gotoxy(sp->bsavex,sp->bsavey);
					clrscr();
					rp = bp->data;
					while (rp < cp)
						putch(*rp++) ;
					cputs("_\b");
					sp->bsavex = wherex();
					sp->bsavey = wherey();
					window(1,1,80,23);
					gotoxy(sp->tsavex,sp->tsavey);
#endif
				} else {
#if !defined(OS2)
					fprintf(Rawterm,"^R%s",Eol) ;
					rp = bp->data;
					while (rp < cp)
						putc(*rp++,Rawterm) ;
#endif
				}
			}
			break ;
		case CTLU:	/* Line kill */
			if(sp->split) {
#if !defined(OS2)
				sp->tsavex = wherex();
				sp->tsavey = wherey();
				window(1,24,80,25);
				gotoxy(sp->bsavex,sp->bsavey);
				cputs(" \b");
				while(bp->cnt != 0){
					cputs("\b \b");
					bp->cnt--;
				}
				cputs("_\b");
				sp->bsavex = wherex();
				sp->bsavey = wherey();
				window(1,1,80,23);
				gotoxy(sp->tsavex,sp->tsavey);
#endif
			} else {
				while(bp->cnt != 0){
					bp->cnt--;
					if(sp->ttystate.echo)
#if !defined(OS2)
						fputs("\b \b",Rawterm);
#else
						do {
						rc = WinPostMsg(sp->hwndSession, UM_BS, MPFROMP("\b \b"), 0L);
						if (rc == FALSE)
							DosSleep(MSPTICK);
						} while (rc = FALSE);
#endif
				}
			}
			break;
		case CTLB:	/* Use last line to finish current */
			cnt = bp->cnt;		/* save count so far */

			while(bp->cnt != 0){
				bp->cnt--;
				if(sp->ttystate.echo)
#if !defined(OS2)
					fputs("\b \b", Rawterm);
#else
					do {
						rc = WinPostMsg(sp->hwndSession, UM_BS, MPFROMP("\b \b"), 0L);
						if (rc == FALSE)
							DosSleep(MSPTICK);
					} while (rc = FALSE);
#endif
			}
			bp->cnt = cnt;

                        if(bp->cnt < (Lastsize-1)){
                                memcpy(bp->data+bp->cnt, &Lastline[bp->cnt], (Lastsize-1) - bp->cnt);
                                bp->cnt = Lastsize-1;
			}

			*(bp->data + bp->cnt) = '\0';	/* make it a string */
			if(sp->ttystate.echo)
#if !defined(OS2)
				fputs(bp->data, Rawterm);	/* repaint line */
#else
				do {
					rc = WinPostMsg(sp->hwndSession, UM_INSERT, MPFROMP(bp->data), 0L);
					if (rc == FALSE)
						DosSleep(MSPTICK);
				} while (rc = FALSE);
#endif
			break ;
		case CTLW:	/* erase word */
			cnt = 0 ;	/* we haven't seen a printable char yet */
			while(bp->cnt != 0){
				*(bp->data + bp->cnt--) = '\n';
				if(sp->ttystate.echo)
#if !defined(OS2)
					fputs("\b \b", Rawterm);
#else
					do {
						rc = WinPostMsg(sp->hwndSession, UM_BS, MPFROMP("\b \b"), 0L);
						if (rc == FALSE)
							DosSleep(MSPTICK);
					} while (rc = FALSE);
#endif
				if (isspace((int)*(bp->data + bp->cnt))) {
					if (cnt)
						break ;
				} else {
					cnt = 1 ;
				}
			}
			break ;
		default:	/* Ordinary character */
			*cp = c;
			bp->cnt++;

			/* ^Z apparently hangs the terminal emulators under
			 * DoubleDos and Desqview. I REALLY HATE having to patch
			 * around other people's bugs like this!!!
			 */
			if(sp->ttystate.echo &&
#ifndef	AMIGA
			 c != CTLZ &&
#endif
			 bp->cnt < LINESIZE-1){
				if(sp->split) {
#if !defined(OS2)
					sp->tsavex = wherex();
					sp->tsavey = wherey();
					window(1,24,80,25);
					gotoxy(sp->bsavex,sp->bsavey);
					putch(c);
					cputs("_\b");
					sp->bsavex = wherex();
					sp->bsavey = wherey();
					window(1,1,80,23);
					gotoxy(sp->tsavex,sp->tsavey);
#endif
				} else {
#if !defined(OS2)
					putc(c,Rawterm);
#else
					buf[0] = c;
					do {
						rc = WinPostMsg(sp->hwndSession, UM_INSERT, MPFROMP(buf), 0L);
						if (rc == FALSE)
							DosSleep(MSPTICK);
					} while (rc = FALSE);
#endif
				}

			} else if(bp->cnt >= LINESIZE-1){
				putc('\007',Rawterm);	/* Beep */
				bp->cnt--;
			}
			break;
		}
		break;
	}
	return NULLBUF;
}

#else


/* Accept characters from the incoming tty buffer and process them
 * (if in cooked mode) or just pass them directly (if in raw mode).
 *
 * Echoing (if enabled) is direct to the raw terminal. This requires
 * recording (if enabled) of locally typed info to be done by the session
 * itself so that edited output instead of raw input is recorded.
 */
struct mbuf *
ttydriv(sp,c)
struct session *sp;
char c;
{
	struct mbuf *bp;
	char *cp,*rp;

	switch(sp->ttystate.edit){
	case OFF:
		bp = ambufw(1);
		*bp->data = c;
		bp->cnt = 1;
		if(sp->ttystate.echo)
			putc(c,Rawterm);

		return bp;
	case ON:
		if(sp->ttystate.line == NULLBUF)
			sp->ttystate.line = ambufw(LINESIZE);

		bp = sp->ttystate.line;
		cp = bp->data + bp->cnt;
		/* Perform cooked-mode line editing */
		switch(c & 0x7f){
		case '\r':	/* CR and LF both terminate the line */
		case '\n':
			if(sp->ttystate.crnl)
				*cp = '\n';
			else
				*cp = c;
			if(sp->ttystate.echo)
				fputs(Eol,Rawterm);

			bp->cnt += 1;
			sp->ttystate.line = NULLBUF;
			return bp;
		case DEL:
		case '\b':	/* Character delete */
			if(bp->cnt != 0){
				bp->cnt--;
				if(sp->ttystate.echo)
					fputs("\b \b",Rawterm);
			}
			break;
		case CTLR:	/* print line buffer */
			if(sp->ttystate.echo){
				fprintf(Rawterm,"^R%s",Eol) ;
				rp = bp->data;
				while (rp < cp)
					putc(*rp++,Rawterm) ;
			}
			break ;
		case CTLU:	/* Line kill */
			while(bp->cnt != 0){
				bp->cnt--;
				if(sp->ttystate.echo){
					fputs("\b \b",Rawterm);
				}
			}
			break;
		default:	/* Ordinary character */
			*cp = c;
			bp->cnt++;

			/* ^Z apparently hangs the terminal emulators under
			 * DoubleDos and Desqview. I REALLY HATE having to patch
			 * around other people's bugs like this!!!
			 */
			if(sp->ttystate.echo &&
#ifndef	AMIGA
			 c != CTLZ &&
#endif
			 bp->cnt < LINESIZE-1){
				putc(c,Rawterm);

			} else if(bp->cnt >= LINESIZE-1){
				putc('\007',Rawterm);	/* Beep */
				bp->cnt--;
			}
			break;
		}
		break;
	}
	return NULLBUF;
}

#endif /*ALLSERV*/
