(*===========================================================================*)
(* Turbo pascal control info                                                 *)
(*                                                                           *)
(*   Copyright 1991 by H. Roy Engehausen.  All rights reserved.              *)
(*   This software may be freely distributed and used, but it may not        *)
(*   under any circumstances be sold by anyone other than the author.        *)
(*   It may be distributed by a commercial company as long as it is          *)
(*   for no cost.                                                            *)
(*                                                                           *)
(*===========================================================================*)

CONST
  int3f = $3FCD;

TYPE

  overlay_header = RECORD
                     return_int     : WORD;      (* INT $3F                  *)
                     return_ofs     : WORD;      (* Offset to 1 st return    *)
                     file_ofs       : LONGINT;   (* Offset inside overlay fil*)
                     code_size      : WORD;      (* Size of overlay in paras *)
                     fixup_size     : WORD;      (* Size of fixup in paras   *)
                     entry_count    : WORD;      (* Number of entry points   *)
                     code_list_next : WORD;      (* Segment of next overlay  *)
                     load_segment   : WORD;      (* Address loaded at        *)
                     unused_1       : WORD;      (*                          *)
                     load_list_next : WORD;      (* Segment of next item in  *)
                                                 (* overlay buffer           *)
                     unused_2       : ARRAY [1..5] OF WORD;
                     first_entry    : WORD       (* First entry point data   *)

                   END;

  stack_frame_type = RECORD
                      next_bp   : WORD;
                      CASE BYTE OF
                        0: (link_ptr : POINTER);
                        1: (link_off  : WORD;
                            link_seg  : WORD);
                    END;

  stack_frame_ptr_type = RECORD
                      CASE BYTE OF
                        0: (pnt  : ^stack_frame_type);
                        1: (off  : WORD;
                            seg  : WORD);
                    END;

  over_head_type = RECORD
                      CASE byte OF
                        0 : (pnt : ^overlay_header);
                        1 : (off : WORD;
                             seg : WORD);
                    END;

