/* UDP packet tracing
 * Copyright 1991 Phil Karn, KA9Q
 */
/* Mods by PA0GRI */
#include <stdio.h>
#include "global.h"
#include "mbuf.h"
#include "netuser.h"
#include "internet.h"
#include "udp.h"
#include "ip.h"
#include "socket.h"
#include "trace.h"

void rwho_dump __ARGS((struct iface *ip,struct mbuf **bpp));

/* Dump a UDP header */
void
udp_dump(ip,bpp,source,dest,check)
struct iface  *ip;
struct mbuf **bpp;
int32 source,dest;
int check;		/* If 0, bypass checksum verify */
{
	struct udp udp;
	struct pseudo_header ph;
	int16 csum;

	if(bpp == NULLBUFP || *bpp == NULLBUF)
		return;

	prtTrace(ip,"UDP:");

	/* Compute checksum */
	ph.source = source;
	ph.dest = dest;
	ph.protocol = UDP_PTCL;
	ph.length = len_p(*bpp);
	if((csum = cksum(&ph,*bpp,ph.length)) == 0)
		check = 0;	/* No checksum error */

	ntohudp(&udp,bpp);

	prtTrace(ip," len %u",udp.length);
	prtTrace(ip," %u->%u",udp.source,udp.dest);
	if(udp.length > UDPHDR)
		prtTrace(ip," Data %u",udp.length - UDPHDR);
	if(udp.checksum == 0)
		check = 0;
	if(check)
		prtTrace(ip," CHECKSUM ERROR (%u)",csum);

	prtTrace(ip, "\n");

	switch(udp.dest){
	case IPPORT_RIP:
		rip_dump(ip,bpp);
	case IPPORT_RWHO:
		rwho_dump(ip,bpp);
	}

}

