/* This file contains machine specific functions */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/termio.h>
#include <sys/dir.h>
#include <signal.h>
#include <string.h>
#include "bm.h"

struct termio	savetty;
int	savedtty = 0;		/* tell weather savetty is valid */

/* This function should put the tty in a mode such that signgle characters
* can be read without waiting for a complete line. Echo should be on.
*/
setrawmode()
{
	struct termio ttybuf;
	ioctl(0, TCGETA, &ttybuf);
	ioctl(0, TCGETA, &savetty);
	savedtty = 1;
	ttybuf.c_lflag &= ~ICANON;
	ttybuf.c_iflag &= ~ICRNL;
	ttybuf.c_oflag &= ~OCRNL;
	ttybuf.c_cc[VTIME] = '\0';
	ttybuf.c_cc[VMIN] = '\1';
	ioctl(0, TCSETA, &ttybuf);
}

/* This function should restore the tty modes back to cooked mode */
setcookedmode()
{
	if (savedtty) {
		ioctl(0, TCSETA, &savetty);
		savedtty = 0;
	}
}

/* This function return one charater form the keyboard. It will wait
* for a character to be input. This function will echo the character.
* This funtion will return afer each character is typed if raw is set
*/
int
getrch()
{
	int	c;
	c = getchar();
	return c & 0xff;
}

/* This function show clear screen and put cursor at top of screen */
screen_clear()
{
}

setsignals()
{
	/* ignore break */
	signal(SIGINT,SIG_IGN);
}
