/*
   mailer.c : Copyright Paul Healy, EI9GL, 1992.

   920802 : Created.
*/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <dir.h>

#include "rc.h"

/*
 * eg, set TMP=g:\   where g: is a ram disk
 */
FILE *tempfile(char *prog, char *filename, char *mode)
{  
   char *tmp = getrc(tmpdir);
   FILE *fp = NULL;

   if (tmp == NULL)
      if ( (tmp = getenv("BMHTMP")) == NULL)
         tmp = getenv("TMP");

   if (tmp == NULL)
      sprintf(filename, "%.6sXXXXXX", prog);
   else 
      sprintf(filename, "%s%.6sXXXXXX", tmp, prog);

   if ((mktemp(filename) == NULL) || ( (fp = fopen(filename, mode)) == NULL) )
      fprintf(stderr, "%s: can't make temporary file %s\n", prog, filename);
#ifdef DEBUG
   printf("tempfile: made %s\n", filename);
#endif
   return fp;
}

/*------------------------------------------------------------------*/
/*   c a l l _ e d                                                  */
/*                                                                  */
/*   Invoke editor defined in configuration file.                   */
/*------------------------------------------------------------------*/

int call_ed(char *prog, char *filename)
{
   char *ed = getrc(editor);

   if ( ed == NULL) {
      fprintf(stderr, "%s: no editor defined\n", prog);
      return(-1);
      }
   if (spawnlp(P_WAIT, ed, ed, filename, NULL) != 0) {
      fprintf(stderr, "%s: error calling editor '%s %s'\n", prog, ed, filename);
      perror(prog);
      return(-1);
      }

   return(0);
}


/*-----------------------------------------------------------------*/
/*   d o s i g n a t u r e                                         */
/*                                                                 */
/*   Append user's signature to message file.                      */
/*-----------------------------------------------------------------*/

void dosignature(FILE *fp)
{
   FILE *sigfp;
   int ch;

   if (getrc(signature) == NULL)
      return;

   if ( (sigfp = fopen(getrc(signature), "r")) == NULL) {
      fprintf(stderr,"pnews: can't open signature file %s\n",getrc(signature));
      return;
      }
   
   while ((ch = fgetc(sigfp)) != EOF)
      if (fputc(ch, fp) == EOF) {
         fprintf(stderr, "pnews: error adding signature file to message\n");
         break;
         }
   fclose(sigfp);
}

/*---------------------------------------------------------------------*/
/*   d u p f i l e                                                     */
/*                                                                     */
/*---------------------------------------------------------------------*/

int dupfile(FILE *in, FILE *out)
{
   char buf[2048];
   int r;

   while ( (r = fread(buf, sizeof(char), sizeof(buf), in)) > 0 ) {
      if ( fwrite(buf, sizeof(char), r, out) != r) {
         fprintf(stderr, "bmh: error writing file\n");
         return -1;
         }
      if (r != sizeof(buf))
         return 0;
      }

   return 0;
}
