/* Delete all .LCK files in all directories */

/* Written by Bernie Roehl, May 1990 */

/* Works with the NNTPCLI by Anders Klemets and Bernie Roehl */

#include <stdio.h>
#include <dir.h>
#include <dos.h>

char *progname = "ZAPLOCKS";

int verbose = 0;

void main(argc, argv)
int argc;
char *argv[];
	{
	FILE *hist;
	void walk_dirs();
	char buff[100];
	if (argc > 1)
		if (!strcmp(argv[1], "-v")) {
			verbose = 1;
			++argv;
			--argc;
			}
	if (argc != 2) {
		printf("%s: Correct usage is 'zaplocks spooldir'\n", progname);
		exit(2);
		}
	walk_dirs(argv[1]);
	exit(0);
	}

void walk_dirs(char *dir)
	{
	char work[100];
	struct ffblk ff;

	sprintf(work, "%s/*.lck", dir);
	if (findfirst(work, &ff, 0) == 0)
		do {
			sprintf(work, "%s/%s", dir, ff.ff_name);
			if (verbose) printf("%s: deleting '%s'\n", progname, work);
			unlink(work);
			} while (findnext(&ff) == 0);

	sprintf(work, "%s/*.*", dir);
	if (findfirst(work, &ff, FA_DIREC) == 0)
		do {
			if (ff.ff_name[0] != '.') {
				sprintf(work, "%s/%s", dir, ff.ff_name);
				walk_dirs(work);
				}
			} while(findnext(&ff) == 0);
	}
