/* config.h    general configuration info
 *
 * Copyright 1991, Michael Westerhof, Sun Microsystems, Inc.
 * This software may be freely used, distributed, or modified, providing
 * this header is not removed.
 *
 */

#define CONFIG_FILE "./ax25ip.cfg"

char ttydevice[128];
unsigned char mycallsign[7];
unsigned char myalias[7];
char bc_text[128];
int bc_interval;
int bc_every;		/* true=every, false=after */
int digi;
int ttyspeed;
int loglevel;

#define MAX_FRAME 2048

#define LOGL1 if(loglevel>0)(void)printf
#define LOGL2 if(loglevel>1)(void)printf
#define LOGL3 if(loglevel>2)(void)printf
#define LOGL4 if(loglevel>3)(void)printf

/* kiss.c */
void kiss_init();
void assemble_kiss();
void send_kiss();
void param_add();
void dump_params();
void send_params();

/* routing.c */
void route_init();
void route_add();
unsigned char *ip_to_call();
unsigned char *call_to_ip();
void dump_routes();

/* config.c */
void config_init();
void config_read();
int parse_line();
int a_to_call();
char *call_to_a();
void dump_config();

/* process.c */
void process_init();
void from_ip();
void from_kiss();
void do_broadcast();
int addrmatch();
unsigned char *next_addr();
void add_crc();
void dump_ax25frame();

/* io.c */
void io_init();
void io_open();
void io_start();
void send_tty();
void send_ip();

/* crc.c */
unsigned short int compute_crc();
int ok_crc();

/* main.c */
void hupper();
