/* main.c     main entrypoint
 *
 * Copyright 1991, Michael Westerhof, Sun Microsystems, Inc.
 * This software may be freely used, distributed, or modified, providing
 * this header is not removed.
 *
 */

#include "config.h"
#include "version.h"
#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

jmp_buf restart_env;

void
main(argc, argv)
	int argc;
	char *argv[];
{
	if(setjmp(restart_env)==0){
		signal(SIGHUP, hupper);
	}

	/* Say hello to the world */
	(void)printf("\nax25ip (PROTOTYPE) %s\n",VERS);
	(void)printf("Copyright 1991, Michael Westerhof, Sun Microsystems, Inc.\n\n");

	/* Test arguments */
	if(argc>2){
		(void)fprintf(stderr,"Usage: %s [<configuration-file>]\n",argv[0]);
		exit(1);
	}

	/* Initialize all routines */
	config_init();
	kiss_init();
	route_init();
	process_init();
	io_init();

	/* read config file */
	config_read(argv[1]);

	/* print the current config and route info */
	dump_config();
	dump_routes();
	dump_params();

	/* Open the IO stuff */
	io_open();

	/* and let the games begin */
	io_start();
}

void
hupper()
{
	LOGL1("SIGHUP signal!\n\n");
	longjmp(restart_env, 1);
}
