#include <stdio.h>
#include <string.h>
#include <fcntl.h>
 /*  Mail file header record.
 */

typedef struct
{
  short next;	 /* Next record to allocate	    */
  short first;	 /* First message header record     */
  short last;	 /* Last message header record	    */
  short ffree;	 /* First record in free chain	    */
  short lfree;	 /* Last record in free chain	    */
  short next_msg; /* Next message number 	    */
  unsigned char version;  /* File format version number	    */
  short free;	 /* Number of records in free chain */
  short count;	 /* Number of messages		    */
  char date[6];  /* Date of last untangle	    */
  char time[4];  /* Time of last untangle	    */
  short unt_msg;  /* next_msg at last untangle	    */
  char unused[99];
} MAIL_HDR;
/*
 *  Message header record.
 */

#define m_read	 0x01  /* Message has been read by recipient	*/
#define m_fwd	 0x02  /* Message has been forwarded		*/
#define m_orphan 0x04  /* Message destination not known locally */
#define m_unk	 0x08  /* Message destination not know by wp	*/

#define mhtitl 80  /* Length of title. */

typedef struct
{
  short first;	/* First text record, or zero if message in a file */
  short last;	/* Last text record, or zero if message in a file  */
  short next;	/* Next message header record			   */
  short number;	/* Message number				   */
  short size;	/* Size in bytes, excluding terminating ctl-z	   */
  char type;	/* Message type 				   */
  unsigned char stat;	/* Message status, see bit definitions above	   */
  char to[6];	/* Destination call				   */
  char from[6]; /* Originator call				   */
  char date[6]; /* Entry date					   */
  char time[4]; /* Entry time					   */
  short ext;	/* Header extension record, or zero		   */
  short read;	/* # times the message has been read		   */
  short prev;	/* Previous message header record		   */
  char bbs[6];	/* Destination BBS, or distribution list	   */
  short unu2;	/* Still available				   */
  char title[mhtitl];
} MSG_HDR;

MSG_HDR msgbuf;
MAIL_HDR mailbuf;

main()
{
	int fd1,fd2,fd3,topnum;
	char c,s,*p;
 	char msgpath[40],headerbuf[128],newpath[40];	
	long recnum;
	
	if((fd1=open("/u/bbs/mail.dat",O_RDONLY)) == -1)
	{
		printf("File Open Failure on mail.dat\n");
		exit();
	}

	read(fd1,&mailbuf,128);
	for(recnum=mailbuf.first;recnum != mailbuf.last; recnum=msgbuf.next){
	
            read(fd1,&msgbuf,128);

            if(msgbuf.stat & m_read)
                s = 'Y';
                else
                 s = 'N';

            sprintf(headerbuf,
"%c%c %6.6s %6.6s %6.6s %6.6s %4.4s %s\n\0"
,msgbuf.type,s,msgbuf.to,msgbuf.from,msgbuf.bbs,msgbuf.date,msgbuf.time,msgbuf.title);

            sprintf(msgpath,"/u/bbs/msgs/%d\0",msgbuf.number);
            sprintf(newpath,"/u/newbbs/mail/%d\0",msgbuf.number);

            if((fd2=open(newpath,O_WRONLY|O_CREAT,0666)) < 0)
            {
                printf("Cant Open new file %s",newpath);
            }

            if((fd3=open(msgpath,O_RDONLY)) < 0){
                printf("File Open Error %s\n",msgpath);
	    }
            else
            {
                p=headerbuf;
                while(*p) write(fd2,p++,1);
	        c='\n';
                write(fd2,&c,1);
	        while(read(fd3,&c,1) > 0)
		    write(fd2,&c,1);
                close(fd2);
	        close(fd3);
            }
        }
}
