# HRLNOS set-up-ing
# make sure to have at least the following files setup:
# between (): might be omitted; in CAPITALs: these are directories!
#  /hrlnos.exe           : HRLNOS exe file
#  /autoexec.nos         : HRLNOS setup file (this file)
#  /ftpusers             : with ftp user codes, passwords and directories
#                          see NOS_0618 manual by PA0GRI
#  /domain.txt           : with domain data (name to IP_addr translation)
# (/popusers)            : for pop mailbox access (see pop.doc)
# (/alias)               : for smtp mail aliasing (see bbs.doc)
#  /SPOOL
# (/SPOOL/rewrite)       : for smtp mail re-addressing (see bbs.doc)
# (/SPOOL/forward.bbs)   : for W0RLI-bbs forwarding (see bbs.doc)
# (/SPOOL/areas)         : with public mail areas in in (see bbs.doc)
#  /SPOOL/MQUEUE         : with outgoing mail in it
#  /SPOOL/MAIL           : with mail files in it
#  /SPOOL/HELP           : with 'host.hlp' as BBS welcome text;
#                          <bbs_command>.hlp (eg. area.hlp) for help in BBS
# (/SPOOL/SIGNATUR)      : with files username.sig containing mail signatures
# (/SPOOL/NEWS)          : for use by the NNTP client/server
# (/SPOOL/NEWS/JUNK)     : NNTP junk directory
# (/FINGER)              : with finger files (info), syntax <username.txt>
#
# don't forget to define a public FTP directory!
# 
# Files, directories between brackets are OBGLIGED to be present.
# ATTENTION! All of the directory structure can be configurated dynamically
# with the "set" command or by changing the respective DOS environment
# variables. An example as used by pa3eug:
set tmp=n:\temp
set userfile=n:\
set hostfile=n:\
set maillog=n:\spool
set mailspool=n:\spool\mail
set mailqdir=n:\spool\mqueue
set routeqdir=n:\spool\mqueue
set alias=n:\
set dfile=n:\
set fdir=n:\finger
set arealist=n:\spool
set helpdir=n:\spool\help
set rewritefile=n:\spool
set popusers=n:\
set axroutefile=n:\spool
set arproutefile=n:\spool
set tz=utc-1
set forwardfile=n:\spool
NEVER USE THE AUTOEXEC.HRL AS IT IS!!! FIRST SETUP YOUR PARAMETERS, CALL, ETC!
exit
#
#
# Here are the actual setup commands.
# This was meant to be installed:
# two slip links "sl0" and "sl2" at com1 and com2
# two links from a SCC-card using the PE1CHL driver to the transmitters
# Because I'm not quite common with SCC-cards, I copied the SCC-parameters
# from someone else. They could be incorrect because I couldn't check it!
# Sometimes, the order of commands doen't seem to be too logic. My appolo-
# gied for that, but that's because this file is compiled from my own auto-
# exec-file... I wrote the comments later...
#
# Here we go....
#
# First let's set the 'fix' parameters. These will NEVER change during the
# use of the program. After the attachment of the interfaces you CANNOT change
# hostname, AX25 call and ip address!
domain suffix ampr.org.
hostname pa3eug.ampr.org
ip address [44.137.24.31]
ax25 mycall pa3eug
#
# Now we can define several ports:
attach asy 0x3f8 4 slip sl0 5000 256 2400
attach asy 0x2f8 3 slip sl2 5000 256 2400
attach scc 2 init 150 4 2 0 1 168 2 p4915200
attach scc 0 ax25 144 256 d1200
attach scc 2 ax25 430 256 d1200
#
# If we'd have a KISS-tnc, the attach-commands would be like this:
# attach asy 0x3f8 4 ax25 144 5000 256 4800
# attach asy 0x2f8 3 ax25 430 5000 256 4800
# The first line defines a 4800 bps link to a KISS TNC with interface name 144
# at COM1, the second line does the same for a line named 430 at COM2.
# 16550A-controllers are recognized automatically. Always use the combination
# "0x3f8 4" for COM1 and "0x2f8 3" for COM2.
#
# Now we defined a "way out", we can start several servers. We don't start
# NET/ROM because we don't like it, and because it's not implemented to save
# memory!
start ftp
start telnet
start ttylink
start smtp
start finger
start ax25
start remote
start nntp
start rip
start discard
start echo
start pop
#
# standard, routing goes to the 144 interface, further pa3eug-a goes to sl0
# and pi8tcp to sl2.
# It is NOT necessary to add full routing tables, because if a station onesn
# has connected, the route to him will be remembered, on AX25-level and at
# L3 (route and arp-result). This is done by the WANMPES and tcp/ip
# autorouter.
# For this propose, MINIHRL makes the axroute.dat and arproute.dat files.
# Don't panic if they're not present the first time you run the software...
# ALWAYS USE THE "route addprivate" command instead of just "route add"!
# Private routings will be skipped by the RIP router, if you DON'T the RIP
# network will go crazy because of all routings you SAY you have...
# (route add default doesn't need to be private...)
route add default 144
route addp pa3eug-a.ampr.org sl0
route addp pi8tcp sl2
#
# Whenever a CALL is trying to be connected without mentioning the interface,
# and without having a AX25 ROUTE entry (manual/automatic!), the CALL is
# considered to be at the 144 interface:
ax25 route add default 144
#
# events will be logged by NOS:
log \spool\nos.log
#
# Accept mailbox third-party mail and mbox attended is set OFF.
# One cannot use the "c" command in the mailbox to call the operator.
third on
mb atte off
#
# kiss setup:
# syntax is "param <int> <param> <param> <param> <.....>"
# The first parameter may be a KISS command. Here's a list of KISS commands:
# 1 : TXdelay (n x 10 ms)
# 2 : p-Persistance (256/(n+1))
# 3 : Slottime (n x 10 ms) (intervaltime between two attempts to sent on an
#                           occupied channel)
# 4 : TXtail (n x 10 ms)
# 5 : full duplex on/off  (0=off; 1=on)
# 6 : TNC dependant parameter (e.g. at the DTNC1: param 144 6 37 : set
#                              TNC to 4800 baud output speed)
# 255 : end KISS-mode
param 144 1 6
param 144 2 50
param 144 3 6
param 144 4 2
param 144 5 0
param 430 1 10
param 430 2 50
param 430 3 6
param 430 4 2
param 430 5 0
#
# Now some general set up.
#
# TCP RETRY gives the number of attempts to start a connection before a time
# out is generated. Whenever the (tcp/ip) connection is established, the
# number of retries will be multiplied by 3.
tcp retry 15
#
# attribute changes the status line into color or monochrome. Just try out
# and see what happens....
attr mono
#
# Here's the AX25 ID (broadcast) text. bct = broadcast text and
# bci = broadcast interval
# parameter ax t3disc makes a AX25-connection to be terminated at T3 tick.
# When set to "on", at mailbox login the following tekst will be shown:
# "inactivity time-out xx min." te zien.
ax bct "HRLNOS - PA3EUG"
ax bci 300
ax t3d off
#
# Here's the nntp (network news transfer protocol, poort 119) setup.
# This stands for itself. We ask pi8hrl for NNTP data:
nntp add pi8hrl 900 *
nntp profile fullname "Ram"n Kolb PA3EUG [44.137.24.31]"
nntp profile organ "AMPRNET Netherlands SUBNET East Brabant"
nntp profile reply sysop@pa3eug.ampr.org
nntp profile sig /spool/signatur/sysop.sig
#
# Here's the smtp setup. Smtp timer will be well known. Smtp batch will put
# the HELO, MAIL FROM, RCPT TO and DATA lines in one packet.
smtp batch y
smtp ti 1800
#
# Now some stuff fot the mailbox. Mbox log logs every mailbox user to the
# file /spool/node.log; mbox mota sets the mailbox prompt. Mbox motd
# sets the mailbox message of the day.
mbox log y
mbox mota PA3EUG-HRLNOS v911211-2 <
mbox motd "Enter 'c' for a chat or '?' for a list of commands"
#
# Now set some remote control codes:
remote -s pa3eug
sysop 12345
# Here's the setup of the POP client:
# The mail is waiting at pi8hrl, and pi8hrl has (among others) in his
# /popusers file:
# py0yy:somebody:
# Pop mailhost sets pi8hrl as Post Office, and with mailbox the local mailfile
# is determined. Userdata makes the passwords go okay.
# (at pi8hrl the mailfile to be read is  /spool/mail/py0yy.txt)
pop mailhost pi8hrl
pop mailbox sysop
pop userdata py0yy somebody
#
# At last we make pi8hrl to be a domain server, and RIP routing goes to
# pi8hrl. After 5 minutes, we give up hope to reach the domain server...
dom ad pa3eug
dom tim 300
rip ad pa3eug 450
# This should be sufficient. Many mare things can be set up, but most of the
# parameters are okay of-their-own.
# Have a good luck, and send any questions/remarks to:
# ramon@blade.stack.urc.tue.nl OR pa3eug@pi8hrl.ampr.org OR
# PA3EUG @ ON4UBO.BLG.EU                                    ---73's, Ramon.
