PROJ = pmail
PROJFILE = pmail.mak
DEBUG = 0

PBTDEPEND  = $(PROJ).exe
PREP  = prep
PROFILE  = profile
PLIST  = plist
PROFSET  = set
PROFNMAKE  = nmake
PWBRMAKE  = pwbrmake
NMAKEBSC1  = set
NMAKEBSC2  = nmake
BRFLAGS  =  /o $(PROJ).bsc /Es /Iu
BROWSE	= 1
CC  = cl
CFLAGS_G  = /Alfw /W4 /G2 /D_MT /Zp /MT /BATCH /B2 c2l.exe /FR$*.sbr
CFLAGS_D  = /Gs /Gi$(PROJ).mdt /Zi /Od
CFLAGS_R  = /Ot /Ol /Og /Oe /Oi /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /STACK:8192 /NOI /BATCH
LFLAGS_D  = /CO /FAR /PACKC /PACKD /PMTYPE:PM
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:PM
LINKER	= link
ILINK  = ilink
LRF  = echo > NUL
RC  = rc
LLIBS_R  =  /NOD:LLIBCE LLIBCMT
LLIBS_D  =  /NOD:LLIBCE LLIBCMT

DEF_FILE  = pmail.def
OBJS  = pmail.obj main.obj GETOPT.obj BMUTIL.obj HEADER.obj pc.obj SEND.obj\
	FILES.obj
RESS  = pmail.res
SBRS  = pmail.sbr main.sbr GETOPT.sbr BMUTIL.sbr HEADER.sbr pc.sbr SEND.sbr\
	FILES.sbr

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .sbr .res .c .rc

pmail.obj : pmail.c pmail.h pmaildlg.h bm.h pmail.d

pmail.sbr : pmail.c pmail.h pmaildlg.h bm.h pmail.d

pmail.res : pmail.rc pmail.h pmaildlg.h pmail.dlg

main.obj : main.c bm.h pmail.h pmaildlg.h pmail.d

main.sbr : main.c bm.h pmail.h pmaildlg.h pmail.d

GETOPT.obj : GETOPT.C

GETOPT.sbr : GETOPT.C

BMUTIL.obj : BMUTIL.C bm.h header.h pmail.h pmaildlg.h pmail.d

BMUTIL.sbr : BMUTIL.C bm.h header.h pmail.h pmaildlg.h pmail.d

HEADER.obj : HEADER.C bm.h header.h pmail.d

HEADER.sbr : HEADER.C bm.h header.h pmail.d

pc.obj : pc.c

pc.sbr : pc.c

SEND.obj : SEND.C bm.h pmail.d

SEND.sbr : SEND.C bm.h pmail.d

FILES.obj : FILES.C

FILES.sbr : FILES.C


$(PROJ).pbt : 
	$(PROFSET) MAKEFLAGS=
	$(PROFNMAKE) $(NMFLAGS) -f $(PROJFILE) $(PBTDEPEND)
	$(PREP) /P $(PBTDEPEND) /OT $(PROJ).pbt

$(PROJ).bsc : $(SBRS)
	$(PWBRMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).exe : $(DEF_FILE) $(OBJS) $(RESS)
!IF $(DEBUG)
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
	$(LINKER) @$(PROJ).lrf
	$(RC) $(RESS) $@
	$(NMAKEBSC1) MAKEFLAGS=
	$(NMAKEBSC2) $(NMFLAGS) -f $(PROJFILE) $(PROJ).bsc


.c.obj :
!IF $(DEBUG)
	$(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
	$(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF

.c.sbr :
!IF $(DEBUG)
	$(CC) /Zs $(CFLAGS_G) $(CFLAGS_D) /FR$@ $<
!ELSE
	$(CC) /Zs $(CFLAGS_G) $(CFLAGS_R) /FR$@ $<
!ENDIF

.rc.res :
	$(RC) /r $< $@


run: $(PROJ).exe
	$(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
	CVP $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
